/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2013, 2014. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.rational.datacollection.web.ui.internal.dialogs.AddResourceGroupDialog"); //$NON-NLS-1$
dojo.require("dijit._Widget"); //$NON-NLS-1$
dojo.require("dijit._Templated"); //$NON-NLS-1$
dojo.require("dojox.xml.parser"); //$NON-NLS-1$
dojo.require("dojo.io.iframe"); //$NON-NLS-1$
dojo.require("dijit.ProgressBar"); //$NON-NLS-1$
dojo.require("dojox.uuid"); //$NON-NLS-1$
dojo.require("dojox.uuid.generateTimeBasedUuid"); //$NON-NLS-1$
dojo.require("jazz.ui.Dialog");//$NON-NLS-1$
dojo.require("jazz.app.ua.TextHoverHelp"); //$NON-NLS-1$
dojo.require("com.ibm.rational.datacollection.web.ui.internal.common.DataCollectionClient"); //$NON-NLS-1$
dojo.require("com.ibm.rational.datacollection.web.ui.internal.common.DataCollectionConstants"); //$NON-NLS-1$
dojo.require("com.ibm.rational.datacollection.web.ui.internal.common.ResourceHelper");//$NON-NLS-1$
dojo.requireLocalization("com.ibm.rational.datacollection.web.ui.internal.dialogs", "AddResourceGroupDialogMessages");//$NON-NLS-1$//$NON-NLS-2$

(function() {
	
var _okButton_onclick_handle;
var _WIDTH_IN_EM = 80;
var DataCollectionClient = com.ibm.rational.datacollection.web.ui.internal.common.DataCollectionClient;
var DataCollectionConstants = com.ibm.rational.datacollection.web.ui.internal.common.DataCollectionConstants;
var ResourceHelper = com.ibm.rational.datacollection.web.ui.internal.common.ResourceHelper;	
var TextHoverHelp = jazz.app.ua.TextHoverHelp;

dojo.declare("com.ibm.rational.datacollection.web.ui.internal.dialogs.AddResourceGroupDialog", [dijit._Widget, dijit._Templated], { //$NON-NLS-1$
	templatePath: dojo.moduleUrl("com.ibm.rational.datacollection.web", "ui/internal/dialogs/templates/AddResourceGroupDialog.html"),//$NON-NLS-1$ //$NON-NLS-2$ 
	widgetsInTemplate: true,
	configureResourceGroupPage: null,
	
	constructor: function(args) {
		if (!args) {
			args = {};
		}
		
		this.width = _WIDTH_IN_EM + "em"; //$NON-NLS-1$
		this.uploadId = null;
		this.intervalId = null;
		var properties = {
			"width": this.width //$NON-NLS-1$
		};
		this.messages = dojo.i18n.getLocalization("com.ibm.rational.datacollection.web.ui.internal.dialogs", "AddResourceGroupDialogMessages");//$NON-NLS-1$ //$NON-NLS-2$
	},
	
	postCreate: function() {
		this.dialog = new jazz.ui.Dialog({
			contentNode: this.contentNode,
			primaryTitle: this.messages.AddResourceGroupDialog_2,
			width: this.width,
			destroyContents: true
		});
		this._topText.innerHTML = this.messages.AddResourceGroupDialog_1;
		this._createTable();
		
		this.connect(this.externalJTS, "onchange", dojo.hitch(this, function(e) { //$NON-NLS-1$
			this.appTable.clearBody();
			if (this.externalJTS.checked) {
				this.jtsArea.style.display = ""; //$NON-NLS-1$
			} else {
				this.jtsArea.style.display = "none"; //$NON-NLS-1$
				this._initializeContent();
			}
		}));
		
		this.connect(this.jtsRoot, "onkeyup", dojo.hitch(this, function(e) { //$NON-NLS-1$
			this._checkDiscoverButton();
		}));
		this.connect(this.discoverButton, "onclick", "onDiscover");  //$NON-NLS-1$ //$NON-NLS-2$ 
		this.connect(this.cancelButton, "onclick", "onCancel");  //$NON-NLS-1$ //$NON-NLS-2$ 
		this.connect(this.closeButton, "onclick", "onClose");  //$NON-NLS-1$ //$NON-NLS-2$ 
		this._okButton_onclick_handle = this.connect(this.okButton, "onclick", "_onOk"); //$NON-NLS-1$ //$NON-NLS-2$
		
		this._initializeContent();
	},
	
	_initializeContent: function (param) {
		this._setStatusMessage(this.messages.AddResourceGroupDialog_4);
		this._showProgressBar(true);
		var data = param ? param : {};
		DataCollectionClient.getRegisteredApplications({
			data: data,
			load: dojo.hitch(this, function(data, ioArgs) {
				this.items = [];
				for (var i = 0; i < data.length; i++) {
					if (data[i].identifier === DataCollectionConstants.APPID_JTS || data[i].identifier === DataCollectionConstants.APPID_CCM || data[i].identifier === DataCollectionConstants.APPID_QM || data[i].identifier === DataCollectionConstants.APPID_RM) {
						this.items.push(data[i]);
						var resourceGroupList = this.configureResourceGroupPage.workingCopy.resourceGroupList;
						var identifier = data[i].identifier;
						var baseURL = data[i].baseURL;
						if (this._hasResourceGroup(resourceGroupList, baseURL)) {
							data[i].disabled = true;
						}
						this.addRow(data[i]);
					}
				}

				this.onLoadingComplete();
			}),
			error: dojo.hitch(this, function(error, ioArgs) {
				this._clearStatusMessage();
				var message = error.responseText ? error.responseText : error.message;
				this._setStatusMessage(message, true);
			})
		})
	},
	
	_getBaseResourceGroup: function (baseResourceGroupMap, identifier) {
		for (var uri in baseResourceGroupMap) {
			if (baseResourceGroupMap[uri]["dcterms:identifier"] === identifier) { //$NON-NLS-1$
				return baseResourceGroupMap[uri];
			}
		}
		return null;
	},
	
	_hasResourceGroup: function (resourceGroupList, baseURL) {
		for (var i = 0; i < resourceGroupList.length; i++) {
			if (resourceGroupList[i].status === DataCollectionConstants.STATUS_DELETE || resourceGroupList[i].status === DataCollectionConstants.STATUS_IGNORE) {
				continue;
			}
			var url = ResourceHelper.getBaseURL(resourceGroupList[i].data);
			if (url === baseURL) {
				return true;
			}
		}
		
		return false;
	},
	
	onLoadingComplete: function () {
		this._clearStatusMessage();
	},
	
	_createTable: function() {
		this.appTable = new jazz.ui.StyledTable({
			columns : [ {
				label : "", //$NON-NLS-1$
				sortable : false,
				width : "5%" //$NON-NLS-1$
			}, {
				label : this.messages.AddResourceGroupDialog_7,
				sortable : false,
				width : "25%" //$NON-NLS-1$
			}, {
				label : this.messages.AddResourceGroupDialog_5,
				sortable : false,
				width : "40%" //$NON-NLS-1$
			}, {
				label : this.messages.AddResourceGroupDialog_6,
				sortable : false,
				width : "30%" //$NON-NLS-1$
			} ],
			sortBy : 3,
			sortByAscending : false,
			handleSort : function() {
			},
			trim : jazz.ui.styledTable.TrimStyles.BLUE
		});
		
		this.appTable.domNode.style.width = "100%"; //$NON-NLS-1$
		this.contentArea.appendChild(this.appTable.domNode);
	},
	
	addRow: function(item) {
		var row, enabled, instanceName, baseURL, appType;
		var _self = this;
		row = document.createElement("tr"); //$NON-NLS-1$

		enabled = document.createElement("td"); //$NON-NLS-1$
		instanceName = document.createElement("td"); //$NON-NLS-1$
		appType = document.createElement("td"); //$NON-NLS-1$
		baseURL = document.createElement("td"); //$NON-NLS-1$

		dojo.addClass(enabled, "center-column"); //$NON-NLS-1$
		var enabledInput = document.createElement("input"); //$NON-NLS-1$
		enabledInput.type = "checkbox"; //$NON-NLS-1$
		enabled.appendChild(enabledInput);
		enabledInput.checked = (item["disabled"] === true); //$NON-NLS-1$
		enabledInput.item = item;
		enabledInput.disabled = (item["disabled"] === true); //$NON-NLS-1$
		dojo.connect(enabledInput, "onclick", this, function(e) { //$NON-NLS-1$
			var target = this._getCurrentTarget(e);
			target.item.checked = target.checked;
			this.setChange();
		});

		instanceName.innerHTML = item["instanceName"]; //$NON-NLS-1$
		
		var titleSpan = document.createElement("span"); //$NON-NLS-1$
		titleSpan.innerHTML = item["title"]; //$NON-NLS-1$
		new TextHoverHelp({
			helpContentString: item["description"], //$NON-NLS-1$
			contentNode: titleSpan
		});
		appType.appendChild(titleSpan);
		
		baseURL.innerHTML = item["baseURL"]; //$NON-NLS-1$
		
		row.appendChild(enabled);
		row.appendChild(instanceName);
		row.appendChild(appType);
		row.appendChild(baseURL);
		
		this.appTable.tbody.appendChild(row);
	},
	
	_onOk: function(e) {
		if (e) {
			dojo.stopEvent(e);
		}
		
		for (var i = 0; i < this.items.length; i++) {
			if (this.items[i].checked) {
				var workingCopy = this.configureResourceGroupPage.workingCopy;
				var baseResourceGroupMap = workingCopy.baseResourceGroupMap;
				var identifier = this.items[i].identifier;
				var baseResourceGroup = this._getBaseResourceGroup(baseResourceGroupMap, identifier);
				var item = workingCopy.createResourceGroup(baseResourceGroup.uri, this.items[i].baseURL);
				var section = this.configureResourceGroupPage.getBaseResourceGroupSection(baseResourceGroup.uri);
				section.addItem(item);
			}
		}
		this.okButton.disabled = true;
		this.dialog.close();
	},
	
	onCancel: function(e) {
		dojo.stopEvent(e);
		this.dialog.close();
	},
	
	onDiscover: function(e) {
		this.appTable.clearBody();
		var data = {
			jtsRoot: this.jtsRoot.value,
		}
		this._initializeContent(data);
	},
		
	onClose: function(e) {
		dojo.stopEvent(e);
		this.dialog.close();
	},
	
	_getCurrentTarget : function(e) {
		if (dojo.isIE) {
			return window.event.srcElement;
		}
		if (e) {
			return e.currentTarget;
		}
		return undefined;
	},
	
	_handleLoad: function(response, ioArgs) {
	},
	
	_formatSummary: function(msg) {
		var lines = msg.split("\n"); //$NON-NLS-1$
		var summary = ""; //$NON-NLS-1$
		for (var i = 0; i < lines.length; i++) {
			summary = summary + lines[i] + "<br>"; //$NON-NLS-1$
		}
		return summary;
	},
	
	onSuccess: function(json) {
		this.okButton.style.display = "none"; //$NON-NLS-1$
		this.cancelButton.style.display = "none"; //$NON-NLS-1$
		this.closeButton.style.display = ""; //$NON-NLS-1$
		this.closeButton.innerHTML = this.messages.AddResourceGroupDialog_17;
	},
	
	_clearStatusMessage: function() {
		this.status.style.visibility = "hidden";//$NON-NLS-1$
		this._progress.domNode.style.display = "none"; //$NON-NLS-1$
	},
	
	_setStatusMessage: function(msg, isError) {
		this.status.style.visibility = "visible";//$NON-NLS-1$
		dojox.xml.parser.replaceChildren(this.status, document.createTextNode(msg));
		this.status.className = isError ? "ErrorStatus" : "NormalStatus";//$NON-NLS-1$ //$NON-NLS-2$
	},
	
	_showProgressBar: function(indeterminate) {
		this._progress.update({
			indeterminate: indeterminate
		});
		this._progress.domNode.style.display = "block";//$NON-NLS-1$
	},
	
	_checkDiscoverButton: function() {
		if (this.jtsRoot.value) {
			this.discoverButton.disabled = false;
		} else {
			this.discoverButton.disabled = true;
		}
	},
	
	setChange: function() {
		var changed = false;
		for (var i = 0; i < this.items.length; i++) {
			if (this.items[i].checked) {
				changed = true;
				break;
			}
		}
		this.okButton.disabled = !changed;
	},
	
	uninitialize: function() {
		this.inherited(arguments);
	}
});
})();
