/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2013. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
dojo.provide("com.ibm.rational.datacollection.web.ui.internal.editors.AbstractEditor"); //$NON-NLS-1$

dojo.require("dijit._Widget"); //$NON-NLS-1$
dojo.require("dijit._Templated"); //$NON-NLS-1$
dojo.require("jazz.ui.MessageBox"); //$NON-NLS-1$

(function() {
	
var MessageBox = jazz.ui.MessageBox;

dojo.declare("com.ibm.rational.datacollection.web.ui.internal.editors.AbstractEditor", [dijit._Widget, dijit._Templated], { //$NON-NLS-1$
	postCreate: function () {
		this.header = new MessageBox();
		this.headerArea.appendChild(this.header.domNode);
	},
	
	displayDetailedErrorMessage: function (summary, errorObj) {
		errorObj.message = errorObj.responseText ? errorObj.responseText : errorObj.message;
		this.header.showMessage({
			type: MessageBox.STATUS_TYPES.ERROR,
			summary: summary,
			errorObject: errorObj
		});		
	},
	
	displayErrorMessage: function (message) {
		this.displayMessage(message, MessageBox.STATUS_TYPES.ERROR);
	},
	
	displaySuccessMessage: function (message) {
		this.displayMessage(message, MessageBox.STATUS_TYPES.OK);
	},
	
	displayInfoMessage: function (message) {
		this.displayMessage(message, MessageBox.STATUS_TYPES.INFO);
	},
	
	displayMessage: function(message, messageType) {
		if (this.header) {
			var status = {
				type: messageType,
				summary: message
			};
			this.header.showMessage(status);
		}
	},
	
	hideMessage: function(message, messageType) {
		this.header.hideMessage();
	},
	
	_getCurrentTarget : function(e) {
		if (dojo.isIE) {
			return window.event.srcElement;
		}
		if (e) {
			return e.currentTarget;
		}
		return undefined;
	},
	
	uninitialize: function() {
		this.header.destroyRecursive();
	}
});

})();