/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2013. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
dojo.provide("com.ibm.rational.datacollection.web.ui.internal.editors.StringSelectProperty"); //$NON-NLS-1$

dojo.require("dijit._Widget"); //$NON-NLS-1$
dojo.require("dijit._Templated"); //$NON-NLS-1$
dojo.require("jazz.ui.MessageBox"); //$NON-NLS-1$
dojo.require("com.ibm.rational.datacollection.web.ui.internal.editors.AbstractProperty"); //$NON-NLS-1$
dojo.require("dojo.i18n"); //$NON-NLS-1$
dojo.require("jazz.app.ua.TextHoverHelp"); //$NON-NLS-1$

dojo.requireLocalization("com.ibm.rational.datacollection.web.ui.internal.editors", "StringPropertyMessages"); //$NON-NLS-1$ //$NON-NLS-2$

(function() {

var MessageBox = jazz.ui.MessageBox;
var AbstractProperty = com.ibm.rational.datacollection.web.ui.internal.editors.AbstractProperty;
var TextHoverHelp = jazz.app.ua.TextHoverHelp;

dojo.declare("com.ibm.rational.datacollection.web.ui.internal.editors.StringSelectProperty", [AbstractProperty], { //$NON-NLS-1$

	templatePath: dojo.moduleUrl("com.ibm.rational.datacollection.web", "ui/internal/editors/templates/StringSelectProperty.html"), //$NON-NLS-2$ //$NON-NLS-1$
	key: "", //$NON-NLS-1$
	value: "", //$NON-NLS-1$
	name: "", //$NON-NLS-1$
	defaultValue: "", //$NON-NLS-1$
	textHoverHelp: "", //$NON-NLS-1$
	readonly: false,
	// widget initialization
	
	constructor: function() {
		this._errIconScr = dojo.moduleUrl("com.ibm.rational.datacollection.web", "graphics/icons/inline-error.gif"); //$NON-NLS-2$ //$NON-NLS-1$
		this.messages = dojo.i18n.getLocalization("com.ibm.rational.datacollection.web.ui.internal.editors", "StringPropertyMessages"); //$NON-NLS-2$ //$NON-NLS-1$
		this.options = [];
	},

	postCreate: function () {
		this.connect(this.editValue, "onchange", function(e) { //$NON-NLS-1$
			this.value = this.editValue.value;
			
			this.viewValue.innerHTML = this.editValue.value;
			
			this.onChange(this.value);
		});
		
		this._initializeContent();
	},

	_initializeContent: function () {
		for(var i=0;i<this.options.length;i++){
			var newOption = new Option(this.options[i].name, this.options[i].value);
			this.editValue.options[i] = newOption;
		}
		
		this.editValue.value = this.value;
		
		this.viewValue.innerHTML = this.value;

		this.prepareTextHoverHelp();
	},
	
	prepareTextHoverHelp: function (){
		if(this.textHoverHelp){
			new TextHoverHelp({
				helpContentString: this.textHoverHelp,
				contentNode: this._propertyName
			}); 
		}
	},
	
	toggleEditMode: function (edit) {
		if (edit && !this.readonly) {
			dojo.style(this.editValue, "display", ""); //$NON-NLS-1$  //$NON-NLS-2$
			dojo.style(this.viewValue, "display", "none"); //$NON-NLS-1$  //$NON-NLS-2$
		} else {
			dojo.style(this.editValue, "display", "none"); //$NON-NLS-1$  //$NON-NLS-2$
			dojo.style(this.viewValue, "display", ""); //$NON-NLS-1$  //$NON-NLS-2$
		}
		
	},
	
	onChange: function (value) {
	},
	
	uninitialize: function(){
		this.inherited(arguments);
	}
});

})();