/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007, 2015. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("com.ibm.rdm.web.project.ResultSetGridView");

dojo.require("dijit._Templated");
dojo.require("dijit._Widget");
dojo.require("dijit.layout.ContentPane");
dojo.require("com.ibm.rdm.web.common.MimeTypes");
dojo.require("dojo.date.locale");
dojo.require("com.ibm.rdm.web.common.ResourceLinksHandler");
dojo.require("com.ibm.rdm.web.common.DateTimeHelper");
dojo.require("dojo.i18n");
dojo.require("com.ibm.rdm.web.common.ProjectCache");
dojo.require("com.ibm.rdm.web.util.domutils");
dojo.require("com.ibm.rdm.web.server.client.RecentFeedsClient");
dojo.require("com.ibm.rdm.web.common.dnd.BumpScroller");
dojo.require("com.ibm.rdm.web.common.ErrorHandler");
dojo.require("com.ibm.rdm.web.common.StatusDisplay");
dojo.require("com.ibm.rdm.web.grid.Grid");
dojo.require("com.ibm.rdm.web.grid.Operation");
dojo.require("com.ibm.rdm.web.project.DashboardConstants");
dojo.require("com.ibm.rdm.web.project.RelationManager");
dojo.require("com.ibm.rdm.web.notifications.ChangeNotifier");
dojo.require("com.ibm.rdm.web.commenting.EventTopics");
dojo.require("com.ibm.rdm.web.common.UpdateContext");
dojo.require("com.ibm.rdm.web.project.RenameArtifactForm");
dojo.require("com.ibm.rdm.web.review.reviewutils");
dojo.require("com.ibm.rdm.web.links.LinkTypeUtils");
dojo.require("com.ibm.rdm.web.links.linkutils");
dojo.require("com.ibm.rdm.web.model.resources.ResourceManager");
dojo.require("com.ibm.rdm.web.model.types.RRMTypes");
dojo.require("com.ibm.rdm.web.query.ViewServiceClient");
dojo.require("com.ibm.rdm.web.project.EditManager");
dojo.require("com.ibm.rdm.web.picker.ArtifactPickerForm");
dojo.require("com.ibm.rdm.web.project.LinkExpansionDialog");
dojo.require("com.ibm.rdm.web.project.AutoExpansionManager");
dojo.require("com.ibm.rdm.web.project.AddColumnDialog");
dojo.require("com.ibm.rdm.web.artifactgrid.ArtifactCommands");
dojo.require("com.ibm.rdm.web.artifactgrid.ArtifactDataCache");
dojo.require("com.ibm.rdm.web.artifactgrid.ArtifactTypeCache");
dojo.require("com.ibm.rdm.web.artifactgrid.ArtifactEdit");
dojo.require("com.ibm.rdm.web.artifactgrid.ArtifactDisplay");
dojo.require("com.ibm.rdm.web.artifactgrid.ArtifactLinks");
dojo.require("com.ibm.rdm.web.artifactgrid.ArtifactGroup");
dojo.require("com.ibm.rdm.web.artifactgrid.ArtifactConstants");
dojo.require("com.ibm.rdm.web.grid.PageModel");
dojo.require("com.ibm.rdm.web.common.MessageHandler");
dojo.require("com.ibm.rdm.web.util.queryutils");
dojo.require("com.ibm.rdm.web.common.MessageForm");
dojo.require("com.ibm.rdm.web.server.client.utils.UserCache");
dojo.require("com.ibm.rdm.web.editor.editorutils");
dojo.require("com.ibm.rdm.web.artifactgrid.ArtifactPermissionsCache");
dojo.require("com.ibm.rdm.web.snapshots.ModuleSnapshotServer");
dojo.require("com.ibm.rdm.web.suspicion.model.types");
dojo.require("com.ibm.rdm.web.locks.LockManager");
dojo.require("com.ibm.rdm.web.server.client.utils.LinkUtils");
dojo.require("com.ibm.rdm.web.suspicion.SuspectLinksUtil");
dojo.require("com.ibm.rdm.web.artifactgrid.ModuleArtifactCommands");
dojo.require("com.ibm.rdm.web.common.AutomaticPopupHelpManager");
dojo.require("com.ibm.rdm.web.preferences.UserPreferenceNames");

dojo.requireLocalization("com.ibm.rdm.web.project", "ResultSetGridView");
dojo.requireLocalization("com.ibm.rdm.web.artifactgrid", "ArtifactCommands");

var ArtifactConstants = com.ibm.rdm.web.artifactgrid.ArtifactConstants;
var ArtifactGroup = com.ibm.rdm.web.artifactgrid.ArtifactGroup;
var ErrorHandler = com.ibm.rdm.web.common.ErrorHandler;
var StatusDisplay = com.ibm.rdm.web.common.StatusDisplay;
var ResourceLinksHandler = com.ibm.rdm.web.common.ResourceLinksHandler;
var DateTimeHelper = com.ibm.rdm.web.common.DateTimeHelper;
var ProjectCache = com.ibm.rdm.web.common.ProjectCache;
var RecentFeedsClient = com.ibm.rdm.web.server.client.RecentFeedsClient;
var ChangeNotifier = com.ibm.rdm.web.notifications.ChangeNotifier;
var DomUtils = com.ibm.rdm.web.util.domutils;
var LinkTypeUtils = com.ibm.rdm.web.links.LinkTypeUtils;
var linkutils = com.ibm.rdm.web.links.linkutils;
var LinkUtils = com.ibm.rdm.web.server.client.utils.LinkUtils;
var ResourceManager = com.ibm.rdm.web.model.resources.ResourceManager;
var RRMTypes = com.ibm.rdm.web.model.types.RRMTypes;
var ViewServiceClient = com.ibm.rdm.web.query.ViewServiceClient;
var EditManager = com.ibm.rdm.web.project.EditManager;
var LinkExpansionDialog = com.ibm.rdm.web.project.LinkExpansionDialog;
var MessageHandler = com.ibm.rdm.web.common.MessageHandler;
var queryutils = com.ibm.rdm.web.util.queryutils;
var UserCache = com.ibm.rdm.web.server.client.utils.UserCache;
var editorutils = com.ibm.rdm.web.editor.editorutils;
var LockManager = com.ibm.rdm.web.locks.LockManager;
var SuspectLinksUtil = com.ibm.rdm.web.suspicion.SuspectLinksUtil;

var PlatformUI = net.jazz.ajax.ui.PlatformUI;

var COMMENT_HIGHLIGHT_EXPIRATION_HRS = 48; //Do not hightlight comments older than limit set here (in hours)

var MAXURLSizeInColumn = 25;
//Rowtype for a row built from resource info records.
var RESOURCE_ROW = com.ibm.rdm.web.artifactgrid.ArtifactConstants.RESOURCE_ROW;

var FIND_SELECT_CSS_CLASS = "rdmFindSelect";
var FIND_MARK_CSS_CLASS = "rdmFindMark";
var REPLACE_MARK_CSS_CLASS = "rdmReplaceMark";

// Please note that we're explicitly using a "var" for this 'automaticPopupHelpManager'
// rather than a class field.  This is due to the fact that we want the user to be
// exposed to the auto help 3 times _regardless_ of which modules he/she makes
// use of when "editing rows".
var automaticPopupHelpManager = null;


dojo.declare(
		"com.ibm.rdm.web.project.ResultSetGridView",
		[dijit._Widget, dijit._Templated],
{
	templatePath: dojo.moduleUrl("com.ibm.rdm.web", "project/templates/ResultSetGridView.html"),
	widgetsInTemplate: true,

	projectURI: null,
	resourceURI: null,
	baselineURI: null,
	dashboardTabPage: null,
	
	//////////////////////////////////////////
	// References to other 'Requirement' components
	
	//ArtifactDataCache - for the storage of the data model
	dataCache: null,
	//ArtifactTypeCache - for the storage of the type model
	typeCache: null,
	//ArtifactCommands - configures and defines the basic menu operations
	commands: null,
	//ArtifactDisplay - for the details of how to display requirement data
	display: null,

	// getModuleArtifactTypeURI: Function
	//		Get the artifact type URI associated with the currently opened module.
	getModuleArtifactTypeURI: null,

	///////////////////////////////////////////////////////////////////////////////////
	// template Bindings
	_resultSetGridView: null,

	///////////////////////////////////////////////////////////////////////////////////
	// Private Fields
	_messages: null,
	_artifactCommandsMessages: null,

	// _viewType: String
	//		Must be set to one of the values found in com.ibm.rdm.web.project.DashboardConstants.VIEW_TYPES.
	_viewType: null,

	_isInHistoryMode: false,
	_isInReviewMode: false,
	_groupOrder: null,
	_contentPane: null,
	_contentPaneSize: null,
	_pageToDisplay: null,
	_pageOffsets: {},
	_projectOperations: null,
	
	_isTypeSystemLoaded: false,
	
	_arrayListOfRecentArtifacts: null,
	_arrayListOfNewlyCreatedArtifacts: [],
	_isRecentArtifactsHighlighted: null,
	_isRecentCommentedHighlighted: null,
	_showBaseProperties: null,
	// _isMessageDisplayed: Boolean
	//		Set to true only when the this._messages.loadingArtifactsMessage or
	//		this._messages.filterNeededMessage is being displayed.
	_isMessageDisplayed: null,
	
	_drillDownEnabled: false,
	
	_puiOnBeforeUnloadHandle: null,
	_puiBodyClickHandle: null,
	
	_replaceResource: null,

	_pageHoverHelp: null,
	
	_idColumnWidth: null,

	_headerCellTableDataNodes: null,
	
	// WI 71307 keeps track of how many artifacts are created/deleted to correctly
	// display the total number of artifacts without page refresh
	_artifactCountAdjuster: 0,

	_listeners: null,



	postMixInProperties: function() {
		this._messages =
			dojo.i18n.getLocalization("com.ibm.rdm.web.project", "ResultSetGridView");
		this._artifactCommandsMessages =
			dojo.i18n.getLocalization("com.ibm.rdm.web.artifactgrid", "ArtifactCommands");
	},

	postCreate: function() {
		this._listeners = [];
		var pageHoverHelp;
		if (this._viewType === com.ibm.rdm.web.project.DashboardConstants.VIEW_TYPES.COLLECTIONS) {
			this.headerNodes.headerTitleSpan.innerHTML = this._messages["viewTypeCollectionsHeaderMsg"];
			pageHoverHelp =
				new jazz.app.ua.PageHoverHelp(
					{uaKey: com.ibm.rdm.web.help.context.collectHome}
				);
			this.headerNodes.hoverSpan.appendChild(pageHoverHelp.domNode);
		} else if (this._viewType === com.ibm.rdm.web.project.DashboardConstants.VIEW_TYPES.MODULES) {
			this.headerNodes.headerTitleSpan.innerHTML = this._messages["viewTypeModulesHeaderMsg"];
			pageHoverHelp =
				new jazz.app.ua.PageHoverHelp(
					{uaKey: com.ibm.rdm.web.help.context.viewModules}
				);
			this.headerNodes.hoverSpan.appendChild(pageHoverHelp.domNode);
		} else if (this._viewType === com.ibm.rdm.web.project.DashboardConstants.VIEW_TYPES.ARTIFACTS) {
			this.headerNodes.headerTitleSpan.innerHTML = this._messages["viewTypeArtifactsHeaderMsg"];
			pageHoverHelp =
				new jazz.app.ua.PageHoverHelp(
					{uaKey: com.ibm.rdm.web.help.context.project}
				);
			this.headerNodes.hoverSpan.appendChild(pageHoverHelp.domNode);
		}
		this._pageHoverHelp = pageHoverHelp;
		
		//Management of Permissions
		this.permissionsCache = new com.ibm.rdm.web.artifactgrid.ArtifactPermissionsCache();
		
		//Arguments for Creating the Grid
		var gridArgs = {
			onHidePagingWidget: this.onHidePagingWidget,
			onShowPagingWidget: this.onShowPagingWidget
		};
		
		//Make sure the grid checks permissions are in place before drawing anything.
		gridArgs.preDisplayCallbackFunction = dojo.hitch(this.permissionsCache, this.permissionsCache.ensureSynchronous);

		// Avoid issues with respect to "Showing N of M Artifacts" being positioned off
		// the screen (as we're using "paging-widget-hidden/paging-widget-visible" CSS
		// rules in DashboardTabPage.css to make sure that the grid's view header
		// doesn't change its Y position whenever the pager appears or disappears).
		gridArgs.accountForPagingWidgetWhenResettingHeight = false;
		
		if (this.dragDropArgs && this.dragDropArgs.dragSource) {
			gridArgs.enableDrag = true;
			gridArgs.dragDropArgs = this.dragDropArgs; 
		}
		
		if (this._viewType === com.ibm.rdm.web.project.DashboardConstants.VIEW_TYPES.MODULE) {
			gridArgs.virtualScrolling = true;
			gridArgs.fisheye = true;
			gridArgs.pageModel = new com.ibm.rdm.web.grid.PageModel({
				structure: this.moduleStructure
			});
			gridArgs.showWithFindButton = true;
			gridArgs.onFind = dojo.hitch(this, function(findNode){
				this.projectButtonAndMenuActions.executeFind(findNode);
			});
		}

		gridArgs.onNodeFocused = dojo.hitch(this, this._onGridNodeFocused);

		this.grid = new com.ibm.rdm.web.grid.Grid(gridArgs, this.gridDiv);
		this.connect(this.grid, "requestOrReconcileArtifacts", this.requestOrReconcileArtifacts);
		this.connect(this.grid, "requestArtifacts", this.requestArtifacts);
		this.connect(this.grid, "releaseArtifacts", this._releaseArtifacts);
		this.connect(this.grid, "refreshArtifacts", this.refreshArtifacts);
		this.connect(this.grid.header, "reapplyGridDialogData",
				this._applyTraceAttributes);
		
		//This defines all the subcomponents for dealing with requirements
		this.typeCache = new com.ibm.rdm.web.artifactgrid.ArtifactTypeCache();
		
		this.permissionsCache.setContext({
			projectURI: this.projectURI,
			typeCache: this.typeCache
		});
		
		this.dataCache = new com.ibm.rdm.web.artifactgrid.ArtifactDataCache({
			permissionsCache: this.permissionsCache
		});
		
		if (this.grid.virtualScrolling) {
			this.dataCache.enableSecondaryCache();
		}

		var commentingInterface = {
			addMemberCommentCallback: dojo.hitch(this, function(resourceURI, baseURI) {
				// summary:
				//		Opens a dialog to have the user add a comment.
				// returns:
				//		A deferred whose callback is called when the dialog is closed.
				var onCloseDeferred = new dojo.Deferred();
				var onCloseCallback = function(){
					onCloseDeferred.callback();
				};
				this.goTo(resourceURI, true, true);
				this.dashboardTabPage.resourceViewer.getArtifactCommentsSidebar().addMemberComment(resourceURI, baseURI, this._showBaseProperties, onCloseCallback);
				return onCloseDeferred;
			}),
			showMemberCommentsCallback: dojo.hitch(this, function(resourceURI, baseURI) {
				var resourceInfos = [];
				resourceInfos.push({
					resourceURI: resourceURI,
					baseURI: baseURI
				});
				this.goTo(resourceURI, true, true);
				this.dashboardTabPage.resourceViewer.getArtifactCommentsSidebar().showMemberComments(resourceInfos, this._showBaseProperties);
			})
		};
				
		if (this._viewType === com.ibm.rdm.web.project.DashboardConstants.VIEW_TYPES.MODULE) {
			this.commands = new com.ibm.rdm.web.artifactgrid.ModuleArtifactCommands({
				projectURI: this.projectURI,
				baselineURI: this.baselineURI,
				dataCache: this.dataCache,
				typeCache: this.typeCache,
				permissionsCache: this.permissionsCache,
				onTypeSystemReady: dojo.hitch(this, this._addTypeSystemDeferredFunction),
				viewType: this._viewType,
				isInHistoryMode: this._isInHistoryMode,
				isInReviewMode: this._isInReviewMode,
				grid: this.grid,
				moduleStructure: this.moduleStructure
			});
		} else {
			//When in a Module, base properties are displayed by toggling the "Show Base Properties" button.
			//Force the base properties to be displayed in views other than Modules.
			this._showBaseProperties = true;
			this.commands = new com.ibm.rdm.web.artifactgrid.ArtifactCommands({
				projectURI: this.projectURI,
				baselineURI: this.baselineURI,
				dataCache: this.dataCache,
				typeCache: this.typeCache,
				permissionsCache: this.permissionsCache,
				viewType: this._viewType,
				isInHistoryMode: this._isInHistoryMode,
				isInReviewMode: this._isInReviewMode,
				grid: this.grid
			});
		}
		
		this.display = new com.ibm.rdm.web.artifactgrid.ArtifactDisplay({
			projectURI: this.projectURI,
			baselineURI: this.baselineURI,
			typeSystemReady: dojo.hitch(this, this._addTypeSystemDeferredFunction),
			dataCache: this.dataCache,
			typeCache: this.typeCache,
			permissionsCache: this.permissionsCache,
			viewType: this._viewType,
			grid: this.grid,
			moduleStructure: this.moduleStructure,
			commentingInterface: commentingInterface,
			isInHistoryMode: this._isInHistoryMode,
			isInReviewMode: this._isInReviewMode,
			showBaseProperties: this._showBaseProperties		
		});
		this.edit = new com.ibm.rdm.web.artifactgrid.ArtifactEdit({
			projectURI: this.projectURI,
			baselineURI: this.baselineURI,
			isInHistoryMode: this._isInHistoryMode,
			isInReviewMode: this._isInReviewMode,
			dataCache: this.dataCache,
			typeCache: this.typeCache,
			permissionsCache: this.permissionsCache,
			display: this.display,
			commands: this.commands,
			viewType: this._viewType,
			grid: this.grid,
			moduleStructure: this.moduleStructure
		});
		this.links = new com.ibm.rdm.web.artifactgrid.ArtifactLinks({
			projectURI: this.projectURI,
			baselineURI: this.baselineURI,
			dataCache: this.dataCache,
			typeCache: this.typeCache,
			display: this.display,
			viewer: this,
			commands: this.commands,
			isInHistoryMode: this._isInHistoryMode,
			isInReviewMode: this._isInReviewMode,
			onGetLinkedRowsForLinktypeForColumn: dojo.hitch(this, this._onGetLinkedRowsForLinktypeForColumn),
			getLinkedRowsForLinktypeForArtifact: dojo.hitch(this, this.getLinkedRowsForLinktypeForArtifact),
			grid: this.grid
		});
		this.groupSort = new com.ibm.rdm.web.artifactgrid.ArtifactGroup({
			dataCache: this.dataCache,
			typeCache: this.typeCache,
			grid: this.grid
		});

		//Setup the interfaces between parts
		this.display.setEditInterface({
			invokeEdit: dojo.hitch(this.edit, this.edit.invokeEdit),
			isTextReallyEditable: dojo.hitch(this.edit, this.edit.isTextReallyEditable),
			getEditableValue: dojo.hitch(this.edit, this.edit.getEditableValue),
			focusOnEditor: dojo.hitch(this.edit, this.edit.focusOnEditor)
		});
		
		this.edit.setDashboardInterface({
			disableFilters: dojo.hitch(this, this._disableFilterSection),
			enableFilters: dojo.hitch(this, this._enableFilterSection),
			getResources: dojo.hitch(this, this._getBatchFullResources),
			getAssetFolderURI: dojo.hitch(this, function(){
				return this.dashboardTabPage.resourceViewer.getResourceObject().getAssetFolderURI();
			}),
			getIsModifyModuleContentAllowed: dojo.hitch(this, function(){
				return this.commands.getIsModifyModuleContentAllowed();
			}),
			getPromoteEnablementDeferred: dojo.hitch(this, this._getPromoteEnablementDeferred),
			getDemoteEnablementDeferred: dojo.hitch(this, this._getDemoteEnablementDeferred),
			promoteArtifact: dojo.hitch(this, this._promoteArtifact),
			demoteArtifact: dojo.hitch(this, this._demoteArtifact),
			getModuleArtifactTypeURI: this.getModuleArtifactTypeURI
		});
		this.commands.setEditInterface(this.edit);
		this.commands.setLinksInterface(this.links);
		
		this.commands.setDashboardInterface({
			setArtifactCount: dojo.hitch(this, this.updateNumArtifacts),
			getSelectedFolder: dojo.hitch(this.dashboardTabPage, this.dashboardTabPage.getSelectedFolder),
			colRemovedCallback: dojo.hitch(this, function(rowIds) {
				this.setPagedResults(this.dataCache.getArrayListOfResources(), this._pageDisplayed, this._maxPages, this._count);
				if (dojo.isFunction(this.dashboardTabPage.colRemovedCallback)) {
					this.dashboardTabPage.colRemovedCallback(rowIds);
				}
				this.showArtifacts();
			}),
			createArtifact: dojo.hitch(this.dashboardTabPage, this.dashboardTabPage.createArtifact),
			isEditMode: dojo.hitch(this, function() {
				return this.dashboardTabPage.resourceViewer.editMode;
			}),
			getCompositeRootURI: dojo.hitch(this, function() {
				return this.dashboardTabPage.resourceViewer.getResourceObject().getCompositeRootURI();
			}),
			getAssetFolderURI: dojo.hitch(this, function() {
				return this.dashboardTabPage.resourceViewer.getResourceObject().getAssetFolderURI();
			}),
			getModuleArtifactTypeURI: dojo.hitch(this, function() {
				var artifactTypeUris =
					this.dashboardTabPage.resourceViewer.getResourceObject().getTypes();
				// Note: we only ever have one URI found in the object returned by getTypes() ...
				for (var artifactTypeURI in artifactTypeUris) {
					return artifactTypeURI;
				}
				return null;
			}),
			getModuleProcessAreaURI: dojo.hitch(this, function() {
				return (this.dashboardTabPage.resourceViewer ? this.dashboardTabPage.resourceViewer.getResourceObject().getProcessAreaURI() : null);
			}),
			getModifyArtifactPermissions: dojo.hitch(this, function() {
				return this.dashboardTabPage.resourceViewer.getModifyArtifactPermissions();
			}),
			getCurrentViewServiceRequestParams:  dojo.hitch(this.dashboardTabPage, this.dashboardTabPage.getCurrentViewServiceRequestParams),
			getCurrentConfiguration: dojo.hitch(this, this.getCurrentConfiguration)
		});
		
		if (this._viewType === com.ibm.rdm.web.project.DashboardConstants.VIEW_TYPES.MODULE) {
			this.commands.setCommentingInterface(commentingInterface);
		}

		this.registerNavigateHandlers();

		if (this._viewType !== com.ibm.rdm.web.project.DashboardConstants.VIEW_TYPES.MODULE
			&& this._viewType !== com.ibm.rdm.web.project.DashboardConstants.VIEW_TYPES.COLLECTION
			) {
			this.headerNodes.toolbarContainer.appendChild(this.projectToolbar.domNode);
		}

		var self = this;
		
		var columnSelectionFunc = (function() {

			var projectURI = self.projectURI;
			var resourceURI = self.resourceURI;
			var baselineURI = self.baselineURI;
			
			return function() {
				//This function returns the AddColumn dialog to use, and we prepopulate with the types from the filter.
				
				var artifactTypes = self.dashboardTabPage.getAppliedArtifactTypes();
				if (self._addcolumndialog) {
					self._addcolumndialog.destroy();
				}
				// TODO: Probably a better way to do this than passing
				// a reference to the ArtifactLinks and ArtifactDisplay,
				// perhaps by leveraging gridmodel's custom property.
				// Will file a task to clean it up. --Christian
				var artifactLinks = self.links;
				var artifactDisplay = self.display;
				var viewType = self._viewType;
				self._addcolumndialog = new com.ibm.rdm.web.project.AddColumnDialog(
						{
							projectURI: projectURI,
							resourceURI: resourceURI,
							artifactTypes: artifactTypes,
							baselineURI: baselineURI,
							artifactDisplay: artifactDisplay,
							artifactLinks: artifactLinks,
							viewType: viewType
						});
				
				self.connect(self._addcolumndialog, "handleOk", self.columnChange);
				
				return self._addcolumndialog;
			};
		}());
		
		// Define keypress handlers for the module and non-module cases.
		// TODO:  This and the handler methods should probably be relocated to 
		// ArtifactCommands and ModuleArtifactCommands. 
		var keyPressHandlers;
		if (this._viewType === com.ibm.rdm.web.project.DashboardConstants.VIEW_TYPES.MODULE) {
			// define keypress handlers for modules
			keyPressHandlers = [
				{ /* DELETE */
					keyCode: dojo.keys.DELETE,
					operationName: ".delete",
					handlerFunction: dojo.hitch(this, this._onDeleteKey),
					multiRow: true
				},
				{ /* CTRL-X  - cut */
					keyChar: 'x',
					copyKey: true, // CTRL for windows, META (apple) for Mac
					ctrl: true,
					operationName: ".cut",
					handlerFunction: dojo.hitch(this, this._onOperationKey),
					multiRow: true
				},
				{ /* SHIFT-DEL - alternative key  for cut */
					keyCode: dojo.keys.DELETE,
					shift: true,
					operationName: ".cut",
					handlerFunction: dojo.hitch(this, this._onOperationKey),
					multiRow: true
				},
				{ /* CTRL-C  - copy */
					keyChar: 'c',
					copyKey: true, // CTRL for windows, META (apple) for Mac
					ctrl: true,
					operationName: ".copy",
					handlerFunction: dojo.hitch(this, this._onOperationKey),
					multiRow: true
				},
				{ /* CTRL-V  - paste after */
					keyChar: 'v',
					copyKey: true, // CTRL for windows, META (apple) for Mac
					ctrl: true,
					operationName: ".pasteAfter",
					handlerFunction: dojo.hitch(this, this._onPasteKey)
				},
				{ /* CTRL-ALT-V  - paste before */
					keyChar: 'v',
					copyKey: true, // CTRL for windows, META (apple) for Mac
					ctrl: true,
					alt: true,
					operationName: ".pasteBefore",
					handlerFunction: dojo.hitch(this, this._onPasteKey)
				},
				{ /* CTRL-SHIFT-V  - paste as link */
					keyChar: 'V',
					copyKey: true, // CTRL for windows, META (apple) for Mac
					ctrl: true,
					shift: true,
					multiRow: true,
					operationName: ".pasteAsLink",
					handlerFunction: dojo.hitch(this, this._onPasteKey)
				},
				{ /*SHIFT-INSERT - alternative key for paste after */
					keyCode: dojo.keys.INSERT,
					shift: true,
					operationName: ".pasteAfter",
					handlerFunction: dojo.hitch(this, this._onPasteKey)
				},
				
				// Add existing artifacts (and variations)
				{ /* CTRL-E - Add existing artifact after */
					keyChar: 'e',
					copyKey: true, // CTRL for windows, META (apple) for Mac
					ctrl: true,
					operationName: ".addAfter",
					validForEditMode: true,
					handlerFunction: dojo.hitch(this, this._onAddExistingArtifactKey)
				},
				{ /* CTRL-ALT-E - Add existing artifact below */
					keyChar: 'e',
					copyKey: true, // CTRL for windows, META (apple) for Mac
					ctrl: true,
					alt: true,
					keyDown: !!dojo.isSafari,
					operationName: ".addBelow",
					validForEditMode: true,
					handlerFunction: dojo.hitch(this, this._onAddExistingArtifactKey)
				},
				{ /* CTRL-SHIFT-E - Add existing artifact before */
					keyChar: 'E',	// shifted, so upper case.
					copyKey: true, // CTRL for windows, META (apple) for Mac
					shift: true,
					ctrl: true,
					operationName: ".addBefore",
					validForEditMode: true,
					handlerFunction: dojo.hitch(this, this._onAddExistingArtifactKey)
				},
				
				// Create similar (and variations)
				{ /* CTRL-ENTER - create similar after */
					keyCode: dojo.keys.ENTER,
					copyKey: true, // CTRL for windows, META (apple) for Mac
					ctrl: true,
					operationName: ".createSimilarAfter",
					validForEditMode: true,
					handlerFunction: dojo.hitch(this, this._onCreateSimilarArtifactKey)
				},
				{ /* CTRL-ALT-ENTER - create similar below */
					keyCode: dojo.keys.ENTER,
					copyKey: true, // CTRL for windows, META (apple) for Mac
					ctrl: true,
					alt: true,
					operationName: ".createSimilarBelow",
					validForEditMode: true,
					handlerFunction: dojo.hitch(this, this._onCreateSimilarArtifactKey)
				},
				{ /* CTRL-SHIFT-ENTER - create similar before */
					keyCode: dojo.keys.ENTER,
					copyKey: true, // CTRL for windows, META (apple) for Mac
					shift: true,
					ctrl: true,
					operationName: ".createSimilarBefore",
					validForEditMode: true,
					handlerFunction: dojo.hitch(this, this._onCreateSimilarArtifactKey)
				},
				
				// Create new artifact and add (and variations)
				{ /* CTRL-K - create (other type) after */
					keyChar: 'k',
					copyKey: true, // CTRL for windows, META (apple) for Mac
					ctrl: true,
					operationName: ".createAfter",
					validForEditMode: true,
					handlerFunction: dojo.hitch(this, this._onCreateNewArtifactKey)
				},
				{ /* CTRL-ALT-K - create (other type) below */
					keyChar: 'k',
					copyKey: true, // CTRL for windows, META (apple) for Mac
					ctrl: true,
					alt: true,
					keyDown: !!dojo.isSafari,
					operationName: ".createBelow",
					validForEditMode: true,
					handlerFunction: dojo.hitch(this, this._onCreateNewArtifactKey)
				},
				{ /* CTRL-SHIFT-K - create (other type) before */
					keyChar: 'K',	// Upper case because shifted.
					copyKey: true, // CTRL for windows, META (apple) for Mac
					shift: true,
					ctrl: true,
					operationName: ".createBefore",
					validForEditMode: true,
					handlerFunction: dojo.hitch(this, this._onCreateNewArtifactKey)
				},
				
				// Upload new artifact and add (and variations)
				{ /* CTRL-U - upload new after */
					keyChar: 'u',
					copyKey: true, // CTRL for windows, META (apple) for Mac
					ctrl: true,
					operationName: ".uploadAfter",
					validForEditMode: true,
					handlerFunction: dojo.hitch(this, this._onCreateNewArtifactKey)
				},
				{ /* CTRL-ALT-U - upload new below */
					keyChar: 'u',
					copyKey: true, // CTRL for windows, META (apple) for Mac
					ctrl: true,
					alt: true,
					keyDown: !!dojo.isSafari,
					operationName: ".uploadBelow",
					validForEditMode: true,
					handlerFunction: dojo.hitch(this, this._onCreateNewArtifactKey)
				},
				{ /* CTRL-SHIFT-U - upload new before */
					keyChar: 'U',	// Upper case because shifted.
					copyKey: true, // CTRL for windows, META (apple) for Mac
					shift: true,
					ctrl: true,
					operationName: ".uploadBefore",
					validForEditMode: true,
					handlerFunction: dojo.hitch(this, this._onCreateNewArtifactKey)
				},

				{ /* CTRL-H  - toggle heading */
					keyChar: 'h',
					copyKey: true, // CTRL for windows, META (apple) for Mac
					ctrl: true,
					operationName: ".toggleHeading",
					validForEditMode: false,
					handlerFunction: dojo.hitch(this, this._onOperationKey),
					multiRow: true
				},
				{ /* CTRL-M - create comment */
					keyChar: 'm',
					copyKey: true, // CTRL for windows, META (apple) for Mac
					ctrl: true,
					operationName: ".addComment",
					handlerFunction: dojo.hitch(this, this._onAddCommentKey)
				},
				{ /* CTRL-SHIFT-M - show comments */
					keyChar: 'M',	// Upper case because shifted.
					copyKey: true, // CTRL for windows, META (apple) for Mac
					ctrl: true,
					shift: true,
					operationName: ".comment",
					handlerFunction: dojo.hitch(this, this._onOperationKey)
				},
				{ /* ALT-SHIFT-RIGHTARROW - indent - demote */
					keyCode: dojo.keys.RIGHT_ARROW,
					alt: true,
					shift: true,
					operationName: ".indent",
					handlerFunction: dojo.hitch(this, this._onIndentOutdentKey),
					multiRow: true
				},
				{ /* ALT-SHIFT-LEFTARROW - outdent - promote */
					keyCode: dojo.keys.LEFT_ARROW,
					alt: true,
					shift: true,
					operationName: ".outdent",
					handlerFunction: dojo.hitch(this, this._onIndentOutdentKey),
					multiRow: true
				}
			];
		} else {
			// define keypress handlers for non-modules
			keyPressHandlers = [
				{ /* DELETE */
					keyCode: dojo.keys.DELETE,
					operationName: ".delete",
					handlerFunction: dojo.hitch(this, this._onDeleteKey),
					multiRow: true
				},
				{ /* CTRL-D - create similar */
					keyChar: 'd',
					copyKey: true, // CTRL for windows, META (apple) for Mac
					ctrl: true,
					operationName: ".createSimilar",
					handlerFunction: dojo.hitch(this, this._onCreateSimilarKey),
					multiRow: true
				},
				{ /* CTRL-C  - copy */
					keyChar: 'c',
					copyKey: true, // CTRL for windows, META (apple) for Mac
					ctrl: true,
					operationName: ".copy",
					handlerFunction: dojo.hitch(this, this._onOperationKey),
					multiRow: true
				},
				{ /* CTRL-X  - duplicate */
					keyChar: 'x',
					copyKey: true, // CTRL for windows, META (apple) for Mac
					ctrl: true,
					operationName: ".duplicate",
					handlerFunction: dojo.hitch(this, this._onOperationKey),
					multiRow: true
				},
				{ /* CTRL-V  - paste as link */
					keyChar: 'v',
					copyKey: true, // CTRL for windows, META (apple) for Mac
					ctrl: true,
					multiRow: true,
					operationName: ".pasteAsLink",
					handlerFunction: dojo.hitch(this, this._onPasteKey)
				}
			];
		}
		
		
		var defaultGridArgs = {
			getFirstEditMenuGroups: dojo.hitch(this, this._getFirstEditMenuGroups),
			columnSelectionDialogFunction: columnSelectionFunc,
			onSaveKey: dojo.hitch(this.edit, this.edit.saveKey),
			onEscKey: dojo.hitch(this.edit, this.edit.escKey),
			onCtrlDKey: dojo.hitch(this.edit, this.edit.duplicate),
			virtualScrolling: true,
			keyPressHandlers: keyPressHandlers
		};
		

		
		//Function used to reflect the save all state
		var isValidListener = function(isEnabled) {
			self.projectToolbar.setSaveAllState(isEnabled);
		};
		//Rich Text Fields pass keys through Edit Manager
		this.edit.setSaveAllListener(isValidListener);
		
		this.configureGridArgs = dojo.mixin(defaultGridArgs, this.configureGridArgs || {});

		this._pageToDisplay = 1;
		this._typeSystemDeferredFunctions = [];

		//Add the callback to init the permissionsCache
		this._addTypeSystemDeferredFunction(dojo.hitch(this, function() {
			this.permissionsCache.typeSystemLoaded();
		}));

		this._nextLoadDeferredFunctions = [];

		this._resultSetGridView = new dijit.layout.ContentPane({}, this._resultSetGridViewDiv);
		this._contentPane = this._resultSetGridView; //TODO Change to what user selected last

		
		this.headerKeys = {};


		this.connect(this.grid, "addCol", this.columnChange);
		this.connect(this.grid, "removeCol", this.columnChange);
		
		this.connect(this.grid, "_addCol", dojo.hitch(this, function(){
			//Ensure the grid is refreshed after column is added
			com.ibm.rdm.web.notifications.ChangeNotifier.notifyListeners({
				eventTopic: com.ibm.rdm.web.notifications.EventTopics.PAGE_DEFINITION_CHANGE,
				projectURI: this.projectURI,
				resourceUriScope: this.resourceURI,
				columnsChanged: true
			});
		}));

		this._disableSortingWhenConditionsWarrant();

		this._isMessageDisplayed = false;

		//This defines the operations for display on the menu.
		//An Collection of Operations
		var that = this;
		var ops = this.commands.getOperations(this);
		this.MENU_OPERATIONS = ops.operations;
		this.MENU_LAYOUT = ops.layout;

		//Setup the grid model
		this.display.setupGridModelData(this);
		this.groupSort.setupGroups();

		this.projectButtonAndMenuActions.addGrouping(this.groupSort.GROUP_NONE, this._messages.groupByNone, function () {
			that.noGrouping();
		});

		this.projectButtonAndMenuActions.addGrouping(this.groupSort.GROUP_DATE, this._messages.groupByDate, function () {
			that.groupByDate();
		});

		this.projectButtonAndMenuActions.addGrouping(this.groupSort.GROUP_USER, this._messages.groupByUser, function () {
			that.groupByUser();
		});

		this.projectButtonAndMenuActions.addGrouping(this.groupSort.GROUP_FORMAT, this._messages.groupByFormat, function () {
			that.groupByFormat();
		});
	
		this.connect(this.projectToolbar, "onSaveClicked", dojo.hitch(this.edit, this.edit.saveAllEdits));

		this.connect(this.projectToolbar, "onCancelClicked", dojo.hitch(this.edit, this.edit.cancelAllEdits));

		this._groupOrder = this.groupSort.GROUP_NONE;
		this._groupLabel = this._messages.groupByNone;

		//RelationManager for all your link traceability needs!
		this._relationManager = new com.ibm.rdm.web.project.RelationManager(this, this.projectURI, this.resourceURI);
		this._relationManager.setGrid(this.grid);

		// Note by SPC on 02/12/2013: I'm adding the following setTimout
		// workaround for 64bit IE ... see Defect 70956 for details about
		// this workaround.
		if (dojo.isIE && window.navigator.cpuClass === "x64") {
			setTimeout(dojo.hitch(this, function(){
					this._loadLinkTypes();
				}), 1);
		} else {
			this._loadLinkTypes();
		}	

		this.dataCache.clearLinks();
		
		//Create the AutoExpansionManager
		this._autoExpansionManager = new com.ibm.rdm.web.project.AutoExpansionManager(this, this._relationManager, 
			this.projectURI, this.baselineURI, dojo.hitch(this.permissionsCache, this.permissionsCache.ensureSynchronous));

		//Enable paging
		this.grid.addPaging({
			getTotalPagesFunction: function() {
				if (self._maxPages) { return self._maxPages; } else { return -1;}
			},
			getCurrentPageFunction : function() {
				return self._pageDisplayed || 1;
			},
			gotoPageFunction: function(pageNum) {
				if (self._pageDisplayed && pageNum && self._pageDisplayed < pageNum) {
					//Going to a next page - reset the grid to the top
					self._scrollToTop = true;
				}
				self._triggerPageRefresh(pageNum, true);
			}
		});
		if (this._viewType === com.ibm.rdm.web.project.DashboardConstants.VIEW_TYPES.MODULE) {
			this._listeners.push(ChangeNotifier.addListener({
				eventTopic: com.ibm.rdm.web.notifications.EventTopics.COMMENTS_CHANGED,
				callbackFunction: this._onCommentsChangedNotify,
				callbackScope: this,
				projectURI: this.projectURI
			}));
			this._listeners.push(ChangeNotifier.addListener({
				eventTopic: com.ibm.rdm.web.notifications.EventTopics.ARTIFACT_SHOW_BASE_PROPERTIES,
				callbackFunction: this._onShowBasePropertiesNotify,
				callbackScope: this,
				resourceUriScope: this.moduleStructure.moduleURI,
				projectURI: this.projectURI
			}));
			this._listeners.push(ChangeNotifier.addListener({
				eventTopic: com.ibm.rdm.web.notifications.EventTopics.MODULE_COUNT_CHANGED,
				callbackFunction: this._onModuleCountChangedNotify,
				callbackScope: this,
				resourceUriScope: this.moduleStructure.moduleURI,
				projectURI: this.projectURI
			}));
		}

		this._listeners.push(ChangeNotifier.addListener({
			eventTopic: com.ibm.rdm.web.notifications.EventTopics.RESOURCE_DELETED,
			callbackFunction: this._onResourceDelete,
			callbackScope: this,
			projectURI: this.projectURI
		}));

		this._listeners.push(ChangeNotifier.addListener({
			eventTopic: com.ibm.rdm.web.notifications.EventTopics.LINK_CREATED,
			callbackFunction: this._onLinkCreate,
			callbackScope: this,
			projectURI: this.projectURI
		}));

		this._listeners.push(ChangeNotifier.addListener({
			eventTopic: com.ibm.rdm.web.notifications.EventTopics.DM_LINK_ACTIONS,
			callbackFunction: this._onDMLinkActions,
			callbackScope: this,
			projectURI: this.projectURI
		}));
		
		this._listeners.push(ChangeNotifier.addListener({
			eventTopic: com.ibm.rdm.web.notifications.EventTopics.LINK_DELETED,
			callbackFunction: this._onLinkDelete,
			callbackScope: this,
			projectURI: this.projectURI
		}));

		this._listeners.push(ChangeNotifier.addListener({
			eventTopic: com.ibm.rdm.web.notifications.EventTopics.LINK_TYPE_ADDED,
			callbackFunction: dojo.hitch(this, this._loadLinkTypes, true),
			callbackScope: this,
			projectURI: this.projectURI
		}));
		this._listeners.push(ChangeNotifier.addListener({
			eventTopic: com.ibm.rdm.web.notifications.EventTopics.LINK_TYPE_REMOVED,
			callbackFunction: dojo.hitch(this, this._loadLinkTypes, true),
			callbackScope: this,
			projectURI: this.projectURI
		}));
		this._listeners.push(ChangeNotifier.addListener({
			eventTopic: com.ibm.rdm.web.notifications.EventTopics.LINK_TYPE_UPDATED,
			callbackFunction: dojo.hitch(this, this._loadLinkTypes, true),
			callbackScope: this,
			projectURI: this.projectURI
		}));
		
		this._listeners.push(ChangeNotifier.addListener({
			eventTopic: com.ibm.rdm.web.notifications.EventTopics.EDIT_FINISHED,
			callbackFunction: dojo.hitch(this, function(){
				this._toggleDrag(false);
			}),
			neverDelayCallback: true,
			callbackScope: this
		}));
		this._listeners.push(ChangeNotifier.addListener({
			eventTopic: com.ibm.rdm.web.notifications.EventTopics.EDIT_STARTED,
			callbackFunction: dojo.hitch(this, function(){
				this._toggleDrag(true);
			}),
			neverDelayCallback: true,
			callbackScope: this
		}));

		if (this._viewType === com.ibm.rdm.web.project.DashboardConstants.VIEW_TYPES.MODULE) {
			// The UX team wants us to ONLY show the auto help popups for modules.
			// Install appropriate listeners to make sure they popup and close when needed ...
			this._listeners.push(ChangeNotifier.addListener({
				eventTopic: com.ibm.rdm.web.notifications.EventTopics.EDIT_FINISHED,
				callbackFunction: dojo.hitch(this, function(){
					automaticPopupHelpManager.closePopupHelpIfNeeded();
				}),
				neverDelayCallback: true,
				callbackScope: this
			}));
			this._listeners.push(ChangeNotifier.addListener({
				eventTopic: com.ibm.rdm.web.notifications.EventTopics.EDIT_STARTED,
				callbackFunction: dojo.hitch(this, function(){
					// Note: It _may_ be the case that the row edit being performed is for
					// some other artifact, in which case we should ignore it. To test for this
					// we just do a quick check to see if this widget is an orphan (meaning this
					// widget doesn't represent part of the currently opened page in the action
					// view cache).
					if (dojo.doc.getElementById(this.id)
						&& automaticPopupHelpManager.isPopupHelpNeeded()) {
						// This module is currently being shown ... show auto help popup if needed.
						var module = this.grid.get("module");
						if (module) {
							// When the CK Editor is opened the InlineGridEditor receives a 'ready' call
							// which invokes code that eventually results in calling the module's 'focus'
							// method (after one or more setTimeout's occur).  We temporarily hook into
							// that focus call here, so that we can pass the correct 2'nd argument to
							// 'openPopupHelpIfNeeded' (i.e. an argument representing the DOM node for
							// which we're attempting to provide popup help).
							var handle = dojo.connect(module, "focus", this, function(){
								automaticPopupHelpManager.openPopupHelpIfNeeded(
									document.activeElement,
									dojo.hitch(this, function(){
										this.grid.focus();
									})
								);
								dojo.disconnect(handle);
							});
						}
					}
				}),
				neverDelayCallback: true,
				callbackScope: this
			}));
		}

		if (this.configureGridArgs) {
			this.grid.configureGrid(this.configureGridArgs);
		}
		
		//Ensure col change refreshes rows
		this.grid.setColumnReorderNotification(dojo.hitch(this, this._gridReorderNotification));
		this.bumpScroller = new com.ibm.rdm.web.common.dnd.BumpScroller({
			scrollable: this.grid.moduleContentPane,
			horizontal: true
		});
		if(this.baselineURI) {
			dojo.addClass(this.domNode, "in-baseline");			
		}

		if (this._viewType === com.ibm.rdm.web.project.DashboardConstants.VIEW_TYPES.MODULE) {
			if (!automaticPopupHelpManager) {
				automaticPopupHelpManager = new com.ibm.rdm.web.common.AutomaticPopupHelpManager({
					displayCountPreferenceName:
						com.ibm.rdm.web.preferences.UserPreferenceNames.ARTIFACT_ROW_EDIT_AUTOMATIC_POPUP_HELP_DISPLAY_COUNT,
					helpMessage:
						this._messages.automaticPopupHelpText
				});
			}
		}
	},

	getCommands: function(){
		return this.commands;
	},
	
	getCurrentMaxPage: function() {
		return this._maxPages;
	},

	startup: function() {

		// handle for our status message
		var loadingPermissionsHandle;
		
		if (this._startedAlready) {
			var fakeDeferred = new dojo.Deferred();
			fakeDeferred.callback();

			return fakeDeferred;
		}
		this._startedAlready = true;
		
		var self=this;
		
		//Initialize with project operations before populating.
		//WI 33084
		var projectOperationsDeferred = ProjectCache.getProjectPermissions(this.projectURI);
		
		// Set status message
		loadingPermissionsHandle = StatusDisplay.showStatusMessage(this._messages["loadingPermissionsMessage"], true);
		
		projectOperationsDeferred.addCallback(this, function(projectOperations){

			this._projectOperations = projectOperations;
			this.commands.setProjectOperations(projectOperations);
			this.links.setProjectOperations(projectOperations);
			this.edit.setProjectOperations(projectOperations);

			//Set the highlight functions
			this._setHighlightRecentArtifacts(this._isRecentArtifactsHighlighted);
			this._setHighlightRecentCommentedArtifacts(this._isRecentCommentedHighlighted);
			this._autoExpansionManager.startup();

			// Project permissions have loaded, clear our message
			StatusDisplay.hideStatusMessage(loadingPermissionsHandle);

			return projectOperations;
		});
		
		projectOperationsDeferred.addErrback(this, function(e) {
			StatusDisplay.hideStatusMessage(loadingPermissionsHandle);
		});
		// Show the grid, even if permissions haven't loaded yet.  Additional functionality will
		// be given once permissions load.
		this.grid.startup();

		return projectOperationsDeferred;
	},
	
	onHidePagingWidget: function() {
		// summary:
		//		User defined function to handle the case of the paging widget
		//		getting hidden (i.e. 'display' set to '').
		// tags:
		//		callback
	},

	onShowPagingWidget: function() {
		// summary:
		//		User defined function to handle the case of the paging widget
		//		getting shown (i.e. 'display' set to '').
		// tags:
		//		callback
	},

	editRow: function(rowIds, /*?Boolean*/inModule){
		this._editRow(rowIds, true, inModule);
	},
	
	_editRow: function (rowIds, /*?Boolean*/editPreferredColumn, /*?Boolean*/inModule) {
		this.edit.editRow(rowIds, editPreferredColumn, inModule);
	},
	
	_onGridNodeFocused: function(/*DOMNode*/node) {
		// summary:
		//		Account for the fact that the user may have moved focus to a row that
		//		is so tall it can't fit in its viewport.  In this case the browser
		//		may have reacted by resetting some of the scrollTop positions which
		//		results in either shifting the whole content area up by 2 pixels and/or
		//		moving the left sidebar and content area up and clipping the top
		//		of these areas, and due to the fact that things have "shifted up" a
		//		gap also appears below the left sidebar as well as the result set area.
		// description:
		//		[ This method was introduced to address Defect 86926. ]
		//		If you've just moved focus into a row whose height exceeds the
		//		viewport's height here is what will occur:
		//		For the Artifacts/Collections/Modules pages ...
		//		  The 'scrollTop' for:
		//		  - JAF's content-cell
		//		  - the content pane that represents the 'contentNode' for the SidebarArtifactLayout
		//		  will change from 0 to some positive number.
		//		For an opened collection or an opened module ...
		//		  The 'scrollTop' for:
		//		  - JAF's content-cell
		//		  - the content pane that represents the 'contentNode' for the SidebarArtifactLayout
		//		  will change from 0 to some positive number.
		//		Note: Although these issues ONLY occur on webkit based browsers when moving
		//		focus around, if you INSTEAD create a brand new "Vision" based artifact [using
		//		a JKE based project] seeded from the "Vision Template" you'll find that all
		//		browser variants will show with these issues as a result of inserting the
		//		newly created row (for views other than a module you'd probably want to turn
		//		on the "Primary Text" column to enable you to see the issue).

		var resetScrollTopValues = function(queryString) {
			dojo.query(queryString).forEach(
				function(node) {
					if (node.scrollTop > 0) {
						node.scrollTop = 0;
					}
				}
			);
		};

		switch (this._viewType) {
		case com.ibm.rdm.web.project.DashboardConstants.VIEW_TYPES.ARTIFACTS:
		case com.ibm.rdm.web.project.DashboardConstants.VIEW_TYPES.COLLECTIONS:
		case com.ibm.rdm.web.project.DashboardConstants.VIEW_TYPES.MODULES:
			resetScrollTopValues("#content-cell, .rdm-project-dashboard > .dijitContentPane");
			break;
		case com.ibm.rdm.web.project.DashboardConstants.VIEW_TYPES.COLLECTION:
			resetScrollTopValues(
				"#content-cell, .com-ibm-rdm-web-artifact-CollectionArtifactWidget > .dijitContentPane"
			);
			break;
		case com.ibm.rdm.web.project.DashboardConstants.VIEW_TYPES.MODULE:
			resetScrollTopValues(
				"#content-cell, .com-ibm-rdm-web-artifact-ModuleArtifactWidget > .dijitContentPane"
			);
			break;
		}
	},

	setBaseline: function(baselineURI) {
		this.baselineURI = baselineURI;
		if (this._autoExpansionManager) {
			this._autoExpansionManager.setBaseline(baselineURI);
		}
		//Refresh the structure
		if (this.moduleStructure){
			this.moduleStructure.setBaseline(baselineURI);
		}
	},
	
	_clearRelations: function(skipRefresh) {
		// summary:
		//		Does the necessary to clear all relation information.
		this.dataCache.clearLinks();
		this._relationManager.reset(skipRefresh);
		
		this._autoExpansionManager.clear();
	},

	_disableSortingWhenConditionsWarrant: function() {
		// summary:
		//		Whenever the user has selected "Group by Modified On" we take
		//		care here to disable sorting for all columns that would
		//		normally be sortable.  This function has been implemented to
		//		address Defects 65066 and 76632.

		// Fill a '_headerCellTableDataNodes' array.
		this._headerCellTableDataNodes = [];
		this.connect(
			this.grid.header,
			"_createSortableHeaderCell",
			dojo.hitch(this, function(td, div, columnName, columnId){
				this._headerCellTableDataNodes.push(td);
			})
		);
		// Appropriately enable or disable the columns that would
		// normally be sortable whenever the user changes the
		// "Group by" assignment.
		this.connect(
			this.grid.header,
			"_setGroupingIdAttr",
			dojo.hitch(this, function(groupingId){
				var i;
				for (i = 0; i < this._headerCellTableDataNodes.length; i++) {
					this.grid.header._setHeaderCellSortEnablement(
						this._headerCellTableDataNodes[i],
						groupingId !== ArtifactGroup.GROUP_DATE
					);
				}
			})
		);
		// Override the definition of isHeaderCellSortingEnabled in the ViewHeader
		// instance that's associated with our grid so that we can report back
		// whether the passed columnId should currently be enabled for sorting.
		this.grid.header.isHeaderCellSortingEnabled = dojo.hitch(this, function(columnId){
			return this.grid.header.get("groupingId") !== ArtifactGroup.GROUP_DATE;
		});
	},
	
	_disableFilterSection: function () {
		if (this._filtersDisabled) {
			return;
		}
		this._filtersDisabled = true;
		this.dashboardTabPage.enableFilterSection(false);
		this.grid.hidePagingWidget();
		this._editorsInGrid = true;
		if (!this._connectedToDisabledFilterClick) {
			this._connectedToDisabledFilterClick = true;
			
			this.connect(this.dashboardTabPage.filterSectionOverlay.getNode(), "onclick", function () {
				var contentElement,
					buttonStrip,
					continueButton,
					dialog,
					closeDialog;
			
				closeDialog = function () {
					dialog.close();
				};

				contentElement = dojo.create("div", {
					"class": "rdm-project-dashboard-edits-in-progress",
					"innerHTML": "<p>"+this._messages.editsInProgressMessage+"</p>"+
								"<p>"+this._messages.saveOrCancelEditsMessage+"</p>"
				});
			
				buttonStrip = dojo.create("div",null,contentElement);
				continueButton = dojo.create("button", {
					innerHTML: this._messages.continueButtonText
				}, buttonStrip);
			
			
			
				this.connect(continueButton, "onclick", function() {
					closeDialog();
				});
			
				
				dialog = new jazz.ui.Dialog({		
					contentNode: contentElement,
					primaryTitle: this._messages.editsInProgressTitle,
					width: (dojo.isIE ? "350px" : "auto")
				});

			});
		}
	},
	
	_enableFilterSection: function () {
		this._filtersDisabled = false;
		this.dashboardTabPage.enableFilterSection(true);
		this.grid.showPagingWidget();
		this._editorsInGrid = false;
	},

	_loadLinkTypes: function(isReload) {
		//isReload: boolean, true if linktypes have been updated, created or removed.
		if(isReload){
			this.typeCache.clearLinkTypesCache();
		}
		this.typeCache.loadLinkTypeSystem(this.projectURI, this.baselineURI, isReload, dojo.hitch(this, function() {
			this._initRelationManager();
			this.links.initialiseLinkCreation(this.MENU_LAYOUT, this.MENU_OPERATIONS, this);
		}));
	},
	
	_toggleDrag: function(isDisabled) {
		dojo.toggleClass(this.domNode, "dragDisabled", isDisabled);
	},
	
	columnChange: function(){
	},
	
	clearSelection: function(){
		this.grid.clearSelection();
	},

	getRecordInfo: function(resourceURI) {
		var record = this.dataCache.getRecordInfo(resourceURI);
		return record;
	},
	
	isEditEnabled: function(resourceURI) {
		return this.edit.isEditEnabled(resourceURI);
	},
	
	createResourceLinkHTML: function(resource, includeId) {
		return this.display.createResourceLinkHTML(resource, includeId);
	},

	/*
	Adds resources without fetching through view service - ebcraig
	*/
	requestOrReconcileArtifacts: function(resources, uris, callback){
		var statusMessageHandle = StatusDisplay.showStatusMessage(this._messages["updating"], true);

		dojo.forEach(resources, function(resource){
			var idx = dojo.indexOf(uris, resource.resourceURI);
			if (idx !== -1){
				uris.splice(idx, 1);
			}
		});
		var resourcesDeferred;

		if (uris.length > 0){
			resourcesDeferred = this.fetchArtifactsToMatchView(uris);
		}
		else{
			resourcesDeferred = new dojo.Deferred();
			resourcesDeferred.callback();
		}

		resourcesDeferred.then(dojo.hitch(this, function(viewServiceResults){
			dojo.forEach(resources, dojo.hitch(this, function (artifact) {
				// makes the result the same shape as the "normal" full page request.
				//this._populateArtifact(artifact);
				var idx = null;
				
				if (this.moduleStructure){
					var structureArtifact = this.moduleStructure.getArtifactByURI(artifact.getResourceURI());
					idx = this.moduleStructure.indexOf(structureArtifact);
				}
				
				this.dataCache.addResource(artifact, idx);
			}));

			var results = {
				resources: resources
			};

			if (viewServiceResults){
				var orderedResources = ViewServiceClient.getResourcesOrderedByOriginalRequestOrdering(
					viewServiceResults.resources, uris
				);
				dojo.forEach(orderedResources, dojo.hitch(this, function (artifact) {
					// makes the result the same shape as the "normal" full page request.
					//this._populateArtifact(artifact);
					this.dataCache.addResource(artifact);
				}));
				dojo.mixin(results.resources, orderedResources);
			}

			if (callback){
				callback(results);
			}
			StatusDisplay.hideStatusMessage(statusMessageHandle);
		}));
	},
	
	requestArtifacts: function(uris, callback){
		var statusMessageHandle = StatusDisplay.showStatusMessage(this._messages["updating"], true);
		this.fetchArtifactsToMatchView(uris).then(dojo.hitch(this, function(viewServiceResults){
			dojo.forEach(viewServiceResults.resources, dojo.hitch(this, function (artifact) {
				// makes the result the same shape as the "normal" full page request.
				//this._populateArtifact(artifact);
				this.dataCache.addResource(artifact);
			}));
			if (callback){
				callback(viewServiceResults);
			}
			StatusDisplay.hideStatusMessage(statusMessageHandle);
		}));
	},
	
	groupByDef: function(attrDefUri, skipRefresh) {
		this._groupLabel = this.projectButtonAndMenuActions.getGroupLabel(attrDefUri);
		this._groupOrder = this.groupSort.GROUP_DEF;
		this.groupSort.setCurrentGroupByDef(attrDefUri);

		//Reset the Relations
		this._clearRelations(skipRefresh);
		
		//And also refresh the page (and go to the first)
		if (!skipRefresh) {
			this._triggerPageRefresh(1);
		}
	},
	
	noGrouping: function(skipRefresh) {
		this._groupOrder = this.groupSort.GROUP_NONE;
		this._groupLabel = this._messages.groupByNone;

		//Reset the Relations
		this._clearRelations(skipRefresh);

		//And also refresh the page (and go to the first)
		if (!skipRefresh) {
			this._triggerPageRefresh(1);
		}
	},

	groupByUser: function(skipRefresh) {
		this._groupOrder = this.groupSort.GROUP_USER;
		this._groupLabel = this._messages.groupByUser;

		//Reset the Relations
		this._clearRelations(skipRefresh);
		
		//And also refresh the page (and go to the first)
		if (!skipRefresh) {
			this._triggerPageRefresh(1);
		}
	},
	
	groupByDate: function(skipRefresh) {
		this._groupOrder = this.groupSort.GROUP_DATE;
		this._groupLabel = this._messages.groupByDate;

		//Reset the Relations
		this._clearRelations(skipRefresh);
		
		//And also refresh the page (and go to the first)
		if (!skipRefresh) {
			this._triggerPageRefresh(1);
		}

	},
	
	groupByFormat: function(skipRefresh) {
		this._groupOrder = this.groupSort.GROUP_FORMAT;
		this._groupLabel = this._messages.groupByFormat;

		//Reset the Relations
		this._clearRelations(skipRefresh);
		
		//And also refresh the page (and go to the first)
		if (!skipRefresh) {
			this._triggerPageRefresh(1);
		}
	},
	
	groupByType: function(skipRefresh) {
		this._groupOrder = this.groupSort.GROUP_TYPE;
		this._groupLabel = this._messages.groupByType;

		//Reset the Relations
		this._clearRelations(skipRefresh);
		
		//And also refresh the page (and go to the first)
		if (!skipRefresh) {
			this._triggerPageRefresh(1);
		}
	},

	getCurrentConfiguration: function(/*Boolean?*/useDesiredAutoExpansionState) {
		// summary:
		//		Provides details of the current display configuration. Returns an object like:
		//		{
		//		    columns: [<array of Column Details, in left to right display order>],
		//		    displayedLinks: [<array of Displayed Link Details for links that can be explored>],
		//		    sortBy: [<array of Sort By Details>],
		//		    groupBy: [<array of Group By details],
		//		    expansionRules: [<array of expansion rules] (if expansion is turned on),
		//		    expansionLevel: integer number of levels (if expansion is turned on)
		//		}
		// description:
		//		Column Details are {colType: <attribute, link, system>,
		//		                colWidth: <an int for the width of the column>,
		//		                  colKey: <URI of the attribute definition, or the LinkType. The actual col_id for 'system' columns>}
		//		
		//		Displayed Link Details are {linkURI: <URI of linktype to be displayed>}
		//		
		//		Sort By Details are {sortType: <custom, system>,
		//		                  sortURI: <URI of the definition, or the col_id for a system column>,
		//						  sortDir: <"A" or "D", ascending or descending>}
		//		
		//		Group By Details are {groupType: <custom, system>,
		//		                   groupURI: <URI of the definition, or the col_id for a system colum>}
		//		
		//		Expansion Rules are {{sourceArtifacts: [artifact types], linkTypes: [link types#object/subject], targetArtifacts: [artifact types]}
		//		
		// useDesiredAutoExpansionState:
		//		If passed as true, the the returned 'expansionLevel' and 'expansionRules'
		//		properties will be based on the last specified settings set by
		//		LinksToShowPopupContentPane (rather than the AutoExpansionManager's
		//		value for these, which change as deferreds are resolved).

		//Get the userCols, array of {colId: colId, width: width}
		var userCols = this.grid.getUserCols(RESOURCE_ROW);

		var columns = [];
		dojo.forEach(userCols, function(userCol) {
			var colKeyAndType = this.display.getDetailsByColId(userCol.colId);
			var traceFormat =
				this._getTraceabilityFormatObject(colKeyAndType.key);
			var col = {
					colType: colKeyAndType.type,
					width: userCol.width,
					colURI: colKeyAndType.key
				};
			if(traceFormat) {
//				col["traceabilityAttributes"] = tlinkAttrs;
				col.format = traceFormat;
				col.linkTypeURI = colKeyAndType.linkTypeURI;
			} 
			columns.push(col);
		}, this);

		var results = {columns: columns};
		
		if (this._drillDownEnabled) {
			if (useDesiredAutoExpansionState) {
				results.expansionLevel = this._autoExpansionLevel;
				results.expansionRules = this._autoExpansionRules;
			} else {
				results.expansionLevel = this._autoExpansionManager.getCurrentLevel();
				results.expansionRules = this._autoExpansionManager.getCurrentRules();
			}
		} 

		return results;
	},

	setCurrentConfiguration: function(configurationDetails) {
		// summary:
		//		Accepts details of the current display configuration.
		// configurationDetails:
		//		See the definition in the getCurrentConfiguration method above.
		//		If any of these settings are not present (as opposed to be an empty array),
		//		then the current settings in the ResultsView are preserved.

		if (configurationDetails.onComplete && !this._isTypeSystemLoaded) {
			this._reloadTypeSystem();
		}
		this._addTypeSystemDeferredFunction(dojo.hitch(this, function(){
			this._setCurrentConfiguration(configurationDetails);
			if (configurationDetails.onComplete) {
				configurationDetails.onComplete();
			}
		}));
	},

	_setCurrentConfiguration: function(configurationDetails) {
		if (configurationDetails) {
			//Clear the grid of contents
			this.grid.hardClear();
			if (!configurationDetails.columns){
				configurationDetails.columns = [
					{
						colType: "s",
						colURI: ArtifactConstants.ID_COL,
						width: ArtifactConstants.ID_COL_WIDTH
					},
					{
						colType: "s",
						colURI: ArtifactConstants.TITLE_COL,
						width: ArtifactConstants.TITLE_COL_WIDTH
					},
					{
						colType: "s",
						colURI: ArtifactConstants.TYPE_COL,
						width: ArtifactConstants.TYPE_COL_WIDTH
					},
					{
						colType: "s",
						colURI: ArtifactConstants.CONTRIBUTOR_COL,
						width: ArtifactConstants.CONTRIBUTOR_COL_WIDTH
					},
					{
						colType: "s",
						colURI: ArtifactConstants.MODIFIED_ON_COL,
						width: ArtifactConstants.MODIFIED_ON_COL_WIDTH
					}
				];
			}
			
			//Map the columns onto the current ones
			var desiredCols = [];
			
			dojo.forEach(configurationDetails.columns, function(colDetail) {
				var newColDetails, details;

				if (colDetail.colType === this.display.LINK_COL) {
					details = this.display.getDetailsByLinkKey(colDetail.colURI);
					if (details) {
						newColDetails = {colId: details.colId};
						if(colDetail.columnTraceabilityAttrs) {
							this.links.setTraceabilityAttributesForColumn(
									details.key,
									colDetail.columnTraceabilityAttrs);

							if(colDetail.columnTraceabilityAttrFormat) {
								this.links.setTraceabilityAttributeColumnFormat(
									details.key,
									colDetail.columnTraceabilityAttrFormat);
							}
						}
						else {
							this.links.clearTraceabilityAttributesForColumn(
								details.key);
							this.links.setTraceabilityAttributeColumnFormat(
								details.key);
						}
					} else {
						ErrorHandler.warn("Unrecognised Stored Column Link Key:", colDetail.colURI);
					}
				} else if (colDetail.colType === this.display.ATTRIBUTE_COL) {
					details = this.display.getDetailsByAttribute(colDetail.colURI);
					if (details) {
						newColDetails = {colId: details.colId};
					} else {
						ErrorHandler.warn("Unrecognised Stored Column Attribute URI:", colDetail.colURI);
					}
				} else if (colDetail.colType === this.display.SYSTEM_COL) {
					details = this.display.getDetailsBySystemKey(colDetail.colURI);
					if (details) {
						newColDetails = {colId: details.colId};
					} else {
						ErrorHandler.warn("Unrecognised Stored Column System Key:", colDetail.colURI);
					}
				} else {
					//Not a recognised column type
					ErrorHandler.warn("Unrecognised Stored Column Type:", colDetail.colType);
				}

				if (newColDetails) {
					//Ensure width is a number
					var width = +colDetail.width;
					if (!width || width < 10) {
						width = 10;
					}
					newColDetails.width = width;
					desiredCols.push(newColDetails);
				}
			}, this);

			//And now get them displayed.
			if (desiredCols.length > 0) {
				this.grid.setUserCols(RESOURCE_ROW, desiredCols);
			}

			if (configurationDetails.groupBy) {

				var groupWellKnown = RRMTypes.getWellKnownAttributeObjectFromURI(configurationDetails.groupBy.groupURI, this.projectURI);
				if (groupWellKnown) {
					switch (groupWellKnown.sameAs) {
						case RRMTypes.WELL_KNOWN_SAME_AS_ATTRIBUTE_NAMES.Contributor:
							this.groupByUser(true);
							break;
						case RRMTypes.WELL_KNOWN_SAME_AS_ATTRIBUTE_NAMES.ArtifactFormat:
							this.groupByFormat(true);
							break;
						case RRMTypes.WELL_KNOWN_SAME_AS_ATTRIBUTE_NAMES.ModifiedOn:
							this.groupByDate(true);
							break;
					}
				}
				else{
					if (configurationDetails.groupBy.groupURI === RRMTypes.WELL_KNOWN_OBJECT_TYPE) {
						this.groupByType(true);
					}
					else {
						this.groupByDef(configurationDetails.groupBy.groupURI, true);
					}
				}
			}
			else{
				this.noGrouping(true);
			}
			if (configurationDetails.expansionLevel && configurationDetails.expansionLevel >= 0) {
				this.setCurrentLevelAndRules(configurationDetails.expansionLevel, 
											configurationDetails.expansionRules ? configurationDetails.expansionRules : []);
				if (configurationDetails.expansionRules) {
					this.projectButtonAndMenuActions.setAdvancedRules(configurationDetails.expansionRules);
				}
				this.grid.setExpandoVisibility(RESOURCE_ROW, true);
				this._drillDownEnabled = true;
			} else {
				this.setCurrentLevelAndRules(-1, []);
				//Ensure expansion turned off
				this._clearRelations(true);
				//Switch off expansion
				this.setDrilldown(false, true);
				this._autoExpansionManager.switchOff();
			}
			
			this.projectButtonAndMenuActions.updateExpansion(null, true, true);
			
			if (configurationDetails.sortBy) {
				var sortWellKnown = RRMTypes.getWellKnownAttributeObjectFromURI(configurationDetails.sortBy.def, this.projectURI);
				var sortDir = configurationDetails.sortBy.order;
				if (sortWellKnown){
					switch(sortWellKnown.sameAs){
						case RRMTypes.WELL_KNOWN_SAME_AS_ATTRIBUTE_NAMES.Contributor:
							//WI 66171 - disallow sorting by Contributor
							//this.sortByUser(sortDir, null, true);
							break;
						case RRMTypes.WELL_KNOWN_SAME_AS_ATTRIBUTE_NAMES.Creator:
							//WI 66171 - disallow sorting by Creator
							//this.sortByCreator(sortDir, null, true);
							break;
						case RRMTypes.WELL_KNOWN_SAME_AS_ATTRIBUTE_NAMES.Title:
							this.sortByName(sortDir, null, true);
							break;
						case RRMTypes.WELL_KNOWN_SAME_AS_ATTRIBUTE_NAMES.Identifier:
							this.sortByID(sortDir, null, true);
							break;
						case RRMTypes.WELL_KNOWN_SAME_AS_ATTRIBUTE_NAMES.ArtifactFormat:
							this.sortByFormat(sortDir, null, true);
							break;
						case RRMTypes.WELL_KNOWN_SAME_AS_ATTRIBUTE_NAMES.ModifiedOn:
							this.sortByDate(sortDir, null, true);
							break;
						case RRMTypes.WELL_KNOWN_SAME_AS_ATTRIBUTE_NAMES.Created:
							this.sortByCreatedDate(sortDir, null, true);
							break;
					}
				} 
				else{
					if (configurationDetails.sortBy.def === RRMTypes.WELL_KNOWN_OBJECT_TYPE) {
						this.sortByType(sortDir, null, true);
					}
					else if (configurationDetails.sortBy.def) {
						this.sortByDef(configurationDetails.sortBy.def, sortDir, null, true);
					} else {
						this._clearRelations(true);
					}
				}
			}
			// Handle the case of configurationDetails.sortBy not being specified.
			else {
				// Reset the _currentSortAttrDefUri field (so that we don't end up
				// abitrarily making use of a sort order that may currently be present).
				this._currentSortAttrDefUri = null;
			}
		}
	},
	
	initNextFind: function(key, searchTerm, done, noMore) {
		// summary: 
		//		Performs a textual find operation for a row.  Highlights all instances of the searchTerm in content and string 
		//		cells that are visible for the row.
		// key:
		//		key of row to search
		// searchTerm:	
		//		string to search for
		// done:	
		//		function to perform if matches found in the row
		// noMore: 
		//		function to perform if no matches found

		var doInitNext = dojo.hitch(this, function() {
			this.clearFind();
			this.grid.disableFisheye();
			this.grid.clearSelection();
			if (this.grid.isLoaded(key)) {
				this.grid.findNextTerm(key, searchTerm, FIND_SELECT_CSS_CLASS, FIND_MARK_CSS_CLASS, REPLACE_MARK_CSS_CLASS, done, noMore);
			} else {
				var visibleCallback = dojo.hitch(this, function() {
					window.setTimeout(dojo.hitch(this, function(){
						this.grid.findNextTerm(key, searchTerm, FIND_SELECT_CSS_CLASS, FIND_MARK_CSS_CLASS, REPLACE_MARK_CSS_CLASS, done, noMore);
					}), 750);
				});
				this.goTo(key, false, false, visibleCallback);
			}
		});
		
		// There are some cases where inline grid editors hang around even though the editors lose focus, 
		// so make sure all inline grid editors are closed.
		if (EditManager.isAnyUnderEdit(this.projectURI)) {
			var deferred = EditManager.saveAll(this.projectURI);
			deferred.addCallback(this, function(response) {
				// give the grid some time to finish rendering
				window.setTimeout(dojo.hitch(this, function(){
					doInitNext();
				}), 200);
				return response;
			});
		} else {
			doInitNext();
		}
	},
	
	initPrevFind: function(key, searchTerm, done, noMore) {
		// summary: 
		//		Performs a textual find operation for a row.  Highlights all instances of the searchTerm in content and string 
		//		cells that are visible for the row.
		// key: 
		//		key of row to search
		// searchTerm:	
		//		string to search for
		// done:	
		//		function to perform if matches found in the row
		// noMore: 
		//		function to perform if no matches found

		var doInitPrev = dojo.hitch(this, function() {
			this.clearFind();
			this.grid.disableFisheye();
			this.grid.clearSelection();
			if (this.grid.isLoaded(key)) {
				this.grid.findPrevTerm(key, searchTerm, FIND_SELECT_CSS_CLASS, FIND_MARK_CSS_CLASS, REPLACE_MARK_CSS_CLASS, done, noMore);
			} else {
				var visibleCallback = dojo.hitch(this, function() {
					window.setTimeout(dojo.hitch(this, function(){
						this.grid.findPrevTerm(key, searchTerm, FIND_SELECT_CSS_CLASS, FIND_MARK_CSS_CLASS, REPLACE_MARK_CSS_CLASS, done, noMore);
					}), 750);
				});
				this.goTo(key, false, false, visibleCallback);
			}
		});
		
		// There are some cases where inline grid editors hang around even though the editors lose focus, 
		// so make sure all inline grid editors are closed.
		if (EditManager.isAnyUnderEdit(this.projectURI)) {
			var deferred = EditManager.saveAll(this.projectURI);
			deferred.addCallback(this, function(response) {
				// give the grid some time to finish rendering
				window.setTimeout(dojo.hitch(this, function(){
					doInitPrev();
				}), 200);
				return response;
			});
		} else {
			doInitPrev();
		}
	},
	
	findNext: function(done, noMore) {
		// summary: 
		//		Finds the next match in a row that has had initNextFind performed.
		// done:	
		//		function to perform if another match is found in the row
		// noMore: 
		//		function to perform if no more matches found in the row

		this.grid.nextFind(done, noMore);
	},
	
	findPrev: function(done, noMore) {
		// summary: 
		//		Finds the next match in a row that has had initPrevFind performed.
		// done:	
		//		function to perform if another match is found in the row
		// noMore: 
		//		function to perform if no more matches found in the row

		this.grid.prevFind(done, noMore);
	},

	clearFind: function() {
		// summary: 
		//		Clears the find operation that has been performed on a row.  Removes
		//		find highlighting and saves the resource behind the row if it has
		//		been modified via a replace operation.

		this.grid.enableFisheye();
		if (this._replaceResource) {
			// A replace operation has occurred for the row, save the resource.
			var resourceToSave = this._replaceResource;
			this._replaceResource = null;
			// Update the resource with the replaced data.
			this._updateFindReplaceRow(resourceToSave);
			this.grid.clearFind();
			
			// Save the resource.
			var doSave = dojo.hitch(this, function() {
				StatusDisplay.showStatusMessage(this._messages.savingModifications);
				this.edit.saveStarted([resourceToSave.getResourceURI()]);
				var deferred = resourceToSave.save({refreshAfterSave: false});
				deferred.addCallback(this, function(response) {
					StatusDisplay.hideStatusMessage();
					this.edit.saveFinished([resourceToSave.getResourceURI()]);
					ChangeNotifier.notifyListeners({
						eventTopic: com.ibm.rdm.web.notifications.EventTopics.ARTIFACT_SAVED,
						resourceURI: resourceToSave.getResourceURI(),
						projectURI: this.projectURI,
						resources: [response],
						noFocus: true
					}); 		
					return response;
				});
				deferred.addErrback(this, function(error) {
					StatusDisplay.hideStatusMessage();
					// if we failed to replace because of a lock, tell the user (note this will not let,
					// them override even if they have permission)
					if (error.lockResponse) {
						LockManager.showLockedMessage(LockManager.MSG_LOCK, error.lockResponse);
					}
					// refresh the affected row, our changes didn't save anyway
					this.refreshArtifacts([resourceToSave.getResourceURI()], true);
					this.edit.saveFinished([resourceToSave.getResourceURI()]);
					return error;
				});
			});
			
			// update the resource, checking first if a conflict exists
			var deferred = ResourceManager.checkIsLatestVersion(resourceToSave);
			deferred.addCallback(dojo.hitch(this, function(response) {
				if (response.isLatest) {
					doSave();
				} else {
					// ask the user what they want to do since there is a conflict
					var modifiedByUserURI = response.resource.getLastModifiedBy();
					var modifiedByUser = null;
					UserCache.getUser(modifiedByUserURI).addBoth(this, function(user) {
						if (response){
							modifiedByUser = user.name;
						} else {
							modifiedByUser = queryutils.getTrimmedUserName(modifiedByUserURI);
						}
						var msgForm = new com.ibm.rdm.web.common.MessageForm({
							confirmMessage: dojo.string.substitute(this._messages.saveModificationsConflict, [modifiedByUser]),
							dialogTitle: this._messages.artifactModified,
							dialogStyle: "yesNo",
							onOk: doSave,
							onCancel: dojo.hitch(this, function() {
								StatusDisplay.hideStatusMessage();
								this.edit.saveFinished([resourceToSave.getResourceURI]);
							})
						});
						msgForm.show();
						return user;
					});
				}
				return response;
			}));
			deferred.addErrback(dojo.hitch(this, function(error) {
				return error;
			}));
		} else {
			this.grid.clearFind();
		}
	},

	_updateFindReplaceRow: function (resource) {
		// summary:
		//		Update the resource with text replacements that have occurred in the grid.  

		var sd = this.grid._searchDetails;
		if (!sd) {
//			ErrorHandler.debug("Error: updateFindReplaceRow called with no search established");
			return;
		}
					
		var isSectionNumberNode = function(node) {
			return DomUtils.findAncestorByClass(node, ArtifactConstants.CONTENT_SECTION_NUM_CLASS) !== null;
		};		
		var isTitleNode = function(node) {
			return (DomUtils.findAncestorByClass(node, ArtifactConstants.CONTENT_TITLE_CLASS) !== null) || 
				(DomUtils.findAncestorByClass(node, "headingText") !== null);
		};
		var isPrimaryTextNode = function(node) {
			return (DomUtils.findAncestorByClass(node, ArtifactConstants.CONTENT_TEXT_CLASS) !== null) || 
				(DomUtils.findAncestorByClass(node, "content") !== null);
		};
		
		// avoid issues that may arise if data appears multiple times (e.g., multiple content columns showing)
		var primaryTextUpdated = false;  
		var titleUpdated = false;  
		var updatedAttributeText, attributeText;
		
		var searchTerm = sd.searchTerm.toUpperCase();
		
		// Loop through the cells that have been searched, looking for replacements that may have occurred
		dojo.forEach(sd.cols, function(colId) {

			// if replaceClassName exists in the cell html, a replacement has occurred
			var cellHtml = this.grid.getCellHtml(sd.key, colId);
			if (dojo.query('.' + sd.replaceClassName, cellHtml).length > 0) {
			
				var occurrences = this.grid.gridmodel.getFindReplaceOccurrences(sd.primaryRowType, colId, sd.key);
				var contents;
				
				if (colId === ArtifactConstants.MODULE_CONTENT_COL) {
					
					// in content columns, the cell html can be a conglomerate of section number, title, and primaryText
					var sectionNumberOccurrences = [];  
					var titleOccurrences = [];  
					var primaryTextOccurrences = [];  
					for (var i=0; i<occurrences.length; i++) {
						var occurrence = occurrences[i];
						if (isPrimaryTextNode(occurrence)) {
							primaryTextOccurrences.push(occurrence);
						} else if (isTitleNode(occurrence)) {
							titleOccurrences.push(occurrence);
						} else if (isSectionNumberNode(occurrence)) {
							sectionNumberOccurrences.push(occurrence);
						} else {
							// something is wrong...
						}
					}
					
					// Update title attribute if it has been changed
					if ((titleOccurrences.length > 0) && !titleUpdated) {
						attributeText = resource.getTitle();
						updatedAttributeText = this._searchAndReplace(attributeText, occurrences, 0, searchTerm, sd.replaceClassName);
						resource.setTitle(updatedAttributeText);
						titleUpdated = true;  
					}
					
					// Update primary text if it has been changed
					if ((primaryTextOccurrences.length > 0) && !primaryTextUpdated) {
						primaryTextUpdated = true;
						contents = dojo.create("div");	
						contents.innerHTML = resource.getPrimaryHtmlText();
						this._searchAndReplace(contents, primaryTextOccurrences, 0, searchTerm, sd.replaceClassName);
						resource.setPrimaryText(editorutils.prepareHtmlForServer(contents.innerHTML, false, false));
					}
				} else if ((colId === ArtifactConstants.PRIMARY_TEXT_COL) && !primaryTextUpdated) {
					primaryTextUpdated = true;
					contents = dojo.create("div");	
					contents.innerHTML = resource.getPrimaryHtmlText();
					this._searchAndReplace(contents, occurrences, 0, searchTerm, sd.replaceClassName);
					resource.setPrimaryText(editorutils.prepareHtmlForServer(contents.innerHTML, false, false));
				} else {
					// we're in a string attribute column
					var col = this.grid.gridmodel._getColumn(sd.primaryRowType, colId);
					if (col.custom && col.custom.wellKnownAttributeName) {
						attributeText = resource.getAttributeValue(RRMTypes.getWellKnownAttributeURI(resource.getProjectURI(), col.custom.wellKnownAttributeName));
						if (col.custom.wellKnowAttributeName === RRMTypes.WELL_KNOWN_ATTRIBUTE_NAMES.Title) {
							if (!titleUpdated) {
								updatedAttributeText = this._searchAndReplace(attributeText, occurrences, 0, searchTerm, sd.replaceClassName);
								resource.setTitle(updatedAttributeText);
								titleUpdated = true;
							}
						} else {
							updatedAttributeText = this._searchAndReplace(attributeText, occurrences, 0, searchTerm, sd.replaceClassName);
							resource.setAttribute({
								attributeDefinitionURI: RRMTypes.getWellKnownAttributeURI(resource.getProjectURI(), col.custom.wellKnownAttributeName),
								attributeValue: updatedAttributeText
							});
						}
					} else {
						// user-defined string type
						col = this.grid.gridmodel._getColumn(sd.primaryRowType, colId);
						// build attribute URI
						var attributeURI = com.ibm.rdm.web.FRONTING_SERVICE_TYPES + "/" + colId.substring(1);
						attributeText = resource.getAttributeValue(attributeURI);
						updatedAttributeText = this._searchAndReplace(attributeText, occurrences, 0, searchTerm, sd.replaceClassName);
						resource.setAttribute({
							attributeDefinitionURI: attributeURI,
							attributeValue: updatedAttributeText
						});
					}
				}
			}
		}, this);
	},
	
	_searchAndReplace: function(replaceElement, occurrences, replaceIndex, searchTerm, replaceClassName) {		
		// summary:
		//		For the given element, update it with text replacements that have occurred.  We replace
		//		the resource element by performing the same find logic that was peformed on the grid
		//		cell html and using the grid find occurrences.  
		// replaceElement: 
		//		String or Node that should be updated
		// occurrences:
		//		list of find occurrences
		// replaceIndex:
		//		index of current find occurrence
		// searchTerm:
		//		string we are searching for
		// replaceClassName:
		//		class indicating that a find occurrence has been replaced
	
		var updateText = function(text) {
			var searchValue = text;
			var matchIndex = searchValue.toUpperCase().indexOf(searchTerm);
			if (matchIndex !== -1) {
				var newValue = "";
				while ((replaceIndex < occurrences.length) && (matchIndex !== -1)) {
					newValue = newValue.concat(searchValue.substring(0,matchIndex));
					// if the find occurrence has a replacement, replace the text
					// in the element
					if (dojo.hasClass(occurrences[replaceIndex], replaceClassName)) {
						var replaceText = occurrences[replaceIndex].firstChild.nodeValue;
						newValue = newValue.concat(replaceText);
						replaceIndex = replaceIndex + 1;
					} else {
						var oldValue = searchValue.substr(matchIndex, searchTerm.length);
						newValue = newValue.concat(oldValue);
						replaceIndex = replaceIndex + 1;
					}
					searchValue = searchValue.substring(matchIndex + searchTerm.length);
					matchIndex = searchValue.toUpperCase().indexOf(searchTerm);
				}
				newValue = newValue.concat(searchValue);
				return newValue;
			} else {
				return searchValue;
			}
		};
		
		if (typeof replaceElement === "string") {
			// replacing in a simple string
			return updateText(replaceElement);
		} else {
			// replacing in an html node
			////////////////////////////////////////////////////////////////////////////////////////////////
			// NOTE:  This algorithm needs to match logic and order of the ArtifactDisplay._searchDom method
			//////////////////////////////////////////////////////////////////////////////////////////////// 
			if (replaceElement.nodeType === Node.ELEMENT_NODE) {
				var children = replaceElement.childNodes;
				for (var i=0; i<children.length; i++) {
					var child = children[i];
					replaceIndex = this._searchAndReplace(child, occurrences, replaceIndex, searchTerm, replaceClassName);
				}
			} else if (replaceElement.nodeType === Node.TEXT_NODE) { 
				replaceElement.nodeValue = updateText(replaceElement.nodeValue);
			}
			return replaceIndex;
		}
	},

	replaceFind: function(replaceTerm, onDone, onError) {
		// summary:
		//		Replace the current search item with the given term.  If the operation cannot
		//		be performed or fails, execute onError.  Otherwise, execute onDone when the
		//		replace has occurred.  This method updates the grid display with the changed value;
		//		however, resource update does not occur until the find operation ends for the current
		//		row (e.g., find goes to a new row or find operation ended by some user action).
		// replaceTerm: 
		//		The replacement string.
		// onDone:
		//		Function to perform when replace operation done.
		// onError:
		//		Function to perform when replace operation fails.
		
		var findNode = this.grid.getCurrentFindNode();
		var errorInfo;
		
		// replacements cannot occur on section heading text
		if (DomUtils.findAncestorByClass(findNode, ArtifactConstants.CONTENT_SECTION_NUM_CLASS) !== null) {
			errorInfo = MessageHandler.getMessageBoxInfo(7680);
			onError(errorInfo);
			return;
		}
		
		// replacements cannot occur on id text
		if (DomUtils.findAncestorByClass(findNode, ArtifactConstants.CONTENT_ID_CLASS) !== null) {
			errorInfo = MessageHandler.getMessageBoxInfo(7682);
			onError(errorInfo);
			return;
		}
		
		var key = this.grid.getSelectedObjectId();
		if (!this._replaceResource) {
			// If this is the first time a replace has occurred for the resource,
			// retrieve the full resource.  First check that the resource is in sync.
			// If it is out of sync, we cannot continue since matches that are currently
			// displayed may not match the actual resource content, so call onError
			// in that case.
			var resource = this.getRecordInfo(key);
			var isLatestDeferred = ResourceManager.isLatestModulefactVersion(resource);
			isLatestDeferred.addCallback(this, function(isLatest){
				if (isLatest) {
					// get the resource
					var deferred = ResourceManager.get({
						resourceURI: key, 
						skipCache: true, 
						revision: resource.getRevision()
					});
					deferred.addCallback(this, function(fullResource) {
						// replacements cannot occur on system-generated titles
						if ((DomUtils.findAncestorByClass(findNode, ArtifactConstants.CONTENT_TITLE_CLASS) !== null) && 
							(fullResource.hasServerGeneratedTitle && fullResource.hasServerGeneratedTitle())) {
								errorInfo = MessageHandler.getMessageBoxInfo(7681);
								onError(errorInfo);
						} else {
							this._replaceResource = fullResource;	
							this.grid.replaceFind(replaceTerm, onDone);
						}
						return fullResource;			
					});
					deferred.addErrback(this, function(error) {
						errorInfo = MessageHandler.getMessageBoxInfo(7679, null, error);
						onError(errorInfo);
						return error;
					});
				} else {
					errorInfo = MessageHandler.getMessageBoxInfo(7678);
					onError(errorInfo);
				}
				return isLatest;
			});
			isLatestDeferred.addErrback(this, function(error){
				errorInfo = MessageHandler.getMessageBoxInfo(7679, null, error);
				onError(errorInfo);
				return error;
			});
		} else {
			// replacements cannot occur on system-generated titles
			if ((DomUtils.findAncestorByClass(findNode, ArtifactConstants.CONTENT_TITLE_CLASS) !== null) && 
				(this._replaceResource.hasServerGeneratedTitle && this._replaceResource.hasServerGeneratedTitle())) {
				errorInfo = MessageHandler.getMessageBoxInfo(7681);
				onError(errorInfo);
			} else {
				this.grid.replaceFind(replaceTerm, onDone);
			}
		}
	}, 
	
	goTo: function(key, selectRow, focusRow, onVisible) {
		// summary:
		//		Scrolls the row for the given key into view and selects and focuses the row if indicated.
		var visibleCallback = dojo.hitch(this, function() {
			// select and focus the item after it is visible, module grid may have to load
			// a virtual page in order to scroll the item into view
			//console.log("end scrollIntoView");
			if (selectRow) {
				var selectedRows = this.grid.getSelectedRows();
				if (selectedRows.length === 0) {
					this.grid.addToSelection([key]);
				} else if (selectedRows.length === 1) {
					if (selectedRows[0].uri !== key) {
						this.grid.clearSelection();
						this.grid.addToSelection([key]);
					}
				} else {
					this.grid.clearSelection();
					this.grid.addToSelection([key]);
				}
			} 
			if (focusRow) {
				this.grid.setFocusRowById(key);
			} else {
				this.grid.setFocusRowById(key, true);
			}
			if (onVisible) {
				onVisible();
			}
		});
		//console.log("start scrollIntoView");
		this.grid.scrollIntoView(key, visibleCallback);
	},
	
	_getFindStartKey: function() {
		// summary:
		//		Return the key of the row where the find operation should start.

		var key = this.grid.getSelectedObjectId();
		if (!key) {
			var res = this.dataCache.getArrayListOfResources();
			if (res && res.length > 0) {
				key = res[0].getResourceURI();
			} else {
				key = null;
			}
		}
		return key;
	}, 
	
	_gridReorderNotification: function(fnToCall, newCols) {
		var i;
		var allColsLoaded = true;
		var resources = this.dataCache.getArrayListOfResources();
		
		if (resources && resources.length > 0) {
			var typicalResource = resources[0];
			
			for (i =0; i <  newCols.length; i++) {
				var col = newCols[i];
				
				if (col.visible.checked) {
					var colDetails = this.display.getDetailsByColId(col.columnId);
					if (colDetails.type === this.display.ATTRIBUTE_COL && !typicalResource.isAttributeLoaded(colDetails.key)) {
						allColsLoaded = false;
					}
				}
			}
		}
		
		if (allColsLoaded) {
			fnToCall();
		} else {
			//We need to refresh the rows
			this._addNextLoadDeferredFunction(fnToCall);
			this._triggerPageRefresh(this._pageToDisplay, false, true);
		}
	},
	
	_destroyWidgets: function() {
		this.resetNewlyCreatedResources();
	},
	
	resetNewlyCreatedResources: function() {
		this._arrayListOfNewlyCreatedArtifacts = [];
	},

	showArtifacts: function() {
		//console.log("RSGV showArtifacts");
		var self = this;
		
		if (this._addcolumndialog) {
			this._addcolumndialog.destroy();
			this._addcolumndialog = null;
		}

		//Forget about links
		this.dataCache.clearLinks();


		//Reset the Relations - without refreshing
		this._clearRelations(true);
		
		this.grid.clear();
		this.artifactCount = this.dataCache.getArrayListOfResources().length;
		
		if (this.artifactCount === 0) {		    
			this._isMessageDisplayed = false;       
			StatusDisplay.hideStatusMessage();
			if (this._viewType === com.ibm.rdm.web.project.DashboardConstants.VIEW_TYPES.COLLECTIONS) {
				this._showMessage(this._messages.noCollectionsMessage);
			} else if (this._viewType === com.ibm.rdm.web.project.DashboardConstants.VIEW_TYPES.MODULES) {
				this._showMessage(this._messages.noModulesMessage);
			} else {
				this._showMessage(this._messages.noArtifactsMessage);
			}
		} else {
			//Ensure the type system is loaded before display
			var deferredDisplay = function () {
				if (!self._groupOrder || self._groupOrder === self.groupSort.GROUP_NONE) {
					// Hmmm this should really honour the default order - but we'll deal with that when we get ordering info from the server.
					var artifactsToShow = [];
					dojo.forEach(self.dataCache.getArrayListOfResources(), function (item) {
						artifactsToShow.push({key: item.getResourceURI(), rowtype: RESOURCE_ROW});
					});					
					this._isMessageDisplayed = false;
					StatusDisplay.hideStatusMessage();
					self.grid.selectNoGroup();
					self.grid.showArtifacts(artifactsToShow);
				} else {				    
					this._isMessageDisplayed = false;
					StatusDisplay.hideStatusMessage();
					self.grid.selectGroup(self._groupOrder);
				}
				//Select the top row if neccessary
				if (!self.grid.virtualScrolling) {
					if (self._scrollToTop && self.dataCache.getArrayListOfResources() && self.dataCache.getArrayListOfResources()[0]) {
						var res = self.dataCache.getArrayListOfResources();
						if (res && res.length > 0) {
							var row = res[0];
							var key = row && row.getResourceURI();
							if (key) {
								self.grid.scrollIntoView(key);
							}
						}
						delete self._scrollToTop;
					}
				}
				
				//Act on any deferred loading functions
				self._nextLoad();
			};
			this._addTypeSystemDeferredFunction(deferredDisplay);
		}
		
		//Ensure AutoExpansion is in progress, if necessary
		if (self._drillDownEnabled) {
			self._autoExpansionManager.setDesiredState(self._autoExpansionLevel, self._autoExpansionRules);
		}
		
		//Set the highlight functions
		this._setHighlightRecentArtifacts(this._isRecentArtifactsHighlighted);
		this._setHighlightRecentCommentedArtifacts(this._isRecentCommentedHighlighted);
		this._setHighlightNewlyCreatedArtifacts();

		if (this._viewType !== com.ibm.rdm.web.project.DashboardConstants.VIEW_TYPES.MODULE) {
			this.updateNumArtifacts(this.artifactCount, this._count);
		}
	},

	
	showLoadingArtifactsMessage: function() {
		StatusDisplay.showStatusMessage(this._messages.loadingArtifactsMessage);
		if (this._viewType !== com.ibm.rdm.web.project.DashboardConstants.VIEW_TYPES.MODULE) {
			this.updateNumArtifacts(0);
		}
	},
	
	showRestoringConfigurationMessage: function() {
		StatusDisplay.showStatusMessage(this._messages.restoreConfiguration);
		if (this._viewType !== com.ibm.rdm.web.project.DashboardConstants.VIEW_TYPES.MODULE) {
			this.updateNumArtifacts(0);
		}
	},

	showFilterNeededMessage: function() {
		this._showMessage(this._messages.filterNeededMessage);
		this.updateNumArtifacts(0);
	},

	refreshArtifacts: function(resourceURIs, includeLockInfo) {
		// summary:
		//		Will cause these artifacts, if currently shown in the grid, to refresh themselves.
		this._refreshResources(resourceURIs, dojo.hitch(this, function () {
			var i;
			//And reshow them
			var refreshRows = [];
			for (i = 0; i < resourceURIs.length; i++) {
				refreshRows.push({key: resourceURIs[i], rowtype: RESOURCE_ROW});
			}
			this.grid.refreshRows(refreshRows);
			//Get the RelationManager to refresh as well
			//RelationManager deals with the Tree View (showing relationships) 
			this._relationManager.refreshArtifacts(resourceURIs);
		}), includeLockInfo);
	},
	
	refreshResources: function(resources, /*Boolean?*/ noFocus) {
		// summary:
		//		Will cause these artifacts, if currently shown in the grid, to refresh themselves.
		// noFocus:
		//		If set and true, no attempt is made to restore focus to the grid
		//		following the refresh.

		if (!resources) {
			console.error("RSGV refreshResources: called with resources falsey");
			return;
		}
		
		var i;
		this._findAndReplaceResources(resources);
		//And reshow them
		var refreshRows = [];
		var resourceURIs = [];
		var resourceKey = null;
		var wasStub = false;
		for (i = 0; i < resources.length; i++) {
			if (resources[i].stubId){
				resourceKey = resources[i].stubId;
				wasStub = (resources[i].stubId !== resources[i].getResourceURI());
				if (wasStub){
					resources[i].stubId = null;
				}
			}
			else{
				resourceKey = resources[i].getResourceURI();
				wasStub = false;
			}
			refreshRows.push({key: resourceKey, rowtype: RESOURCE_ROW, newKey: (wasStub ? resources[i].getResourceURI() : null)});
			resourceURIs.push(resourceKey);
		}
		this.grid.refreshRows(refreshRows, noFocus);
		//Get the RelationManager to refresh as well
		this._relationManager.refreshArtifacts(resourceURIs);
		
		if (this.moduleStructure) {
			this.moduleStructure.updatePrimaryTextForResources(resources);
		}
		
	},
	
	refreshAllExpandos: function() {
		// summary:
		//		Will cause all artifacts currently shown in the grid, to refresh themselves.
		var i;
		//First get all expanded rows to refresh
		this._relationManager.refreshAllExpandos();
		
		//Then get all base rows to refresh
		var refreshRows = [];
		var resources = this.dataCache.getArrayListOfResources();
		
		for (i = 0; i < resources.length; i++) {
			refreshRows.push({key: resources[i].getResourceURI(), rowtype: RESOURCE_ROW});
		}
		
		this.grid.refreshExpandos(refreshRows);

	},

	getPageURIList: function(pageNum, /*optional*/isPrefetch) {
		// Summary:
		//    Returns an array of artifact URIs that should go on the given page
		//    This function is called for modules, where for performance reasons
		//    we need supply a list of artifacts (kind of like a SQL where artifact_uri IN)
		//    clause rather than a page number.
		//
		//    pageNum: 
		//			The page number 
		//
		//	  isPrefetch:
		//		    Since this function is also called as part of the scroll cache, this
		//			flag is used to indicate whether the pageNum is actually going to be
		//			displayed.
		//
		var pageToDisplay = pageNum || this._pageToDisplay;
		var page = this.grid.pageModel.getPage(pageToDisplay - 1);
		
		if (page && pageNum && !isPrefetch) {
			this._pageToDisplay = pageNum;
		}
		
		return ((page && page.uris) || []);
	},

	getPageToDisplay: function() {
		// summary:
		//		Returns the page that is the one that 'should' be displayed.
		//		This may or may not be the one that is being displayed.
		return this._pageToDisplay;
	},
	
	getPageOffset: function() {
		return this._pageOffsets[this.getPageToDisplay()];
	},

	resetPageToDisplay: function() {
		// summary:
		//		This resets the page to display to 1.
		this._pageToDisplay = 1;
	},

	getPageSize: function() {
		// summary:
		//		Returns the current page size.
		if (this._viewType === com.ibm.rdm.web.project.DashboardConstants.VIEW_TYPES.MODULE) {
			return this.fixedPageSize;
		}
		else {
			var pageDetails = this.projectButtonAndMenuActions.getPageSize();
			if (pageDetails.justChanged) {
				this.resetPageToDisplay();
			}
			return pageDetails.size;
		}
	},

	getOrderByAttributes: function() {
		// summary:
		//		Returns the desired ordering for a query. This takes into account
		//		any grouping being displayed, and any sort order invoked.
		// returns:
		//		An array of attribute definition uris to order by.

		var orderByAttribs = [];

		if (this._groupOrder === this.groupSort.GROUP_USER) {
			orderByAttribs.push({def: RRMTypes.getWellKnownAttributeURI(this.projectURI, RRMTypes.WELL_KNOWN_ATTRIBUTE_NAMES.Contributor), order: "d", type: "g"});
		} else if (this._groupOrder === this.groupSort.GROUP_FORMAT) {
			orderByAttribs.push({def: RRMTypes.getWellKnownAttributeURI(this.projectURI, RRMTypes.WELL_KNOWN_ATTRIBUTE_NAMES.ArtifactFormat), order: "d", type: "g"});
		} else if (this._groupOrder === this.groupSort.GROUP_TYPE) {
			orderByAttribs.push({def: RRMTypes.WELL_KNOWN_OBJECT_TYPE, order: "d", type: "g"});
		} else if (this._groupOrder === this.groupSort.GROUP_DATE) {
			orderByAttribs.push({def: RRMTypes.getWellKnownAttributeURI(this.projectURI, RRMTypes.WELL_KNOWN_ATTRIBUTE_NAMES.ModifiedOn), order: "d", type: "g"});
		} else if (this._groupOrder === this.groupSort.GROUP_DEF) {
			orderByAttribs.push({def: this.groupSort.getCurrentGroupByDef(), order: "d", type: "g"});
		}

		//Add the sort order
		if (this._currentSortAttrDefUri) {
			if (this._currentSortAttrDefUri === RRMTypes.WELL_KNOWN_SAME_AS_ATTRIBUTE_NAMES.RecentCommentCount) {
				// do secondary and tertiary
				orderByAttribs.push({def: this._currentSortAttrDefUri, order: this._currentSortOrder, type: "s"});
				orderByAttribs.push({def: RRMTypes.WELL_KNOWN_SAME_AS_ATTRIBUTE_NAMES.UnresolvedCommentCount, order: this._currentSortOrder, type: "s"});
				orderByAttribs.push({def: RRMTypes.WELL_KNOWN_SAME_AS_ATTRIBUTE_NAMES.ResolvedCommentCount, order: this._currentSortOrder, type: "s"});
			} else {
				orderByAttribs.push({def: this._currentSortAttrDefUri, order: this._currentSortOrder, type: "s"});
			}
		}
		// sort module artifacts by the book order 
		else if (this._viewType === com.ibm.rdm.web.project.DashboardConstants.VIEW_TYPES.MODULE) {
			orderByAttribs.push({def: RRMTypes.WELL_KNOWN_SAME_AS_ATTRIBUTE_NAMES.BookOrder, order: "a", type: "s"});
		}
		
		return orderByAttribs;
	},

	handleRefresh: function() {
		this._reloadTypeSystem();
		this._loadLinkTypes();
	},
	
	_triggerPageRefresh: function(page, pageChangeOnly, columnsChanged) {
		// summary:
		//		Sets the page and then triggers a page refresh when the page, sort or group order changes.

		this._pageToDisplay = page;

		var notifierArgs = {
			eventTopic: pageChangeOnly ? com.ibm.rdm.web.notifications.EventTopics.PAGE_NUMBER_CHANGE : com.ibm.rdm.web.notifications.EventTopics.PAGE_DEFINITION_CHANGE,
			projectURI: this.projectURI,
			resourceUriScope: this.resourceURI
		};
		
		if (columnsChanged) {
			notifierArgs.columnsChanged = true;
		}

		ChangeNotifier.notifyListeners(notifierArgs);
		
	},

	///////////////////////////////////////////////////////////////////////////
	// Functions to support traceability drill in the Grid
	//

	_initRelationManager: function() {
		//Turn the linktype keys into directional linktypes
		var self = this;
		var linkRelations = [];
		var linkRelationsData = {};
		dojo.forEach(this.typeCache.getLinkTypeKeys(), function (linkTypeUri) {
			var linkType = self.links.getApplicableLinkType(linkTypeUri);
			if (linkType) {
				if (linkType.isBidirectional()) {
					var biUri = linkType.getResourceURI()+ArtifactConstants.BIDIRECTIONAL_LINK;
					linkRelations.push(biUri);
					var name = linkType.getSubjectToObjectLabel() || linkType.getName();
					linkRelationsData[biUri] = {relationName: name, uri: linkType.getResourceURI(), 
												direction: "BI", sameAs: linkType.getSameAs()};
				} else {
					var subjectUri = linkType.getResourceURI()+ArtifactConstants.SUBJECT_LINK;
					linkRelations.push(subjectUri);
					linkRelationsData[subjectUri] = {relationName: linkType.getSubjectToObjectLabel(), uri: linkType.getResourceURI(), 
														direction: "SUB", sameAs: linkType.getSameAs()};
					var objectUri = linkType.getResourceURI()+ArtifactConstants.OBJECT_LINK;
					linkRelations.push(objectUri);
					linkRelationsData[objectUri] = {relationName: linkType.getObjectToSubjectLabel(), uri: linkType.getResourceURI(), 
														direction: "OBJ", sameAs: linkType.getSameAs()};
				}
			} else {
				ErrorHandler.warn("Unknown LinkType when creating LinkType keys", linkType.getResourceURI());
			}
		});


		this.typeCache.setLinkRelationsData(linkRelationsData);

		
		this._relationManager.addRelations({
			relationIds: linkRelations,
			getLinkTypeDataFunction: function(linktype) {
				var result = self.typeCache.getLinkRelationsData(linktype);
				return result;
			},
			getRowRelationsFunction: function(uri, fnToCall) {
				var result = self.links.getLinktypesForArtifact(uri, fnToCall);
				return result;
			},
			getLinkedRowsFunction: function(uri, linktype, fnToCall) {
				var result = self.links.getLinkedRowsForLinktypeForRow(uri, linktype, fnToCall);
				return result;
			},
			parentRelationRow: RESOURCE_ROW,
			projectURI: this.projectURI,
			getLinkTypeFromKeyFunction: function(linktype) {
				var result = self.links.getApplicableLinkType(linktype);
				return result;
			},
			createLinkFunction: dojo.hitch(self, self._createLinkFromHeading)
		});

	},
	


	_releaseArtifacts: function (uris) {
		this.dataCache.removeResources(uris);
	},

	
	_createLinkFromHeading: function(resourceURIs, relationId) {
		// summary:
		//		Creates a link from the details given in the heading row
		// resourceURIs:
		//		The array of resource URIs to create the link from.
		// relationId:
		//		The id given for the relation.
		
		//Split the key into its parts
		var relationData = this.typeCache.getLinkRelationsData(relationId);
		
		var isSubject = (relationData.direction === "SUB");
		var linkType = this.links.getApplicableLinkType(relationData.uri);
		
		this.links.showCreateLinkDialog(linkType, isSubject, resourceURIs);
	},

	
	getLinkedRowsForLinktypeForArtifact: function(resourceUri, desiredLinkType, fnToCall, ignoreRules) {
		// summary:
		//		Obtains an array of the actual linked objects for this artifact and linktype.
		//		When complete, call the fnToCall with an array of uris (or an {err: value , ... other params... } constuct.
		// desiredLinkType:
		//		The 'name' of the linktype you are after - note this is directional, it is the uri plus a _OBJ/_SUB or _BI suffix.
		
		var self = this;
		var loadLinksDeferred = this._autoExpansionManager.getLinksForResource(resourceUri, ignoreRules);
		loadLinksDeferred.addCallback(function() {
			var linkedRows = self.dataCache.getLinkedRows(resourceUri);
			if (linkedRows) {
				fnToCall(linkedRows[desiredLinkType]);
			} else {
				fnToCall([]);
			}
		});
	},


	_onGetLinkedRowsForLinktypeForColumn: function() {

		var resources = {};
		var linkTypes = {};
		
		var rows = this.links.getAndResetInflightLinkedRows();

		//We want deleting a link not to refresh from the server
		var refreshContext = this.display.getAndClearNextLoadContextValue("LINK_REFRESH");
		
		if (refreshContext == "NON-SERVER") {
			this._updatedLinksCallback(rows);
		} else {
		
			var i;
			for (i=0; i < rows.length; i++) {
				var col = rows[i];
				resources[col.uri] = true;
				linkTypes[col.linkType] = true;
			}
			
			var resourceUris = [], resourceUri;
			var moduleBindingURI;
			
			for (resourceUri in resources) {
				resourceUris.push(resourceUri);
				//If desired, collect any links for base artifacts - only for modules
				if(this._viewType === com.ibm.rdm.web.project.DashboardConstants.VIEW_TYPES.MODULE && this._showBaseProperties){
					moduleBindingURI = this.dataCache.getBaseArtifactForResource(resourceUri);
					if(moduleBindingURI){
						resourceUris.push(moduleBindingURI);
					}
				}			
			}
			var linkTypeUris = [], linkTypesUri, traceAttrs = {};
			for (linkTypesUri in linkTypes) {
				var linkDetails = this.typeCache.getLinkRelationsData(linkTypesUri);
				var uri = linkDetails.sameAs || linkDetails.uri;
				if (linkDetails.direction === "SUB") {
					linkTypeUris.push(uri+"#subject");
				} else if (linkDetails.direction === "OBJ") {
					linkTypeUris.push(uri+"#object");
				} else {
					//Must be _BI link
					linkTypeUris.push(uri+"#subject");
					linkTypeUris.push(uri+"#object");
				}
				var traceAttrDetails =
					this.links.getTraceabilityAttributesForColumn(linkTypesUri);
				if(traceAttrDetails) {
					traceAttrs[linkTypesUri] = dojo.map(traceAttrDetails,
						function(traceDetail) {
						return traceDetail.uri;
					});
				}
			}
			
			var deferred = this._autoExpansionManager.getLinksForResources(
					resourceUris, [{
						sourceArtifacts: [],
						linkTypes: linkTypeUris,
						targetArtifacts: []}], traceAttrs);

			deferred.addCallback(dojo.hitch(this, this._updatedLinksCallback, rows));
		}
	},
	
	_updatedLinksCallback: function(rows) {
		var i;
		for (i = 0; i < rows.length; i++) {
			var col = rows[i];
			var fnToCall = col.fn;
			var linkedRows = this.dataCache.getLinkedRows(col.uri);
			if (linkedRows) {
				fnToCall(linkedRows[col.linkType]);
			} else {
				fnToCall([]);
			}
		}	
	},
	
	loadImplementedCalmLinks: function(functionToCall, resource) {
		this.links.loadCalmLinks(functionToCall, resource, LinkTypeUtils.SYSTEM_LINK_TYPE_IMPLEMENTED_BY);
	},

	loadTrackedCalmLinks: function(functionToCall, resource) {
		this.links.loadCalmLinks(functionToCall, resource, LinkTypeUtils.SYSTEM_LINK_TYPE_TRACKED_BY);
	},

	loadAffectedCalmLinks: function(functionToCall, resource) {
		this.links.loadCalmLinks(functionToCall, resource, LinkTypeUtils.SYSTEM_LINK_TYPE_AFFECTED_BY);
	},

	loadValidatedCalmLinks: function(functionToCall, resource) {
		this.links.loadCalmLinks(functionToCall, resource, LinkTypeUtils.SYSTEM_LINK_TYPE_VALIDATED_BY);
	},
	
	startIntraCellNavigationForCalmLinks: function(onEndNavigation, cellNode) {
		this.links.startIntraCellNavigation(onEndNavigation, cellNode);
	},

	_getLinkedRows: function(self, resourceUri, desiredLinkType, fnToCall) {
		// summary:
		//		This gets the full artifacts behind the linked rows, for a given link type.
		// self:
		//		A pointer to 'this', to get at various internal collections.
		// resourceUri:
		//		The uri of the row you are getting links for.
		// desiredLinkType:
		//		The 'name' of the linktype you are after - note this is directional, it is the uri plus a _OBJ/_SUB or _BI suffix.
		//		Also note that all CALM links are of distinct types - so either all linked rows are CALM, or none are.
		// fnToCall:
		//		The call back function with the loaded resources.
		//		
		//		Note that, as a side effect, this function stores the returned links in the _linkedResources collection for the desiredLinkType.

		var links = self.dataCache.getLinks(resourceUri);

		var linksForType = [];
		var calmLinks = [];
		var link;
		var i;
		for (i = 0; i < links.length; i++) {
			link = links[i];
			var suffix = ArtifactConstants.SUBJECT_LINK;
			if (link.getObject() === resourceUri) {
				suffix = ArtifactConstants.OBJECT_LINK;
			}
			var linkTypeUri = link.getLinkType();
			var linkType = self.links.getApplicableLinkType(linkTypeUri);
			if (linkType) {
				if (linkType.isBidirectional()) {
					suffix = ArtifactConstants.BIDIRECTIONAL_LINK;
				}
				var linkTypeName = linkTypeUri+suffix;

				if (linkTypeName === desiredLinkType) {
					if (LinkTypeUtils.isCalmLink(linkType.getSameAs())) {
						calmLinks.push(link);
						calmLinks.isCALMLinks = true;
					} else {
						linksForType.push(link);
					}
				}
			} else {
				ErrorHandler.warn("Unknown LinkType", linkTypeUri);
			}
		}

		//if it's a calm link, we need a different query
		if (calmLinks.length > 0) {
			self.dataCache.setLinkedRowsForType(resourceUri, desiredLinkType, calmLinks);
			fnToCall(calmLinks);
			return;
		}

		//Calculate the query. External URLs need to be excluded from the query
		var params = [];
		var externalURLs = [];

		for (i = 0; i < linksForType.length; i++) {
			link = linksForType[i];
			var targetURI =  (link.getObject() === resourceUri) ? link.getSubject():link.getObject();
			if (!linkutils.sameLocation(targetURI)){
				externalURLs.push({type: "EXTERNAL", link: link, otherEnd: targetURI});
			}else{
				params.push({resourceURI: targetURI, reportErrors: true});
			}
		}

		ResourceManager.getMultiple(params, function(resources){
			var resultUris = [];
			var i;
			for (i = 0; i < resources.length; i++) {
				var resource = resources[i];
				if (!resource.err) {
					//Put it in the right place
					this.dataCache.setLinkedResource(resource.getResourceURI(), resource);
					resultUris.push(resource.getResourceURI());
				} else {
					//Even if an Error, record it.
					resultUris.push({err: 1});
				}
			}
			var totalURIs = resultUris.concat(externalURLs);
			self.dataCache.setLinkedRowsForType(resourceUri, desiredLinkType, totalURIs);
			fnToCall(totalURIs);
		});
	},

	////////////////////// Resource Loading /////////////////////////////////

	//If a Resource isn't available, we can load it here.
	//Note for performance reasons, don't do this for lots of resources!

	_refreshResources: function (resourceUris, callbackFn, includeLockInfo) {
		// summary:
		//		This refreshes the given resources (ignoring them if they are not found or if not in grid).
		//		It then calls back on the given function.
		// resourceUris:
		//		An array of resource URIs to refresh - they should be already in the DataCache.
		// callbackFn:
		//		The function to callback when all have been updated.

		//Calculate the query
		
		// default to true for inclusion of lock info in the view request.
		includeLockInfo = (typeof includeLockInfo === "undefined") ? true : includeLockInfo;
		var viewsServiceRequestParams = this.dashboardTabPage.getCurrentViewServiceRequestParams(true);
		var deferred = ViewServiceClient.getViewContents({
			requestedAttributeUris: viewsServiceRequestParams.requestedAttributeUris,
			isCoreView: viewsServiceRequestParams.isCoreView,
			disableModulefactBasePropertiesUnion: viewsServiceRequestParams.disableModulefactBasePropertiesUnion,
			projectURI: this.projectURI,
			artifactUris: resourceUris,
			moduleURI: (this._viewType === com.ibm.rdm.web.project.DashboardConstants.VIEW_TYPES.MODULE)?this.resourceURI:null, 
			processLockInfo: includeLockInfo,
			delayCallbackUntilDataIndexed: true
		});
		deferred.addCallback(this, function (response) {
			var result = ViewServiceClient.parseViewContentsResponse(response, this.projectURI, null, false);
			var resources = result.resources;	
			this._findAndReplaceResources(resources);
			//Call the callback fn
			callbackFn();
		});
	},
	
	_findAndReplaceResources: function(resources) {
		
		// TODO: This needs to check our older resources as well...
		var i;
		for (i = 0; i < resources.length; i++) {
			var resource = resources[i],
				uri = resource.getResourceURI(),
				stubId = resource.stubId;
			//Put it in the right place
			
			if (!this.grid.virtualScrolling) {
				var currentResources = this.dataCache.getArrayListOfResources();
				var len = currentResources.length;
					
				var found=false;
				var j;
				for (j= 0; j < len; j++) {
					if ((stubId && currentResources[j].stubId === stubId) || currentResources[j].getResourceURI() === uri) {
						this.dataCache.replaceResource(uri, j, resource);
						found = true;
						break;
					}
				}
			} else {
				this.dataCache.replaceResource(uri, -1, resource);
			}
			
			//Check if it is a linked resource (which it may be as well)
			if (this.dataCache.getLinkedResource(uri)) {
				this.dataCache.setLinkedResource(uri, resource);
			}
		}
	},


	///////////////////////////////////////////////////////////////////////////
	
	viewHasBeenRestored: function(){
		// summary:
		//		Notification that we are in a view that
		//		has been restored from and off-screen cache.
		this.edit.registerEditManagerCallbacks();
		this.grid.viewHasBeenRestored();
	},

	resize: function(args) {	
		if (this._resizeTimeout){
			clearTimeout(this._resizeTimeout);
			delete this._resizeTimeout;
		}
		this._resizeTimeout = setTimeout(dojo.hitch(this, this._timedResize, args), 200);
	},

	_timedResize: function(args){
		// summary:
		//		This function is here to receive resize calls that are made when
		//		this widget is used as the sole content of a ContentPane.  Please
		//		see ConentPane's 'resize' function for more information.

		clearTimeout(this._resizeTimeout);
		delete this._resizeTimeout;
		
		if (!args){
			var parentCoords = dojo.coords(this.dashboardTabPage._centerContent.domNode);
			args = {
				h: parentCoords.h,
				w: parentCoords.w
			};
		}

		// Rather than try to account for the shenanigans that occur in
		// DashboardPagePage.css to allow for either the presence or absence
		// of the paging widget, it's more straight-forward to update this
		// code here whenever those CSS rules change (note: the CSS file has
		// a comment in it about what .js files should be updated when the
		// rules are updated).  This was done in support of Task 85662.
		if (this._viewType === com.ibm.rdm.web.project.DashboardConstants.VIEW_TYPES.ARTIFACTS
			|| this._viewType === com.ibm.rdm.web.project.DashboardConstants.VIEW_TYPES.COLLECTIONS
			|| this._viewType === com.ibm.rdm.web.project.DashboardConstants.VIEW_TYPES.MODULES
			) {
			args.h += 24;
		}
		else if (this._viewType === com.ibm.rdm.web.project.DashboardConstants.VIEW_TYPES.MODULE) {
			args.h += 14;
		}
		else if (this._viewType === com.ibm.rdm.web.project.DashboardConstants.VIEW_TYPES.COLLECTION) {
			args.h += -18;
		}
		
		var headerHeight = dojo.marginBox(this.headerNodes.headerDiv).h,
			footerHeight = dojo.marginBox(this.footer).h;

		args.h -= headerHeight;
		args.h -= footerHeight;
	
		if(args && args.w >= 0 && args.h >= 0) {
			var width = args.w;
			var height = args.h;
			if (dojo.isIE) {
				// TODO Is there a better approach for this?
				// Without the following code, the horz scrollbar will always
				// appear when the vert scrollbar is present, even in those
				// [most] cases where it shouldn't ...
				if (this.moduleContentPane) {
					this.moduleContentPane.style.width =
						Math.max(0, (args.w));
					this.moduleContentPane.style.height = height - 50;
				}
				height = height + 20;
			}
			var contentPaneSize = {
					h: height,
					w: width
			};
			
			this._contentPaneSize = args;
			// SW : The grid removes an arbitrary 20px which it calls "margins", perhaps this is to counter
			// some other display bug elsewhere, but when rendered in this context it doesn't
			// require that 20px of padding, so fudge the arguments to compensate.
			if (this._viewType !== com.ibm.rdm.web.project.DashboardConstants.VIEW_TYPES.COLLECTION
				&& this._viewType !== com.ibm.rdm.web.project.DashboardConstants.VIEW_TYPES.MODULE) {
				args.h += 20;
			}
			this.grid.resize(args);
			this.grid.scrollHeaderToMatchContent();
		}
	},

	toggleHighlightRecentArtifacts: function() {
		this._isRecentArtifactsHighlighted = !this._isRecentArtifactsHighlighted;
		this._setHighlightRecentArtifacts(this._isRecentArtifactsHighlighted);
	},


	toggleHighlightRecentCommentedArtifacts: function(){
		this._isRecentCommentedHighlighted = !this._isRecentCommentedHighlighted;
		this._setHighlightRecentCommentedArtifacts(this._isRecentCommentedHighlighted);
	},

	showColumnsDialog: function() {
		this.grid.showColumnsDialog();
	},

	showRelationsDialog: function() {
		this._displayRelationsDialog();
	},

	///////////////////////////////////////////////////////////////////////////////////
	// Helper Methods


	_setShowBaseProperties: function(isOn) {
	},

	_setHighlightRecentArtifacts: function(isOn) {
		if (isOn) {
			var self = this;
			var isHighlighted = function (rowId) {
				return (dojo.indexOf(self._arrayListOfRecentArtifacts, rowId)!== -1);
			};
			this.grid.setHighlightFunction("recently-modified-artifact-highlight", isHighlighted);
		} else {
			this.grid.setHighlightFunction("recently-modified-artifact-highlight", null);
		}
	},


	_setHighlightRecentCommentedArtifacts: function(isOn){
		var self = this;
		if (isOn) {
			var recentlyCommentedDeferred = this._getRecentlyCommentedArtifacts();

			recentlyCommentedDeferred.addCallback(function(commentedItems){
				var isHighlighted = function (rowId) {
					return (dojo.indexOf(commentedItems, rowId)!== -1);
				};
				self.grid.setHighlightFunction("recently-commented-artifact-highlight", isHighlighted);
			});
		} else {
			this.grid.setHighlightFunction("recently-commented-artifact-highlight", null);
		}
	},
	
	_setHighlightNewlyCreatedArtifacts: function() {
		var isHighlighted = dojo.hitch(this, function (rowId) {
			return (dojo.indexOf(this._arrayListOfNewlyCreatedArtifacts, rowId)!== -1);
		});
		this.grid.setHighlightFunction("newly-created-artifact-highlight", isHighlighted);
		this.grid.setAddToNewFunction(dojo.hitch(this, function(artifactUri){
			this._arrayListOfNewlyCreatedArtifacts.push(artifactUri);
		}));
	},

	_getRecentlyCommentedArtifacts: function(){
		// summary:
		//		Returns a deferred with the recently commented artifacts
		//		for the current project.
		var self = this;
		var now= new Date();
		var deferred =  new dojo.Deferred();
		var recentCommentsDeferred = RecentFeedsClient.getRecentComments(self.projectURI, com.ibm.rdm.web.query.StoredQueryClient.QUERYMAP.getUpdatedComments);
		var commentedArtifacts= {};
		recentCommentsDeferred.addCallback(function(storedQuery){
			var commentResults = storedQuery.getResults();
			var results=[];
			dojo.forEach(commentResults, function(comment){
				//Get recent comments which have not exceeded the allowed time
				var hoursPassed = dojo.date.difference(comment.modified, now, "hour");
				if(hoursPassed < COMMENT_HIGHLIGHT_EXPIRATION_HRS){
					commentedArtifacts[comment.resourceUri]=true;
				}
			});
			var prop;
			for(prop in commentedArtifacts){results.push(prop);}
			deferred.callback(results);
			return storedQuery;
		});
		return deferred;
	},

	sortByName: function(order, callbackWithSorted, skipRefresh){
		this._currentSortAttrDefUri = RRMTypes.getWellKnownAttributeURI(this.projectURI, RRMTypes.WELL_KNOWN_ATTRIBUTE_NAMES.Title);
		this._currentSortOrder = order;
		if (skipRefresh) {
			this.grid.header.setSortCol("name", order);
		}
		var self = this;
		this._sortBy(order, callbackWithSorted, skipRefresh);
	},

	sortByID: function(order, callbackWithSorted, skipRefresh){
		this._currentSortAttrDefUri = RRMTypes.getWellKnownAttributeURI(this.projectURI, RRMTypes.WELL_KNOWN_ATTRIBUTE_NAMES.Identifier);
		this._currentSortOrder = order;
		var self = this;
		if (skipRefresh) {
			this.grid.header.setSortCol("id-col", order);
		}
		this._sortBy(order, callbackWithSorted, skipRefresh);
	},

	sortByFormat: function(order, callbackWithSorted, skipRefresh) {
		this._currentSortAttrDefUri = RRMTypes.getWellKnownAttributeURI(this.projectURI, RRMTypes.WELL_KNOWN_ATTRIBUTE_NAMES.ArtifactFormat);
		this._currentSortOrder = order;
		var self = this;
		if (skipRefresh) {
			this.grid.header.setSortCol("format", order);
		}
		this._sortBy(order, callbackWithSorted, skipRefresh);
	},

	sortByType: function(order, callbackWithSorted, skipRefresh) {
		this._currentSortAttrDefUri = RRMTypes.WELL_KNOWN_OBJECT_TYPE;
		this._currentSortOrder = order;
		var self = this;
		if (skipRefresh) {
			this.grid.header.setSortCol("obj_type_col", order);
		}
		this._sortBy(order, callbackWithSorted, skipRefresh);
	},

	sortByUser: function(order, callbackWithSorted, skipRefresh) {
		this._currentSortAttrDefUri = RRMTypes.getWellKnownAttributeURI(this.projectURI, RRMTypes.WELL_KNOWN_ATTRIBUTE_NAMES.Contributor);
		this._currentSortOrder = order;
		var self = this;
		if (skipRefresh) {
			this.grid.header.setSortCol("mod-user", order);
		}
		this._sortBy(order, callbackWithSorted, skipRefresh);
	},

	sortByCreator: function(order, callbackWithSorted, skipRefresh) {
		this._currentSortAttrDefUri = RRMTypes.getWellKnownAttributeURI(this.projectURI, RRMTypes.WELL_KNOWN_ATTRIBUTE_NAMES.Creator);
		this._currentSortOrder = order;
		var self = this;
		if (skipRefresh) {
			this.grid.header.setSortCol("creator", order);
		}
		this._sortBy(order, callbackWithSorted, skipRefresh);
	},

	sortByDate: function(order, callbackWithSorted, skipRefresh) {
		// If it's a module, sort by the module's artifacts' modified date not the module's modified date.
		if (this._viewType === com.ibm.rdm.web.project.DashboardConstants.VIEW_TYPES.MODULE) {
			this._currentSortAttrDefUri = RRMTypes.WELL_KNOWN_SAME_AS_ATTRIBUTE_NAMES.ModifiedOn;
		}
		else {
			this._currentSortAttrDefUri = RRMTypes.getWellKnownAttributeURI(this.projectURI, RRMTypes.WELL_KNOWN_ATTRIBUTE_NAMES.ModifiedOn);
		}
		this._currentSortOrder = order;
		var self = this;
		if (skipRefresh) {
			this.grid.header.setSortCol("mod-date", order);
		}
		this._sortBy(order, callbackWithSorted, skipRefresh);
	},

	sortByCreatedDate: function(order, callbackWithSorted, skipRefresh) {
		// If it's a module, sort by the module's artifacts' created date not the module's created date.
		if (this._viewType === com.ibm.rdm.web.project.DashboardConstants.VIEW_TYPES.MODULE) {
			this._currentSortAttrDefUri = RRMTypes.WELL_KNOWN_SAME_AS_ATTRIBUTE_NAMES.Created;
		}
		else {
			this._currentSortAttrDefUri = RRMTypes.getWellKnownAttributeURI(this.projectURI, RRMTypes.WELL_KNOWN_ATTRIBUTE_NAMES.Created);
		}
		this._currentSortOrder = order;
		var self = this;
		if (skipRefresh) {
			this.grid.header.setSortCol("created_date_col", order);
		}
		this._sortBy(order, callbackWithSorted, skipRefresh);
	},

	sortByDef: function(attrDefUri, order, callbackWithSorted, skipRefresh) {

		this._currentSortAttrDefUri = attrDefUri;
		this._currentSortOrder = order;
		
		if (skipRefresh) {
			var colDetails = this.display.getDetailsByAttribute(attrDefUri);
			if (colDetails) {
				this.grid.header.setSortCol(colDetails.colId, order);
			}
		}
		this._sortBy(order, callbackWithSorted, skipRefresh);
	},


	sortByCommentCount: function(order, callbackWithSorted, skipRefresh) {
		this._currentSortAttrDefUri = RRMTypes.WELL_KNOWN_SAME_AS_ATTRIBUTE_NAMES.RecentCommentCount;
		this._currentSortOrder = order;
		var self = this;
		if (skipRefresh) {
			this.grid.header.setSortCol(ArtifactConstants.COMMENTS_COL, order);
		}
		this._sortBy(order, callbackWithSorted, skipRefresh);
	},
	
	sortByArtifactModuleReuseCount: function(order, callbackWithSorted, skipRefresh) {
		this._currentSortAttrDefUri = RRMTypes.WELL_KNOWN_SAME_AS_ATTRIBUTE_NAMES.ReuseCount;
		this._currentSortOrder = order;
		var self = this;
		if (skipRefresh) {
			this.grid.header.setSortCol(ArtifactConstants.REUSEARTIFACTS_COL, order);
		}
		this._sortBy(order, callbackWithSorted, skipRefresh);
	},
	
	sortBySuspicion: function(order, callbackWithSorted, skipRefresh) {
		var suspicionProfileURIs = SuspectLinksUtil.getSuspicionProfileURIsPreference(this.projectURI);
		this._currentSortAttrDefUri = suspicionProfileURIs.length > 0 ? com.ibm.rdm.web.suspicion.model.types.SUSPECT_ENTRIES : null;
		this._currentSortOrder = order;
		var self = this;
		if (skipRefresh) {
			this.grid.header.setSortCol(ArtifactConstants.SUSPICION_COL, order);
		}
		this._sortBy(order, callbackWithSorted, skipRefresh);
	},

	_sortBy: function (order, callbackWithSorted, skipRefresh) {
		// summary:
		//		Implements the sorting function.
		if (!skipRefresh){
			this.columnChange();
		}
		
		if (order === '') {
			// if no order is set, go back to default sort order
			this._currentSortAttrDefUri = null;
		}
		
		//Internal sorting is switched off - just refresh the page.
		if (!skipRefresh) {
			this.grid.hardClear();
			this.dashboardTabPage.reloadModuleViewShape = true;
			this._triggerPageRefresh(1);
		}
	},
		
	getBaseLevelResourceURIs: function() {
		// summary:
		//		Returns the resources at the top level of the grid.

		//console.log("RSGV getBaseLevelResourceURIs");
		
		var baseUris = [];
		var resources = this.dataCache.getArrayListOfResources();
		var i;
		for (i=0; i<resources.length; i++) {
			baseUris.push(resources[i].getResourceURI());
		}
		return baseUris;
	},
	
	getCurrentLevel: function() {
		// summary:
		//		Gets the level that should be displayed for AutoExpansion.
		return this._autoExpansionLevel;
	},
	
	setCurrentLevel: function(level) {
		// summary:
		//		Sets the level that should be displayed for AutoExpansion.
		this._autoExpansionLevel = level;
	},
	
	getRules: function() {
		// summary:
		//		Gets the rules that are currently set for AutoExpansion.
		return this._autoExpansionRules;
	},
	
	setRules: function(rules) {
		// summary:
		//		Sets the rules to be used for AutoExpansion
		this._autoExpansionRules = rules;
	},
	
	setCurrentLevelAndRules: function(level, rules) {
		// summary:
		//		Sets the level that should be displayed for AutoExpansion.
		this._autoExpansionLevel = level;
		this._autoExpansionRules = rules;
	},
	
	setDrilldown: function(enabled, skipRefresh) {
		// summary:
		//		Enables drill down and actions it unless noAction is true.
		this._drillDownEnabled = enabled;
		
		var rules = dojo.clone(this._autoExpansionRules) || [];

		if (enabled) {
			this._idColumnWidth = this.grid.gridmodel.getWidth(RESOURCE_ROW, "id-col");
			this.grid.setExpandoVisibility(RESOURCE_ROW, true);
			dojo.addClass(this.domNode, "showTree");
		} else {
			this._autoExpansionLevel = -1;
			this._clearRelations(skipRefresh);
			this._autoExpansionManager.switchOff();
			this._autoExpansionRules = [];
			
			this.grid.setExpandoVisibility(RESOURCE_ROW, false);
			dojo.removeClass(this.domNode, "showTree");
		}

	},
	
	addLinkSummaryInformation: function(resourceMap) {
		// summary:
		//		Adds link existence information, even if we don't know what the details are.
		// resourceMap:
		//		A map of {resource uri -> [{linkType: <the link type uri>, linkDir: <in|out>, count: <the number>}]
		var deferred = new dojo.Deferred();
		
		var unloadedLinkTypes = [];
		var resource;
		for (resource in resourceMap) {
			var linkTypes = {objectLinks: [], subjectLinks: []};
			var resourceDetails = resourceMap[resource];
			
			if (!(resourceDetails.count && resourceDetails.count === 0)) {
				var i;
				for (i = 0; i< resourceDetails.length; i++) {					
					var linkDetails = resourceDetails[i];
					if (!this.links.getApplicableLinkType(linkDetails.linkType)) {
						unloadedLinkTypes.push(linkDetails.linkType);
					}
					
					if (linkDetails.linkDir === 'out') {
						linkTypes.objectLinks.push(resourceDetails[i].linkType);
					} else {
						linkTypes.subjectLinks.push(resourceDetails[i].linkType);
					}
				}
				this.dataCache.setLinkIndicatedRows(resource, linkTypes);
			}
		}
		
		//Make sure we have the right linkTypes
		if (unloadedLinkTypes.length > 0) {
			var self = this;
			//We have linktypes we need to load
			LinkTypeUtils.getLinkTypes(unloadedLinkTypes, this.projectURI, this.baselineURI).addCallback(function(linkTypes) {
				//Add the new linktypes
				self.typeCache.addNewLinkTypes(linkTypes);
				
				deferred.callback();
			});		
		} else {
			deferred.callback();
		}
		
		
		return deferred;
	},
	
	addRowAndLinkingInformation: function(resources, linkDetailsData, isPartialResult) {
		// summary:
		//		Adds resources and links to the RSGVs stores, ready to be used later.
		//		Need to add data to linkedResourceInfos and linkedRows, and ensure we have all the linkTypes loaded.
		// returns:
		//		A deferred to schedule subsequent actions.
		
		var deferred = new dojo.Deferred();
		
		if(isPartialResult){
			LinkUtils.getDisconnectedAssociatedProjects(this.projectURI).then(function(detailsString){
				MessageHandler.showWarning(7258, null, detailsString);
			});
		}
		
		//Add all the resources
		var i;
		for (i = 0; i < resources.length; i++) {
			var resource = resources[i];
			if (!resource.externalLink) {
				this.dataCache.setLinkedResource(resource.getResourceURI(), resource);
			}
		}
		//Ensure we have the linktypes
		var linkTypesToLoad = [];
		
		for (i = 0; i < linkDetailsData.length; i++) {
			var linkDetail = linkDetailsData[i];
			if (!this.links.getApplicableLinkType(linkDetail.linkType)) {
				linkTypesToLoad.push(linkDetail.linkType);
			}
		}
		//console.log("RSGV addRowAndLinkingInformation", linkTypesToLoad);
		
		if (linkTypesToLoad.length > 0) {
			//We have linktypes we need to load
			LinkTypeUtils.getLinkTypes(linkTypesToLoad, this.projectURI, this.baselineURI).addCallback(this, function(linkTypes) {
				this.typeCache.addNewLinkTypes(linkTypes);
				
				this._completeAddRowAndLinkingInformation(deferred, resources, linkDetailsData);
			});
		} else {
			//console.log("RSGV addRowAndLinkingInformation calling _completeAddRowAndLinkingInformation");
			this._completeAddRowAndLinkingInformation(deferred, resources, linkDetailsData);
		}
		
		return deferred;
	},
		
		
	_completeAddRowAndLinkingInformation: function(deferred, resources, linkDetailsData) {
		//console.log("RSGV _completeAddRowAndLinkingInformation", resources, linkDetailsData);

		//Now add the linkDetails
		var i, j, found;
		for (i = 0; i < linkDetailsData.length; i++) {
			var linkDetail = linkDetailsData[i];
			var toResource = resources[i];
			
			//Currently, we can get null resource whose artifact type we don't understand (only in development code, I think)
			if (toResource) {
				var toResourceObj;

				var linkTypeKey = this._buildLinkTypeSuffix(linkDetail.linkType, linkDetail.linkDir);
		//console.log("RSGV _completeAddRowAndLinkingInformation2", linkTypeKey);
				if (toResource.externalLink) {
					//An external link (and CALM links count as external here).
					toResourceObj = {type: "EXTERNAL", 
									link: {uri: toResource.uri, linkType: linkDetail.linkType, title: toResource._namedAttribs["title"], 
										linkUri: linkDetail.linkUri, "linkDetails" : linkDetail, "baselineURI" : this.baselineURI},
									otherEnd: toResource.uri};
				} else if (toResource.getProjectURI() !== this.projectURI) {
					//A link to a different project
					toResourceObj = {type: "XPROJECT", object: toResource, linkUri: linkDetail.linkUri};
				} else {
					//Just an object in the current project
					toResourceObj = {type: "INTERNAL", uri: toResource.getResourceURI(), linkUri: linkDetail.linkUri};
				}
				//console.log("RSGV _completeAddRowAndLinkingInformation3", toResourceObj);
				
				
				var linkedTypesForRow = this.dataCache.getLinkedRows(linkDetail.fromResourceURI);
				if (!linkedTypesForRow) {
					linkedTypesForRow = {};
					this.dataCache.setLinkedRows(linkDetail.fromResourceURI, linkedTypesForRow);
				}
				
				var linkTypeKeyRows = linkedTypesForRow[linkTypeKey];
				if (linkTypeKeyRows) {
					//Ensure no duplicate
					if (toResourceObj.type && toResourceObj.type === 'EXTERNAL') {
						//Need to check for duplicate external rows
						found = false;
						for (j = 0; j< linkTypeKeyRows.length; j++) {
							if (linkTypeKeyRows[j].type && linkTypeKeyRows[j].type === 'EXTERNAL' && linkTypeKeyRows[j].otherEnd === toResourceObj.otherEnd) {
								found = true;
								break;
							}
						}
						if (!found) {
							linkTypeKeyRows.push(toResourceObj);
						}
					} else if (toResourceObj.type && toResourceObj.type === "XPROJECT") {
						//Need to check for duplicate project rows
						found = false;
						for (j = 0; j< linkTypeKeyRows.length; j++) {
							if (linkTypeKeyRows[j].type && linkTypeKeyRows[j].type === "XPROJECT" && linkTypeKeyRows[j].object.getResourceURI() === toResourceObj.object.getResourceURI()) {
								found = true;
								break;
							}
						}
						if (!found) {
							linkTypeKeyRows.push(toResourceObj);
						}
					} else {
						//These are all the INTERNAL (ie RRC and same project) links.
						found = false;
						for (j = 0; j< linkTypeKeyRows.length; j++) {
							if (linkTypeKeyRows[j].type && linkTypeKeyRows[j].type === "INTERNAL" && linkTypeKeyRows[j].uri === toResourceObj.uri) {
								found = true;
								break;
							}
						}
						if (!found) {
							linkTypeKeyRows.push(toResourceObj);
						}
					}
				} else {
					linkTypeKeyRows = [toResourceObj];
					linkedTypesForRow[linkTypeKey] = linkTypeKeyRows;
				}
			}
		}
		
		deferred.callback();
	},
	
	_buildLinkTypeSuffix: function(linkTypeUri, direction) {
		// summary:
		//		Builds the right linkTypeKey for a linktype.
		// linkTypeUri:
		//		The uri of the link type.
		// direction:
		//		'in' or 'out'
		
		var linkType = this.links.getApplicableLinkType(linkTypeUri);
		var suffix = (direction === "in") ? ArtifactConstants.OBJECT_LINK : ArtifactConstants.SUBJECT_LINK;
		var linkTypeKey = null;
		
		if (linkType) {
			if (linkType.isBidirectional()) {
				suffix = ArtifactConstants.BIDIRECTIONAL_LINK;
			}
			linkTypeKey = linkType.getResourceURI()+suffix;
		} else {
			ErrorHandler.error("Unknown LinkType");
		}
		return linkTypeKey;
	},
	
	missingFromCache: function(uris) {
		//Summary: Works out which of the given URIs are missing from the cache
		var missing = [];
		
		dojo.forEach(uris, function(uri) {
			if (!this.dataCache.getRecordInfo(uri)) {
				missing.push(uri);
			}
		}, this);
		
		return missing;
	},
	
	addResourceToDataCache: function(resource) {
		//Summary: Adds the given resource to the dataCache (NOT to the line row cache though)
		this.dataCache.addResourceToDataCache(resource);
	},

	setPagedResults: function(results, currentPage, maxPages, nextPage, nextPageOffset, count) {
		// summary:
		//		Sets the grid to show the given results.
		// currentPage:
		//		The page of the results given.
		// maxPages:
		//		The total number of pages available (or -1 if not known).
		// nextPage:
		//		The next page number of results.
		// nextPageOffset:
		//		The offset to give the view service for the next page
		// count:
		//		The total number of records (undefined if not known).
		//		If both are null, assumed to be 1 page with no more available.

		//special case for creating artifacts in empty folder
		//33767: Creating an Artifact in an empty folder causes pagination to appear on top of resource viewer - IE7
		//console.log("RSGV setPagedResults", results, currentPage, maxPages);
		if (results.length === 1 && maxPages <=1) {
			maxPages = 1;
		}
		
		this._count = count;
		
		if (!currentPage && !maxPages) {
			this._pageDisplayed = 1;
			this._maxPages = 1;
		} else {
			this._pageDisplayed = currentPage || 1;
			this._maxPages = maxPages || -1;
		}

		if (currentPage === 1) {
			this._pageOffsets = {};
		}
		
		if (nextPage && nextPageOffset) {
			this._maxPages = -1;
			this._pageOffsets[nextPage] = nextPageOffset;
		} else if (this._pageOffsets[2]) {
			this._maxPages = currentPage;
		}
		
		this.dataCache.setArrayListOfResources(results);
		if (this.grid.virtualScrolling) {
			this.dataCache.addResources(results);
		}
		
		this._arrayListOfRecentArtifacts = [];
		
		var self = this;

		dojo.forEach(results, function(item) {
			if (item.getRevisionDate()){
				var dateRange = DateTimeHelper.getDateRange(item.getRevisionDate());
				if (dateRange === com.ibm.rdm.web.common.DateTimeHelper.DATE_RANGE_TYPE.Today ||
					dateRange === com.ibm.rdm.web.common.DateTimeHelper.DATE_RANGE_TYPE.Yesterday) {
					self._arrayListOfRecentArtifacts.push(item.getResourceURI());
				}
			}
		});
		this.artifactCount = results.length;
		this._reloadTypeSystem();
	},

	_reloadTypeSystem: function() {
		var self = this;
		//Reload Type System, and add the cols, then trigger any additional methods
		this._typeSystemUnloaded();
		this.typeCache.loadTypeSystem(this.projectURI, this.baselineURI, false, function () {
			//If this is a module snapshot, get details about this snapshot
			if (self._isInModuleBaseline()) {
				var moduleURI = self.dashboardTabPage.resourceViewer.getResourceObject().getResourceURI();
				if (self.dashboardTabPage.resourceViewer.isModuleArtifact) {
					moduleURI = self.dashboardTabPage.resourceViewer.owningModule;
				}
				com.ibm.rdm.web.snapshots.ModuleSnapshotServer.getSnapshotByJtsURI(moduleURI, self.baselineURI).addCallback(function (snapshot) {
					if (snapshot) {
						self.snapshotType = "module";
						self.modulesnapshot = snapshot;
						self.display.setModuleBaselineInfo(true, self.baselineURI, moduleURI, snapshot.createdOn);
						
						self._addAdditionalCols();
						self._typeSystemLoaded();						
					} else {
						//We are in a project snapshot displaying a module
						//Now lets get project baselines as well
						var pbDeferred = com.ibm.rdm.web.common.ProjectCache.getProjectSnapshot(self.baselineURI);
						
						pbDeferred.addCallback(self, function(pbSnapshot){
							self.snapshotType = "project";
							self.projectsnapshot = pbSnapshot;
							self.display.setModuleBaselineInfo(true, self.baselineURI, moduleURI, pbSnapshot.updated);
							
							self._addAdditionalCols();
							self._typeSystemLoaded();
							return pbSnapshot;
						});
					}
				});
			} else {
				self._addAdditionalCols();
				self._typeSystemLoaded();
			}
		});
	},
	
	_typeSystemUnloaded: function() {
		this._isTypeSystemLoaded = false;
	},
	
	_isInModuleBaseline: function() {
		return this.baselineURI && this.dashboardTabPage && this.dashboardTabPage.resourceViewer && 
				( this.dashboardTabPage.resourceViewer.isModule || this.dashboardTabPage.resourceViewer.isModuleArtifact);
	},

	_typeSystemLoaded: function() {
		// summary:
		//		Deals with any functions deferred until the type system has been loaded.
		this._isTypeSystemLoaded = true;

		dojo.forEach(this._typeSystemDeferredFunctions, function(fnToCall) {
			fnToCall();
		});
		this._typeSystemDeferredFunctions = [];
	},

	_addTypeSystemDeferredFunction: function(fnToCall) {
		if (this._isTypeSystemLoaded === true) {
			fnToCall();
		} else {
			this._typeSystemDeferredFunctions.push(fnToCall);
		}
	},
	
	_addNextLoadDeferredFunction: function(fnToCall) {
		this._nextLoadDeferredFunctions.push(fnToCall);
	},
	
	_nextLoad: function() {
		// summary:
		//		Deals with any functions deferred until the type system has been loaded.

		dojo.forEach(this._nextLoadDeferredFunctions, function(fnToCall) {
			fnToCall();
		});
		this._nextLoadDeferredFunctions = [];
	},


	///////////////////////////////////////////////////////////////////////////////////////////////
	//// Type System Stuff, and additional columns.


	_addAdditionalCols: function () {

		var self = this;
		//Allow Grouping by Artifact Type
		if (!this.grid.hasGrouping(this.groupSort.GROUP_TYPE)) {
			this.groupSort.addGroupByType();

			this.projectButtonAndMenuActions.addGrouping(this.groupSort.GROUP_TYPE, this._messages.groupByType, function () {
				self.groupByType();
			});
		}

		var count=0;
		//Now Add all the attribute value columns
		var projAttrDef = [], attributeURI;
		for (attributeURI in this.typeCache.getUserDefinedProjectAttributeDefinitions()) {
			projAttrDef.push(attributeURI);
		}

		dojo.forEach(projAttrDef, function (attributeURI) {
			var attrDef = self.typeCache.getProjectAttributeDefinition(attributeURI);
			if (attrDef) {
				var attrType = attrDef.getAttributeType();
				var description = attrDef.getDescription();

				var col = {
					name: DomUtils.getHTMLEncodedText(attrDef.getTitle()),
					width: 60,
					isVisible: false,
					showFullTitleOnHover: true
				};
				//var colname = DomUtils.getHTMLEncodedText(attrDef.getTitle().replace(/[ ,]/gi, "-"));
				//var colId = DomUtils.getHTMLEncodedText(attrDef.getResourceURI());
				var resId = attrDef.getResourceURI();
				//var reqEx = new RegExp("[:/]","gi");
				//var colId = DomUtils.getHTMLEncodedText(resId.replace(reqEx, "-"));
				var i = resId.lastIndexOf("/");
				var colId = '-' + resId.substring(i+1);
				//Work out the display function
				//Set sorting and grouping options
				var sortable = true;
				
				if (attrType.getValueType() === RRMTypes.ATTRIBUTE_TYPES.UserType) {
					sortable = false;
				}

				var groupable = (attrType.isEnum() && !attrDef.isMultiValued()) ||
								(attrType.getValueType() === RRMTypes.ATTRIBUTE_TYPES.BooleanType) ||
								(attrType.getValueType() === RRMTypes.ATTRIBUTE_TYPES.DateType) ||
								(attrType.getValueType() === RRMTypes.ATTRIBUTE_TYPES.DateTimeType);
								
				var searchable = (attrType.getValueType() === RRMTypes.ATTRIBUTE_TYPES.StringType);

				//Set the sorting function if applicable
				if (sortable) {
					col.sortFunction = function(order, callback) { self.sortByDef(attributeURI, order, callback); };
				}

				//Set the grouping functionality if applicable
				if (groupable) {
					var attrName = DomUtils.getHTMLEncodedText(attrDef.getTitle());
					self.projectButtonAndMenuActions.addGrouping(
						attributeURI,
						dojo.string.substitute(self._messages.groupBy, [attrName]),
						function () {
							self.groupByDef(attributeURI);
						}
					);
				}
				
				//Set the searching functions
				if (searchable) {
					col.findMarkAllNext = function (key, searchTerm, markClassName) {
						self.display.findMarkAllNext(key, colId, searchTerm, markClassName);
					};
					col.findMarkAllPrev = function (key, searchTerm, markClassName) {
						self.display.findMarkAllPrev(key, colId, searchTerm, markClassName);
					};
					
					col.nextFind = function (key, selectClassName, replaceClassName, done, noMore) {
						self.display.nextFind(key, colId, selectClassName, replaceClassName, done, noMore);
					};
					
					col.prevFind = function (key, selectClassName, replaceClassName, done, noMore) {
						self.display.prevFind(key, colId, selectClassName, replaceClassName, done, noMore);
					};
					
					col.replaceFind = function (key, replaceTerm, replaceClassName, findClassNames, onDone) {
						self.display.replaceFind(key, colId, replaceTerm, replaceClassName, findClassNames, onDone);
					};
					
					col.getFindReplaceOccurrences = function (key) {
						return self.display.getFindReplaceOccurrences(key, colId);
					};
					
					col.getCurrentFindNode = function (key) {
						return self.display.getCurrentFindNode(key, colId);
					};
									
					col.clearFind = function (key) {
						self.display.clearFind(key, colId);
					};
				}

				//Set the value functions
				col.isReallyEditable = function(rowTypeId, columnId, key, uri) {return self.edit.isReallyEditable(rowTypeId, columnId, key, uri);};
				if (!this.baselineURI) {
					col.invokeEditFunction = function(rowTypeId, columnId, key, uri, cellNode, eventNode, refreshRow) {
						return self.edit.invokeEdit(rowTypeId, columnId, key, uri, refreshRow);
					};
				}
				col.deferredContentFunction = function (functionToCall, resource, key, containerNode, indent, columnId) {
					self.edit.getEditableValue(resource.getResourceURI(), attributeURI, functionToCall, resource, attrType, containerNode, columnId);
				};
				
				if (attrType.getValueType() === RRMTypes.ATTRIBUTE_TYPES.UserType) {
					col.navModeActionFunction = dojo.hitch(self.display, self.display.doUserNavModeAction);
				}
				
				col.isUnderEditFunction = function(rowTypeId, columnId, key, uri){
					return self.edit.isUnderEdit(uri, attributeURI);
				};
				
				col.focusOnEditorFunction = dojo.hitch(self.edit, self.edit.focusOnEditor, attributeURI);
				
				//Ensures the column has custom data of type = "A".
				col.custom = {
					type: "A",
					uri: attributeURI,
					desc: description
				};


				if (!self.grid.hasCol(RESOURCE_ROW, colId)) {
					self.grid.addColumn(RESOURCE_ROW, colId, col);
					self.display.mapColumn(colId, self.display.ATTRIBUTE_COL, attributeURI);
				}
			} else {
				console.error("Cannot find AttributeDef for ",attributeURI);
			}
		});
	},


	///////////////////////////////////////////////////////////////////////////////////

	getGroupLabel: function() {
		return this._groupLabel;
	},

	//getSortOrder: function() {
	//	return this._sortOrder;
	//},

	getRecentlyCommentedToggleState: function() {
		return this._isRecentCommentedHighlighted;
	},

	getRecentlyModifiedToggleState: function() {
		return this._isRecentArtifactsHighlighted;
	},

	addResultURIs: function(resultUris, requestedAttributeUris, orderByAttributes, isCoreView) {
		// summary:
		//		Adds the items whose uri is indicated by the passed in array to the end of the page.
		// resultUris:
		//		An Array of items with a 'resourceURI' property.
		//		Load the resources


		//Calculate the query
		var artifactUris = [];
		for (var i = 0; i < resultUris.length; i++) {
			artifactUris.push(resultUris[i].resourceURI);
			this._arrayListOfNewlyCreatedArtifacts.push(resultUris[i].resourceURI);
		}

		var deferred = ViewServiceClient.getViewContents({
			artifactUris: artifactUris,
			requestedAttributeUris: requestedAttributeUris,
			orderBy: orderByAttributes,
			projectURI: this.projectURI,
			processLockInfo: true,
			isCoreView: isCoreView
		});

		deferred.addCallback(dojo.hitch(this, function (response) {
			var result = ViewServiceClient.parseViewContentsResponse(response, this.projectURI, {}, false);
			var resources = result.resources;

			dojo.forEach(resources, function(item) {
				this.addResult(item, false, false);
			}, this);
			return response;
		}));
		return deferred;
	},

	addResults: function(results) {
		// summary:
		//		Adds the results to the end of the current page
		// results:
		//		An array of Requirements.
		var array = this.dataCache.getArrayListOfResources();
		dojo.forEach(results, function(item) {
			array.push(item);
			this._arrayListOfNewlyCreatedArtifacts.push(item.getResourceURI());
		}, this);

		this.setPagedResults(array, this._pageDisplayed, this._maxPages);
		
		this.showArtifacts();
	},

	addResult: function(
		resource, enableEditInGrid, enableFocusInGrid,
		/*String?*/where, /*String*/relativeSiblingURI)
	{
		// summary:
		//		Adds a single resource to the grid.
		// resource: Object
		//		The full resource to be added.
		// enableEditInGrid: Boolean
		//		true if the resource should be placed in edit mode on the grid
		//		(note: if this parameter is passed, enableFocusInGrid will be
		//		ignored).
		// enableFocusInGrid: Boolean
		//		true if the resource should be given focus in the grid
		//		(note: if this parameter is passed, it's assumed that
		//		enableEditInGrid is not _also_ passed).
		// where: String?
		//		One of the values (BELOW, BEFORE, AFTER and LAST) found in
		//		com.ibm.rdm.web.model.resources.modules.ModuleStructure.
		// relativeSiblingURI: String?
		//		Should only be passed if the 'where' clause is BELOW, BEFORE or
		//		AFTER (as LAST is with regard to the module itself rather than
		//		some other row).

		// if we are showing a module, new artifacts go at the very end of the module.
		if (this._viewType === com.ibm.rdm.web.project.DashboardConstants.VIEW_TYPES.MODULE) {
			var createNewRequirementDeferred = new dojo.Deferred();
			var lastItemInModule = this.moduleStructure.getLast();
			var args = {
				resources: [resource],
				where: where,
				targetURI: relativeSiblingURI,
				//callback: dojo.hitch(this.commands, this.commands._insertRowsIntoModuleGrid),
				deferred: createNewRequirementDeferred,
				forceStructureVersionLoad: true
			};
			//com.ibm.rdm.web.project.EditManager.startEdit(this.projectURI, resource.resourceURI, RRMTypes.getPrimaryTextURI(this.projectURI))
			var listener = ChangeNotifier.addListener({
				eventTopic: com.ibm.rdm.web.notifications.EventTopics.MODULE_GRID_RECONCILED,
				callbackFunction: function () {
					ChangeNotifier.removeListener(listener);
					this.grid.scrollIntoView(resource.resourceURI, dojo.hitch(this, function () {
						var row = this.grid.getRowByKey(resource.resourceURI);
						if (row && row.node) {
							// Highlight the row for a short time.
							dojo.addClass(row.node, "justPasted");
							setTimeout(function(){
								dojo.removeClass(row.node, "justPasted");
							}, ArtifactConstants.MODULE_HIGHLIGHT_TIMEOUT);
							if (enableEditInGrid) {
								// Start a cell editor on the row.
								var rowIds = {};
								rowIds[resource.resourceURI] = RESOURCE_ROW;
								setTimeout(dojo.hitch(this, this._editRow, rowIds, /*editPreferredColumn*/true, /*inModule*/true), 100);
							}
							else if (enableFocusInGrid) {
								// Move focus to a cell on the row.
								this.grid.moveFocusToCellOnRow(resource.resourceURI);
								this.grid.focus();
							}
						}
						
					}));
				},
				callbackScope: this
			});

			this.moduleStructure.placeChildren(args).then(dojo.hitch(this, function () {
				StatusDisplay.hideStatusMessage();	
			}));
			
			return createNewRequirementDeferred;
		}
		
		var array = this.dataCache.getArrayListOfResources();
		array = [resource].concat(array);
		this.dataCache.addResource(resource);
		this._arrayListOfNewlyCreatedArtifacts.push(resource.getResourceURI());
		this.setPagedResults(this.dataCache.getArrayListOfResources(), this._pageDisplayed, this._maxPages);

		if (array.length === 1) {
			//Must be the one we added - so redraw to get rid of message
			this.grid.hardClear();
		}

		//Insert this new artifact at the top, WITHOUT provoking a redraw of the entire grid.
		var inModule =  this._viewType === com.ibm.rdm.web.project.DashboardConstants.VIEW_TYPES.MODULE;
		if (!inModule) {
			this.grid.insertRow(null, resource.getResourceURI(), RESOURCE_ROW);
		}
		this.artifactCount = this.dataCache.getArrayListOfResources().length;
		this.updateNumArtifacts(this.artifactCount);
		
		if (enableEditInGrid) {
			//console.log("RSGV addResult", resource, enableEditInGrid, this.dataCache.getArrayListOfResources());
			var rowIds = {};
			rowIds[resource.getResourceURI()] = RESOURCE_ROW;
			setTimeout(dojo.hitch(this, this._editRow, rowIds, true, inModule), 100);
		}
		this._artifactCountAdjuster++;
	},
	
	_getResources: function(resourceUris, fnToCall) {
		// summary:
		//		Gets the resources requested, and call the function with an array of them.

		var self = this;
		//Load the resources

		//Calculate the query

		var deferred = ViewServiceClient.getViewContents({artifactUris: resourceUris, processLockInfo: true});

		deferred.addCallback(function (response) {
			var result = ViewServiceClient.parseViewContentsResponse(response, self.projectURI);
			var resources = result.resources;

			fnToCall(resources);
			return resources;
		});
	},
	
	//TODO: rewrite this once module supports it
	_getBatchFullResources: function(resourceUris, fnToCall, withEditLock, withChangeTypeLock, onDialogClose, anyDeniedPermission) {
		// summary:
		//		Gets the resources requested, and call the function give with:
		//		    1) ((withEditLock||withChangeTypeLock) is false) an array of the got resources.
		//			2) ((withEditLock||withChangeTypeLock) is true) an object with 
		//				{resources: an array of the got resource that we locked, 
		//				 lockURIMap: a map of resourceURI -> URI the lock was obtained on. If the resourceURI was used (ie not in a module), then the map will be empty }.
		// withEditLock:
		//		If true, will attempt to get a lock on all.
		//		Only locked ones will be returned; will return [] if none could be locked.
		//		Note: If this is passed as true, withChangeTypeLock must be passed as false.
		// withChangeTypeLock:
		//		If true, will attempt to get a lock on all.
		//		Only locked ones will be returned; will return [] if none could be locked.
		//		Note: If this is passed as true, withEditLock must be passed as false.
		// anyDeniedPermission:
		//		Pass as true if any of the original resources requested have been denied
		//		because of permissions issues.
		
		if (withEditLock || withChangeTypeLock) {
			var messageHandler = StatusDisplay.showStatusMessage(this._messages.lockingArtifact, true);
			var baseURIs = [];
			var baseURIMap = {};
			
			if (this._viewType === com.ibm.rdm.web.project.DashboardConstants.VIEW_TYPES.MODULE) {
				//For a module, we need to lock the underlying base artifacts
				dojo.forEach(resourceUris, function(resourceURI) {
					var baseURI = this.dataCache.getBaseArtifactForResource(resourceURI);
					baseURIs.push(baseURI);
					baseURIMap[resourceURI] = baseURI;
				}, this);
			} else {
				baseURIs = resourceUris;
			}
			
			var lockResourcesDeferred = LockManager.lockResources(baseURIs);
			lockResourcesDeferred.addCallback(this, function(results) {					
				StatusDisplay.hideStatusMessage(messageHandler);
				var message = null, dialogStyle;
				var lockedResourcesKeys = [], lockedResourcesUris = [];
				if (results.allFailed) {
					//We got none - tell the user{
					if (anyDeniedPermission) {
						//If some are already denied, must have been more than one!
						message = (
							withEditLock ?
							this._messages.eaLockAllFailedNplusDenied :
							this._messages.ctLockAllFailedNplusDenied
						);
					} else {
						if (resourceUris.length === 1) {
							message = (
								withEditLock ?
								this._messages.eaLockAllFailed1 :
								this._messages.ctLockAllFailed1
							);
						} else { 						
							message = (
								withEditLock ?
								this._messages.eaLockAllFailedN :
								this._messages.ctLockAllFailedN
							);
						}
					}
					dialogStyle = "ok";
				} else if (results.allLocked) {
					//We got all (were some denied?)
					if (anyDeniedPermission) {
						var count = baseURIs.length;
						message = dojo.string.substitute(
							(
								withEditLock ?
								this._messages.eaLockSomeFailedNonlyDenied :
								this._messages.ctLockSomeFailedNonlyDenied
							),
							[count]
						);
						dialogStyle = "yesNo";
					}				
					lockedResourcesKeys = resourceUris;
				} else {
					//Some failed, some didn't
					//Remember the ones we got.
					dojo.forEach(resourceUris, function(resourceUri) {
						//Lookup URI is the base artifact, if it exists, default to the artifact URI.
						var lookupURI = baseURIMap[resourceUri] || resourceUri;
						if (results.results[lookupURI].obtained) {
							lockedResourcesKeys.push(resourceUri);
							lockedResourcesUris.push(lookupURI);
						}
					});
					var count = lockedResourcesKeys.length;
					if (anyDeniedPermission) {
						message = dojo.string.substitute(
							(
								withEditLock ?
								this._messages.eaLockSomeFailedNplusDenied :
								this._messages.ctLockSomeFailedNplusDenied
							),
							[count]);
					} else {
						message = dojo.string.substitute(
							(
								withEditLock ?
								this._messages.eaLockSomeFailedN :
								this._messages.ctLockSomeFailedN
							),
							[count]
						);
					}

					dialogStyle = "yesNo";
				}
				
				var okFunc = dojo.hitch(this, function() {
					if(lockedResourcesKeys.length > 0) {
						var resourcePropertiesArray = [];
						for (var i=0; i<lockedResourcesKeys.length; i++) {
							resourcePropertiesArray.push({uri: lockedResourcesKeys[i]});
						}
						ResourceManager.multiGet(resourcePropertiesArray, this.projectURI, dojo.hitch(this, function(resources){
							fnToCall({resources: resources, lockURIMap: baseURIMap});
						}));
					}
				});
				
				if (message) {
					var msgForm = new com.ibm.rdm.web.common.MessageForm({
						confirmMessage: message,
						dialogTitle: this._artifactCommandsMessages.notifyLocks,
						dialogWidth: "350px",
						dialogStyle: dialogStyle,
						//onDialogOpen: dojo.hitch(this, function() {
						//	dojo.fadeIn({node: clearSuspicionForm.domNode, duration: 400}).play();
						//}),
						onOk: okFunc,
						onCancel: dojo.hitch(this, function() {
							LockManager.releaseLockedResources(lockedResourcesUris);
							fnToCall({resources: [], lockURIMap: {}});
							StatusDisplay.hideStatusMessage();
						})
					});
					msgForm.show(onDialogClose);
				} else {
					//No message - we got all. Just execute the okFunc
					okFunc();
				}
			});
			lockResourcesDeferred.addErrback(this, function(e) {
				StatusDisplay.hideStatusMessage(messageHandler);
			});
		} else {
			//Load the resources
			//convert uris to map
			var resourcePropertiesArray = [];
			for (var i=0; i<resourceUris.length; i++) {
				resourcePropertiesArray.push({uri: resourceUris[i]});
			}
			ResourceManager.multiGet(resourcePropertiesArray, this.projectURI, dojo.hitch(this, function(resources){
					fnToCall(resources);
			}));
		}
	},

	_createRowIds: function(artifactURI) {
		var rowIds = {};
		rowIds[artifactURI] = RESOURCE_ROW;
		return rowIds;
	},

	_getPromoteEnablementDeferred: function(artifactURI) {
		return this.commands.getOutdentEnablementDeferred(this._createRowIds(artifactURI), 1);
	},
	
	_getDemoteEnablementDeferred: function(artifactURI) {
		return this.commands.getIndentEnablementDeferred(this._createRowIds(artifactURI), 1);
	},

	_promoteArtifact: function(artifactURI) {
		return this.commands.executeModuleOutdent(this._createRowIds(artifactURI));
	},

	_demoteArtifact: function(artifactURI) {
		return this.commands.executeModuleIndent(this._createRowIds(artifactURI));
	},

	setCLMFilters: function(clmFilters) {
		this.links.setCLMFilters(clmFilters);
	},

	_showMessage: function(messageToDisplay) {
		StatusDisplay.hideStatusMessage();
		
		this._isMessageDisplayed = true;
		this.dataCache.setArrayListOfResources([]);

		this._pageDisplayed = -1;
		this._maxPages = -1;
		this.grid.showMessage(messageToDisplay);
	},

	getNumArtifacts: function(num) {
		if (this.dataCache) {
			return this.dataCache.getArrayListOfResources().length;
		}
		return 0;
	},
	
	updateNumArtifacts: function(num, count) {
		// Update the number of artifacts in the project header
		if (count) {
			// Reset temporary artifact count adjuster upon page refresh
			if (this._pageToDisplay === 1) {
				this._artifactCountAdjuster = 0;
			}
			count = (parseInt(count, 10) + this._artifactCountAdjuster).toString();
			if (num === 1) {
				this.numArtifacts.innerHTML = dojo.string.substitute(this._messages.showingOneWithCount, [count]);
			} else {
				this.numArtifacts.innerHTML = dojo.string.substitute(this._messages.showingNWithCount, [num, count]);
			}	
		} else {
			if (num === 1) {
				this.numArtifacts.innerHTML = this._messages.showingOne;
			} else {
				this.numArtifacts.innerHTML = dojo.string.substitute(this._messages.showingN, [num]);

				// clear selection
				this.setNumSelected(0);
			}
		}
	},

	_handleResourceContextClicked: function (event) {
		ResourceLinksHandler.handleAnchorContextMenuClicked(event);
	},

	_handleManagedReqClicked: function (event) {
		event.preventDefault();
		event.stopPropagation();
		window.open( (dojo.isIE ? event.srcElement.href : event.target.href) );
	},	


	_displayRelationsDialog: function() {
		var rules = this.projectButtonAndMenuActions.getAdvancedRules() || [];
		
		var expansionDialog = new LinkExpansionDialog({
			projectURI: this.projectURI,
			originalRules: rules
		});

		expansionDialog.show();
		expansionDialog.startup();
		
		this.connect(expansionDialog, "onApply", dojo.hitch(this, function (rules) {
			//Pass the rules to the AutoExpansionManager
			this._autoExpansionManager.setDesiredState(this._autoExpansionLevel, rules);
			this.projectButtonAndMenuActions.setAdvancedRules(rules);
		}));
	},
	
	_findArtifactsToRefresh: function(links) {
		// summary:
		//		Finds the artifacts in the current grid that need to be refreshed because the specified links have changed (created/deleted).
		// links:
		//		Used to find relevant artifacts.  An array containing Link objects (com.ibm.rdm.web.links.Link)
		// returns:
		//		Creates a hash containing:
		//		{
		//			needsRefresh: true if the grid needs to refresh at all
		//			refreshArtifacts: an array that contains all artifacts (in the current grid) that need to be refreshed
		//		}
		
		//Is the link type displayed in a column? if so indicate a refresh is needed.
		var cols = this.grid.getUserCols(RESOURCE_ROW);
		var colDetails=[];
		dojo.forEach(cols, function (userCol) {
			colDetails.push(this.display.getDetailsByColId(userCol.colId));		
		}, this);
		
		var needsRefresh = false;
		var refreshArtifacts = [];
		
		var i;
		for (i=0; i < links.length; i++) {
			var link = links[i];
			var linkTypeURI = link.getLinkType();
			var linkType = this.links.getApplicableLinkType(linkTypeURI);
			var isCalmLink = LinkTypeUtils.isCalmLink(linkType.getSameAs());
			var j;
			for (j = 0; j < colDetails.length; j++) {
				//Need to check all the directions of links
				var colURL = colDetails[j].key;
				if(isCalmLink){
					//If it is a calm link we need to do it slightly differently.
					var calmLinkTypeURI = linkType.getSameAs();
					var calmURI = ArtifactConstants.CalmLinkColToTypeURI[colURL];
					if(calmURI && (calmURI === calmLinkTypeURI)) {
						if(link.getSubject()){
							//the RRC link is always the subject of a calm link.
							//We need a page refresh
							needsRefresh = true;
							var uri = link.getSubject();
							if(dojo.indexOf(refreshArtifacts, uri) === -1){
								refreshArtifacts.push(uri);
							}
						}
					}
				} else if (colURL &&
				(colURL === linkTypeURI + ArtifactConstants.SUBJECT_LINK || 
				colURL === linkTypeURI + ArtifactConstants.BIDIRECTIONAL_LINK  || 
				colURL === linkTypeURI + ArtifactConstants.OBJECT_LINK)) {
					//We need a page refresh
					needsRefresh = true;
					var uri = null;
					//add relevant artifacts to list of artifacts to refresh
					if(colURL === linkTypeURI + ArtifactConstants.OBJECT_LINK){
						if(link.getObject()){
							uri = link.getObject();
							if(dojo.indexOf(refreshArtifacts, uri) === -1){
								refreshArtifacts.push(uri);
							}
						}
					}else if(colURL === linkTypeURI + ArtifactConstants.SUBJECT_LINK ){
						if(link.getSubject()){
							uri = link.getSubject();
							if(dojo.indexOf(refreshArtifacts, uri) === -1){
								refreshArtifacts.push(uri);
							}
						}
					}else if(colURL === linkTypeURI + ArtifactConstants.BIDIRECTIONAL_LINK){
						if(link.getObject()){
							uri = link.getObject();
							if(dojo.indexOf(refreshArtifacts, uri) === -1){
								refreshArtifacts.push(uri);
							}
						}
						if(link.getSubject()){
							uri = link.getSubject();
							if(dojo.indexOf(refreshArtifacts, uri) === -1){
								refreshArtifacts.push(uri);
							}
						}
					}
				}
			}
		}
		return {needsRefresh: needsRefresh, refreshArtifacts: refreshArtifacts};
	},
	
	_handleLinkRefresh: function(links) {
		// summary:
		//		Handles Refreshing of Artifacts in the current Grid.
		// links:
		//		Used to find relevant artifacts.  An array containing Link objects (com.ibm.rdm.web.links.Link)

		var needsRefresh = false;
		
		var refreshHash = this._findArtifactsToRefresh(links);
		var refreshArtifacts = refreshHash.refreshArtifacts;
		needsRefresh = refreshHash.needsRefresh;
		
		if (this._viewType === com.ibm.rdm.web.project.DashboardConstants.VIEW_TYPES.MODULE) {
			// if the thing to be refreshed is being edited, the user
			// has created a content link - we don't want to actually refresh as this 
			// will remove the current editor and replace it
			for (var i = 0; i < refreshArtifacts.length && needsRefresh; i++) {
				if (EditManager.isArtifactUnderEdit(this.projectURI, refreshArtifacts[i])) {
					needsRefresh = false;
				}
			}
		}
		
		//If we need to refresh at this point it's because a relevant Link Col is in the grid, so instead of
		//	refreshing the entire grid, just refresh the relevant artifacts.
		if(needsRefresh){
			if(refreshArtifacts.length > 0){
				this.refreshArtifacts(refreshArtifacts);
			}
			needsRefresh = false;
		}
	},

	/////////////////////////////////////////////////
	// Event Handler functions

	_onLinkCreate: function(eventParams) {
		// summary:
		//		Reacts to the creation of a link.  Refresh relevant rows (if link col is shown, and artifact is in grid, unless drill down (tree view) is
		//		enabled, then refresh entire page.
		
		if (this._drillDownEnabled) {
			//If we are showing expanded links, refresh
			this._triggerPageRefresh(this._pageToDisplay);
			return;
		}
		
		var links = eventParams && eventParams.notifierParams && eventParams.notifierParams.links;
		this._handleLinkRefresh(links);
		
	},
	
	_onLinkDelete: function(eventParams) {
		// summary:
		//		Reacts to the deletion of a link.  Refresh relevant rows (if link col is shown, and artifact is in grid, unless drill down (tree view) is
		//		enabled or the link deleted is invalid, then refresh entire page.
		var link = eventParams && eventParams.notifierParams && eventParams.notifierParams.link;
		var direction = eventParams && eventParams.notifierParams && eventParams.notifierParams.direction;
		
		if (this._drillDownEnabled) {
			//If we are showing expanded links, refresh
			this._triggerPageRefresh(this._pageToDisplay);
			return;
		}
		if(direction === null){
			//Invalid Link, refresh entire grid
			this._triggerPageRefresh(this._pageToDisplay);
			return;
		}
		
		var artifactInRow = null;
		var linkedArtifact = null;
		var linkTypeKey = null;
		var otherLinkTypeKey = null;
		
		//The cache is setup to check for the artifact in the row (not the artifacts in the link columns)
			//Depending on the linkTypeKey we can determine the proper artifact to update in the cache
		if(direction === ArtifactConstants.OBJECT_LINK){
			artifactInRow = link.getObject();
			linkedArtifact = link.getSubject();
			linkTypeKey = link.getLinkType() + ArtifactConstants.OBJECT_LINK;
			otherLinkTypeKey = link.getLinkType() + ArtifactConstants.SUBJECT_LINK;
		}
		else if (direction === ArtifactConstants.SUBJECT_LINK){
			artifactInRow = link.getSubject();
			linkedArtifact = link.getObject();
			linkTypeKey = link.getLinkType() + ArtifactConstants.SUBJECT_LINK;
			otherLinkTypeKey = link.getLinkType() + ArtifactConstants.OBJECT_LINK;
		} else {
			artifactInRow = link.getObject();
			linkedArtifact = link.getSubject();
			linkTypeKey = link.getLinkType() + ArtifactConstants.BIDIRECTIONAL_LINK;
			otherLinkTypeKey = link.getLinkType() + ArtifactConstants.BIDIRECTIONAL_LINK;
		}
		
		if(link){
			//Update Cache (both sides of the link)
			this.dataCache.removeLinkFromRow(artifactInRow, linkTypeKey, linkedArtifact);
			this.dataCache.removeLinkFromRow(linkedArtifact, otherLinkTypeKey, artifactInRow);
			this._handleLinkRefresh([link]);
		} else {
			//We do not have the link information, and need to refresh the entire page.
			this._triggerPageRefresh(this._pageToDisplay);
		}
	},
	
	_onDMLinkActions: function(eventParams) {
		// summary:
		//		Reacts to the deletion of a link.
		//		At the moment, the coursest refresh page strategy is taken.
		this._triggerPageRefresh(this._pageToDisplay);
	},
	_onCommentsChangedNotify: function(event) {
		// summary:
		//		If the comments column is showing, update the row to reflect a state change in the icon.

		if (this.grid.isColumnShowing(ArtifactConstants.COMMENTS_COL)) {
			var uri = event.notifierParams.resourceUriScope;
			var found = this.dataCache.getResourceByUri(uri);
			if (!found && this.dashboardTabPage.showBaseProperties) {
				var resources = this.dataCache.getArrayListOfResources();
				for (var i=0; i<resources.length; i++) {
					if (resources[i].getBoundArtifact() === uri) {
						found = resources[i];
						break;
					}
				}
			}
			// we're just notified that comments have changed, so either a comment will have been added or updated,
			// refresh based on potential state change
			if (found) {
				if (found.getRecentCommentCount && (found.getRecentCommentCount() === 0))  {
					// handle going from non-recent to recent state
					this._refreshResources([found.resourceURI], dojo.hitch(this, function () {
						var refresh = [{key: found.resourceURI, rowtype: RESOURCE_ROW}];
						this.grid.refreshRows(refresh);
					}));
				} 
			} 
		}
	},
	
	_onShowBasePropertiesNotify: function(event) {
		this._showBaseProperties = event.notifierParams.show;
		// TO DO: Maybe we can find a more efficient way of loading base properties instead of
		//refreshing the page.

		this.grid.module.moduleStructure = this.moduleStructure;
		this.grid.prepareRestoreValues(); 
		this.grid.isRefresh = true;
		this.grid.hardClear();
		this.resetPageToDisplay();
		
		this.dashboardTabPage.showBaseProperties=this._showBaseProperties;
		this.display.setShowBaseProperties(this._showBaseProperties);
		this._triggerPageRefresh(this._pageToDisplay);
	},
	
	_onModuleCountChangedNotify: function(event) {
		// Reset artifact count adjuster as the total artifact count is already updated
		this._artifactCountAdjuster = 0;
		this.updateNumArtifacts(this.moduleStructure.getCurrentArtifactCount(), this.moduleStructure.getTotalArtifactCount());
		
		// Clear selection.
		this.setNumSelected(0);
	},

	_onResourceDelete: function(eventParams) {
		var resourseURIdeleted = eventParams.notifierParams.resourceURI;
		
		//ignore self-deletion
		if (resourseURIdeleted === this.resourceURI) {
			return;
		}

		//It may be one of the linked artifacts
		var isLinked = this.dataCache.getLinkedResource(resourseURIdeleted);
		if (isLinked) {
			//need to refresh entire page
			ChangeNotifier.notifyListeners({
				eventTopic: com.ibm.rdm.web.notifications.EventTopics.PAGE_DEFINITION_CHANGE,
				projectURI: this.projectURI,
				resourceUriScope: this.resourceURI
			});
		} else {
			//Check we have that resource in the main rows
			var found = this.dataCache.getResourceByUri(resourseURIdeleted);

			if (found) {
				this.grid.deleteRow(resourseURIdeleted, true);
				// TODO: fixme
				this.dataCache.setArrayListOfResources(dojo.filter(this.dataCache.getArrayListOfResources(), function (item) {
					return (item.getResourceURI() !== resourseURIdeleted);
				}));
				this.artifactCount = this.dataCache.getArrayListOfResources().length;
			}
			if (this.moduleStructure) {
				if (eventParams.notifierParams.isMultiple) {
					if (eventParams.notifierParams.deletedIdx === eventParams.notifierParams.deletedCount) {
						this.moduleStructure.removeItem(resourseURIdeleted, true);
					} else {
						this.moduleStructure.removeItem(resourseURIdeleted, false);
					}
				} else {
					this.moduleStructure.removeItem(resourseURIdeleted, true);
				}
			}
			else {
				if (this.artifactCount > 0) {
					this.updateNumArtifacts(this.artifactCount);
				} else {
					// All artifacts on the page have been deleted, so refresh the page to ensure that it is
					// not left blank and with no paging control if there are some artifacts that could be displayed.
					var pageToRefresh = this._pageToDisplay;
					if (this._maxPages > -1) {
						if (pageToRefresh === this._maxPages) {
							// We were at the last page and all artifacts have been removed from it, so best we can do is
							// refresh the previous page.
							pageToRefresh--;
							if (pageToRefresh < 1) {
								pageToRefresh = 1;
							}
						}
						// And since a whole page has been removed, update _maxPages to reflect that, so that after the refresh
						// the page control is less likely to have a bad last page link.
						this._maxPages = (this._maxPages - 1) || -1;
					}
					this._triggerPageRefresh(pageToRefresh);
				}
			}
		}
		this._artifactCountAdjuster--;
	},
	
	////////////////////////////////////////////////////////////////
	// Navigation Handlers - for controlling clicking away
	
	registerNavigateHandlers: function() {
		this._handleNavigateEvent = dojo.hitch(this, this.navigateAwayEvent);
		this._handleBodyClickEvent = dojo.hitch(this, this.clickNavigateAwayEvent);
		this._puiOnBeforeUnloadHandle = PlatformUI.getWorkbench().registerOnBeforeUnloadHandler(this._handleNavigateEvent, 10000);
		this._puiBodyClickHandle = PlatformUI.getWorkbench().registerBodyClickHandler(this._handleBodyClickEvent, 10000);
	},
	
	unregisterNavigateHandlers: function() {
		PlatformUI.getWorkbench().unregisterOnBeforeUnloadHandler(this._puiOnBeforeUnloadHandle);
		PlatformUI.getWorkbench().unregisterBodyClickHandler(this._puiBodyClickHandle);
		
		this._puiBodyClickHandle = null;
		this._puiOnBeforeUnloadHandle = null;
		this._handleNavigateEvent = null;
		this._handleBodyClickEvent = null;
	},

	navigateAwayEvent: function() {
		return this._editorsInGrid ? this._messages.unsavedNavigateConfirm : false;
	},
	
	clickNavigateAwayEvent: function(urlObject) {
		
		if (urlObject 
			&& urlObject.scheme
			&& urlObject.scheme.indexOf("javascript") >= 0) {
				// WI: 37988, the source of this "navigate away" event
				// will be a CK Editor dialog, which uses <a> tags and CSS
				// to make buttons.  Maybe better solution here is to add our
				// own body click listener to check the event target. works for now.
			return true;
		}
		
		if (!this._editorsInGrid) {
			// do not veto the click event
			return false;
		}

		// Ideally we should give the user three choices:
		//		- save changes? (yes/no), cancel navigation
		// confirm only allows two options and buttons are ok/cancel, we need a window that will block the
		// UI and stop processing until an option is selected, at which point whether or not to veto the
		// operation can be returned to the jazz handler that calls clickNavigateAwayEvent
		
		if (confirm(this._messages.unsavedNavigateConfirm)) {
			// do not veto the click event, discard changes
			this._editorsInGrid = false;
			EditManager.cancelAll(this.projectURI, true);
			this._enableFilterSection();
			return false;
		} else {
			// veto the click event and allow the user to save
			return true;
		}

	},
	
	// Hotkey handlers
	_onToggleHeadingKey: function(focusRowId, rowIdsAndTypes, count, operation) {
		var enableDeferred = this._isOperationEnabled(operation, rowIdsAndTypes, count);
		enableDeferred.addCallback(this, function(enabled) {
			if (enabled) {
				operation.execute(rowIdsAndTypes);
			}
		});
	},
		
	_onCreateSimilarArtifactKey: function(focusRowId, rowIdsAndTypes, count, operation) {
		// summary:
		//		Handle keypress to create a new artifact similar to the current one
		var enableDeferred = this._isOperationEnabled(operation, rowIdsAndTypes, count);
		enableDeferred.addCallback(this, function(enabled) {
			if (enabled) {
				var createSimilarDeferred = operation.execute(rowIdsAndTypes);
				createSimilarDeferred.addCallback(this, function(createdArtifactURIs){
					this.grid.moveFocusToCellOnRow(createdArtifactURIs[0]);
					this._takeFocusOnModuleGridReconciled();
				});
			}
		});
	},
	
	_onCreateNewArtifactKey: function(focusRowId, rowIdsAndTypes, count, operation) {
		// summary:
		//		Handle keypress to create an artifact of a different type
		var enableDeferred = this._isOperationEnabled(operation, rowIdsAndTypes, count);
		enableDeferred.addCallback(this, function(enabled) {
			if (enabled) {
				var createNewDeferred = operation.execute(rowIdsAndTypes);
				createNewDeferred.addCallback(this, function(createdArtifact){
					this.grid.moveFocusToCellOnRow(createdArtifact.getResourceURI());
					this._takeFocusOnModuleGridReconciled();
				});
			}
		});
	},
	
	_onAddCommentKey: function(focusRowId, rowIdsAndTypes, count, operation){
		var enableDeferred = this._isOperationEnabled(operation, rowIdsAndTypes, count);
		enableDeferred.addCallback(this, function(enabled) {
			if (enabled) {
				var createCommentDeferred = operation.execute(rowIdsAndTypes);
				createCommentDeferred.addCallback(this, function(){
					this.grid.focus();
				});
			}
		});
	},
	
	_onDeleteKey: function(focusRowId, rowIdsAndTypes, count, operation) {
		var enableDeferred = this._isOperationEnabled(operation, rowIdsAndTypes, count);
		enableDeferred.addCallback(this, function(enabled) {
			if (!enabled) {
				return (enabled);
			}
			// Find the position of the focus row we are deleting so that we can restore focus to somewhere
			// near it.
			var structure = this.moduleStructure,
				entry,
				deletedEntryIndex;
			if (structure){
				entry = structure.getArtifactByURI(focusRowId);
			}
			if (!entry && structure) {
				// bail out - looks like that artifact is not on display.
				return;
			}
			else if (structure){
				deletedEntryIndex = structure.indexOf(entry);
			}

			// Do the operation
			operation.execute(rowIdsAndTypes);
			// Wait for notification that the operation has completed.
			
			var listener;
			var setFocus = function() {
				// Only listen once - so that we do not try to restore focus for
				// subsequent unrelated operations.  So remove listener now.
				ChangeNotifier.removeListener(listener);
				// Identify the entry that is a the same position that we just deleted from (the one that
				// was below the one we deleted.
				if (structure){
					var entries = structure.getArtifacts();
					if (deletedEntryIndex >= entries.length) {
						deletedEntryIndex = entries.length-1;
					}
					var focusEntryId = entries[deletedEntryIndex].uri;
					this.grid.moveFocusToCellOnRow(focusEntryId);
				}
			};
			
			listener = ChangeNotifier.addListener({
				eventTopic: com.ibm.rdm.web.notifications.EventTopics.MODULE_GRID_RECONCILED,
				callbackFunction: setFocus,
				callbackScope: this
			});
		});
	},
	
	_onCreateSimilarKey: function(focusRowId, rowIdsAndTypes, count, operation) {
		// summary:
		//		Handler for keypress to create similar.  This
		//		is a non-module operation.
		var enableDeferred = this._isOperationEnabled(operation, rowIdsAndTypes, count);
		enableDeferred.addCallback(this, function(enabled) {
			if (!enabled) {
				return (enabled);
			}
			operation.execute(rowIdsAndTypes);
		});
	},
	
	_takeFocusOnModuleGridReconciled: function() {
		// summary:
		//		Listens for the next MODULE_GRID_RECONCILED event, and
		//		makes the grid take focus at that point.  This is a
		//		one-off focus - it only has effect the first time the
		//		event is notified following the call to this method.

		var listener;
		var setFocus = function() {
			// Only listen once - so that we do not try to restore focus for
			// subsequent unrelated operations.  So remove listener now.
			ChangeNotifier.removeListener(listener);
			this.grid.focus();
		};
				
		listener = ChangeNotifier.addListener({
			eventTopic: com.ibm.rdm.web.notifications.EventTopics.MODULE_GRID_RECONCILED,
			callbackFunction: setFocus,
			callbackScope: this
		});
	},
	
	_onIndentOutdentKey: function(focusRowId, rowIdsAndTypes, count, operation) {
		// summary:
		//		Handler for keyboard operation indent or outdent.
		var enableDeferred = this._isOperationEnabled(operation, rowIdsAndTypes, count);
		enableDeferred.addCallback(this, function(enabled){
			if (enabled) {
				operation.execute(rowIdsAndTypes);
				this._takeFocusOnModuleGridReconciled();
			}
		});
	},
	
	_onAddExistingArtifactKey: function(focusRowId, rowIdsAndTypes, count, operation) {
		// summary:
		//		Handler for key to add existing artifacts.  Covers all the operations that add an
		//		existing artifact (after, above, below).
		var enableDeferred = this._isOperationEnabled(operation, rowIdsAndTypes, count);
		enableDeferred.addCallback(this, function(enabled){
			if (!enabled) {
				return enabled;
			}
			var executeDeferred = operation.execute(rowIdsAndTypes);
			executeDeferred.addCallback(this, function(addedResources){
				this.grid.moveFocusToCellOnRow(addedResources[0].getResourceURI());
				this._takeFocusOnModuleGridReconciled();
			});
		});
		
	},
	
	_onPasteKey: function(focusRowId, rowIdsAndTypes, count, operation) {
		var enableDeferred = this._isOperationEnabled(operation, rowIdsAndTypes, count);
		enableDeferred.then(dojo.hitch(this, function(enabled){
			if (!enabled) {
				return (enabled);
			}
			// Do the operation
			var pasteDeferred = operation.execute(rowIdsAndTypes);
			if (pasteDeferred) {
				pasteDeferred.then(dojo.hitch(this, function(pastedRowIds){
					// Focus on the newly pasted row.
					this.grid.moveFocusToCellOnRow(pastedRowIds[0]);
				}));
			}
			
		}));
	},
	
	_onOperationKey: function(focusRowId, rowIdsAndTypes, count, operation) {
		var enableDeferred = this._isOperationEnabled(operation, rowIdsAndTypes, count);
		enableDeferred.then(dojo.hitch(this, function(enabled){
			if (!enabled) {
				return (enabled);
			}
			// Do the operation
			operation.execute(rowIdsAndTypes, focusRowId);
		}));
	},
	
	_isOperationEnabled: function(operation, rowIdsAndTypes, count) {
		// summary:
		//		Helper to indicate whether an operation is enabled.
		// returns:
		//		a deferred with boolean callback parameter to indicate enabled/disabled.
		var enableDeferred;
		if (operation.getEnablementDeferred) {
			enableDeferred = operation.getEnablementDeferred(rowIdsAndTypes, count);
		}
		else {
			// No deferred available, so make one that fires immediately
			enableDeferred = new dojo.Deferred();
			enableDeferred.callback(operation.isEnabled(rowIdsAndTypes, count));
		}
		return enableDeferred;
	},
	
	setNumSelected: function(numSelected) {
		if (numSelected > 0 && !this._clearSelectionNode) {
			this._clearSelectionNode = dojo.create("span", {
				innerHTML: "("+this._messages["clearSelection"]+")",
				"class": "clearSelection",
				"tabindex": "0", // Accessibility - KB navigation
				"role": "button", // Accessibility - screen reader
				"aria-label": this._messages["clearSelection"] // Accessibility - to avoid reading the parens
			}, this.footer);
			
			this.connect(this._clearSelectionNode, "onclick", this.clearSelection);
			this.connect(
				this._clearSelectionNode,
				"onkeydown",
				dojo.hitch(this, function(event){
					// Hook up the appropriate keys as specified by:
					//     http://www.w3.org/WAI/PF/aria-practices/#button
					// for activating our "button".
					if (event.keyCode === dojo.keys.SPACE || event.keyCode === dojo.keys.ENTER) {
						dojo.stopEvent(event);
						this.clearSelection();
					}
				})
			);
		}
		
		if (numSelected > 0) {
			this.numSelectedArtifacts.innerHTML = numSelected + " "+this._messages["selected"];
			dojo.style(this.numSelectedArtifacts, "display", "inline");
			dojo.style(this._clearSelectionNode, "display", "inline");
		} else {
			if (this._clearSelectionNode) {
				dojo.style(this._clearSelectionNode, "display", "none");
			}
			this.numSelectedArtifacts && dojo.style(this.numSelectedArtifacts, "display", "none");
		}
	},
	
	_getTraceabilityFormatObject: function(colKey) {
		var formatObject = null;
		var attributes = this.links
			.getTraceabilityAttributesForColumn(colKey);
		if(attributes) {
			formatObject = this.links
				.getTraceabilityAttributeColumnFormat(colKey);
			formatObject.attributes = dojo.map(attributes, function(a) {
				return a.uri;
			});
		}
		return formatObject;
	},
	
	_applyTraceAttributes: function(griddata) {
		dojo.forEach(griddata, function(datum) {
			if(datum.format) {
				var colDetails = this.display.getDetailsByColId(datum.columnId);
				var traceAttrs = this.links
					.getTraceabilityAttributesForColumn(colDetails.key);
				var traceFormat = this.links
					.getTraceabilityAttributeColumnFormat(colDetails.key);
				
				var traceAttributes = dojo.map(datum.format.attributes,
					function(attr) { return {uri: attr}; });
				this.links.setTraceabilityAttributesForColumn(colDetails.key,
					traceAttributes);
				this.links.setTraceabilityAttributeColumnFormat(colDetails.key,
					{
						showIcon: datum.format.showIcon,
						showTitle: datum.format.showTitle,
						showAttributeName: datum.format.showAttributeName
					});
			}
		}, this);
	},
	
	// Tidy Up
	uninitialize: function () {
		this.grid.destroyRecursive();
		this.bumpScroller.destroy();
		this._destroyWidgets();
		this.display.destroy();
		this._contentPane.destroyRecursive();

		if (this._pageHoverHelp) {
			this._pageHoverHelp.destroyRecursive();
			this._pageHoverHelp = null;
		}
		
		this._clearSelectionNode = null;
		
		this.links.destroy();
		
		if (this.commands && typeof this.commands.onDestroy === "function") {
			this.commands.onDestroy();
		}

		if (this._listeners) {
			ChangeNotifier.removeListeners(this._listeners);
			this._listeners = null;
		}
	},

	_getFirstEditMenuGroups: function(menuOperations) {
		// summary:
		//		For documentation please see the documentation for GridModel's
		//		getFirstEditMenuGroups method.

		if (this._viewType === com.ibm.rdm.web.project.DashboardConstants.VIEW_TYPES.MODULE) {
			return [
				this.projectButtonAndMenuActions.createTreeLevelEditMenuGroup(menuOperations)
			];
		} else {
			return [
				this.projectButtonAndMenuActions.createRowsPerPageEditMenuGroup(menuOperations),
				this.projectButtonAndMenuActions.createGroupByEditMenuGroup(menuOperations),
				this.projectButtonAndMenuActions.createShowLinksTreeViewEditMenuGroup(
					menuOperations, this.grid.header.domNode
				)
			];
		}
	}
});

})();
