/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009, 2014. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.defects.web.ui.internal.RequirementLinksTableView");

dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.RichHoverCellRenderer");
dojo.require("com.ibm.asq.common.web.ui.internal.util.Utility");
dojo.require("com.ibm.rqm.defects.web.util.RichHoverUtil");

dojo.require("com.ibm.rqm.defects.web.ui.utils.DefectsUIUtil");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.requirement.web.client.internal.requirement.RequirementWorkItemClient");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.table.AbstractFilteredTableView");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.rqm.planning.web.ui.internal.model.action.BulkChangeAction");
dojo.require("com.ibm.rqm.defects.web.ui.internal.RequirementLinkTableHeaderRenderer");
dojo.require("com.ibm.rqm.defects.web.client.internal.ResourceLinkService");
dojo.require("com.ibm.rqm.defects.web.ui.utils.CollectionLinksUtil");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.Utility");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.table.ExplorableTableFilterProvider");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentFilterProvider");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.table.ArtifactActionProvider");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.ArtifactSelectorPanelFormField");
dojo.require("com.ibm.asq.common.web.client.internal.FiltersQueriesClient");

(function(){
    var ImageCache = com.ibm.asq.common.web.ui.internal.view.common.ImageCache;
    var TableConstants = com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants;
    var DefectsUIUtil = com.ibm.rqm.defects.web.ui.utils.DefectsUIUtil;
    var Utility = com.ibm.asq.common.web.ui.internal.util.Utility;
    var RichHoverCellRenderer = com.ibm.asq.common.web.ui.internal.widgets.tableViewer.RichHoverCellRenderer;
    var RichHoverUtil = com.ibm.rqm.defects.web.util.RichHoverUtil;
    var Constants = com.ibm.rqm.planning.web.client.internal.Constants;
	var AbstractFilteredPagingTableView = com.ibm.rqm.planning.web.ui.internal.view.table.AbstractFilteredPagingTableView;
	var ServiceResponseHandler = com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
	var RequirementWorkItemClient = com.ibm.rqm.requirement.web.client.internal.requirement.RequirementWorkItemClient;
    var RiskUtil = com.ibm.rqm.risk.web.ui.internal.view.assessment.RiskUtil;
    var ResourceLinkService = com.ibm.rqm.defects.web.client.internal.ResourceLinkService;
    var CollectionLinksUtil = com.ibm.rqm.defects.web.ui.utils.CollectionLinksUtil;
    var PlanningUtil = com.ibm.rqm.planning.web.ui.internal.util.Utility;
    var TableContentFilterProvider = com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentFilterProvider;
	var ArtifactActionProvider = com.ibm.rqm.planning.web.ui.internal.view.table.ArtifactActionProvider;
	var FiltersQueriesClient = com.ibm.asq.common.web.client.internal.FiltersQueriesClient;
    
    dojo.declare("RequirementLinksTableView.TableListener", com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableListener, {
        constructor: function(args){
            dojo.mixin(this, args);
        },
        
        // Summary:
        //   If the table's rows are checkable, when a row is checked, or unchecked, this method is
        //   called.
        //
        rowCheckStateChanged: function(tableViewer, rowObject, state){
            var selection = tableViewer.getCheckedRows();
			var realSelection = dojo.isArray(selection);
			var selectionCount = realSelection ? selection.length : 2; // use 2 to indicate select all.
            
            if (this.parentView.deleteActionNode) 
                // can delete archived or non-archived test cases
                this.parentView.deleteActionNode.setDisabled(selectionCount == 0 || !tableViewer.isEditable());
            if (this.parentView.syncLinkActionNode) {
            	if(this.parentView.syncLinkActionNode.actionId == DefectsUIUtil.getMessage("tooltipSyncReqColl")){

            		//always disable the Sync button when test plan can't be editable
            		this.parentView.syncLinkActionNode.setDisabled(!tableViewer.isEditable()); 
            	} else {
            		this.parentView.syncLinkActionNode.setDisabled(selectionCount == 0);
            	}
            }
            if (this.parentView.clearStatusActionNode) {
            // If this is a virtual select all, always enable the action.
            // We enable the action when ANY rows has updated or removed.
            // So, other rows that don't have this value would get 'cleared'
			var disable = selectionCount > 0 ? false : true;
            if (realSelection && selectionCount > 0) {
                for (var i = 0; i < selection.length; i++) {
                    if (selection[i].status == "updated" || selection[i].status == "removed") {
                        disable = false;
                        break;
                    }
                }
            }
			this.parentView.clearStatusActionNode.setDisabled(disable);
		}
            //if table view has a rowCheckListener, invoke it
            var p = this.parentView;
            if (p && p.rowCheckedListener && dojo.isFunction(p.rowCheckedListener)) {
                p.rowCheckedListener(rowObject, state);
            }
			if (p.bulkchangeActionNode) {
				p.bulkchangeActionNode.setDisabled(selectionCount == 0);
			}

        },
        
        tableContentActionInvoked: function(tableViewer, actionId, callbackData, callback){
            if (callback != null && dojo.isFunction(callback)) {
                if (callbackData != null) {
                    callback(callbackData);
                }
                else {
                    callback();
                }
            }
        },
		
		tableHeaderColumnActionInvoked: function(tableViewer, columnIndex, /*optional*/actionId)
	    {
			if (this.parentView && this.parentView.requirementHeaderColumnActionInvoked) {
				this.parentView.requirementHeaderColumnActionInvoked(tableViewer, columnIndex, actionId);
			}         
	    },
	    
	    tableContentFilterActionInvoked: function(tableViewer, actionId, filters, callback, callbackData)
	    {
	        if(callback) {
	            callback(actionId, filters);
	        }                     
	    },
	    
	    tableContentGroupByChanged: function(tableViewer, colIndex) {
			this.parentView._resetContentOnTableContentGroupByChanged(colIndex);
    	}
	  });
    
    
    dojo.declare("com.ibm.rqm.defects.web.ui.internal.RequirementLinksTableProvider", com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider, {
        constructor: function(viewer, disableRisk, disableStatus){
            this.COLUMNS = {
	            STATUS: this.toColumn(Constants.getMessage("labelStatusRequirementTable"), 6, false, TableConstants.ALIGN_LEFT, TableConstants.RENDER_TYPE_IMAGE, 'status', false),
	            COMMUNITYRISK: this.toColumn(Constants.getMessage("labelCommunityRiskHeader"), 10, false, TableConstants.ALIGN_LEFT, TableConstants.RENDER_TYPE_FADEINOUT, 'communityRisk', false),
	            CALCULATEDRISK: this.toColumn(Constants.getMessage("labelRiskAssessment"), 10, false, TableConstants.ALIGN_LEFT, TableConstants.RENDER_TYPE_IMAGE, 'systemRisk', false, 'calculatedRisk'),
	            SUMMARY: this.toColumn(Constants.getMessage("labelSummary"), 50, false, TableConstants.ALIGN_LEFT, TableConstants.RENDER_TYPE_RICH_HOVER, 'summary', true),
				
				REQUIREMENTLINK: this.toColumn(Constants.getMessage("labelRequirement"), 50, false, TableConstants.ALIGN_LEFT, TableConstants.RENDER_TYPE_RICH_HOVER, 'requirement', true),
				COLLECTION: this.toColumn(Constants.getMessage("labelRequirementCollection"), 20, true, TableConstants.ALIGN_LEFT, TableConstants.RENDER_TYPE_RICH_HOVER_LIST, 'collection', true),
				LINKEDTESTCASES: this.toColumn(DefectsUIUtil.getMessage("labelLinkedTCs"), 30, false, TableConstants.ALIGN_LEFT, TableConstants.RENDER_TYPE_RICH_HOVER_LIST, 'linkedTCs', true)
	        };
	        
	        this.COLUMNS.GENERAL = [];
	        this.COLUMNS.COVERAGE = [this.COLUMNS.REQUIREMENTLINK, this.COLUMNS.COLLECTION, this.COLUMNS.LINKEDTESTCASES];
            
            this.tableViewer = viewer;
            this.disableRisk = disableRisk;
            this.disableStatus = disableStatus;
            
            if(this.disableStatus !== undefined && !this.disableStatus){
            	this.COLUMNS.GENERAL.push(this.COLUMNS.STATUS);
            }
      		
        	if(this.disableRisk !== undefined && !this.disableRisk){
        		this.COLUMNS.GENERAL.push(this.COLUMNS.COMMUNITYRISK);
        		this.COLUMNS.GENERAL.push(this.COLUMNS.CALCULATEDRISK);        		
        	}
        	this.COLUMNS.GENERAL.push(this.COLUMNS.SUMMARY);
        	
        	this.columnProfile = this.COLUMNS.COVERAGE;          	
        },
        
        setProfile: function(profileName) {
        	this.columnProfile = this.COLUMNS[profileName] || this.COLUMNS.ALL;
        },
        
		getNumColumns: function(content){
            return this.columnProfile.length;
        },
				
		getColumnHeading: function(content, index)
    	{
        	return this.columnProfile[index].name;
    	},
		    			
		getColumnIdName: function(columnIndex)
    	{
        	return this.columnProfile[columnIndex].dbName;
    	},
		
        getColumnHeadingImage: function(content, atColumnIndex){
            
			return null;
        },
		getIsColumnVisible: function(atColumnIndex)
	    {
	    	
	    	return this.columnProfile[atColumnIndex].isVisible;
	    },
		
        getColumnHeadingAlignment: function(atColumnIndex){
            return this.columnProfile[atColumnIndex].alignment;
        },
        getIsColumnGroupable: function(content, atColumnIndex){
            return this.columnProfile[atColumnIndex].groupable;
        },
        getIsColumnSortable: function(content, atColumnIndex){
			// Currently all columns are sortable except risk.
       		 return true;  			//!(atColumnIndex == 1 || atColumnIndex == 2);   
        },
		
		
        getColumnWidth: function(content, atColumnIndex){
            // note - using the array lookup rather than a switch statement
    		// is about 17x faster on FF 3.5 - but the same speed on IE7 and IE8.
    		// Probably not worth making these fixes any further.
    		return this.columnProfile[atColumnIndex].width;
        },
        getContentObjects: function(content){
            return content;
        },
        getRowDataId: function(rowData){
        	var id = rowData.calmLink || rowData.uri;
            return "_table_row_for_external_wi" + id;
        },
        getCellDisplayType: function(rowData, atColumnIndex){
        	
        	return this.columnProfile[atColumnIndex].type;
        },
		
        getCellAlignment: function(rowData, atColumnIndex){
            return TableConstants.ALIGN_LEFT;
        },
		
        getCellDisplayData: function(rowData, atColumnIndex){
        	var column = this.columnProfile[atColumnIndex];
        	
            var val = "";
            switch (column.name) {
				case this.COLUMNS.STATUS.name: 
					if(!rowData.status || rowData.status=="new")
						val = Constants.getMessage("labelRequirementNormal");
					else if(rowData.status=="unknown")
						val = "";
					else if(rowData.status == "updated")
		                val = Constants.getMessage("labelRequirementUpdated");
					else if(rowData.status == "removed")
		                val = Constants.getMessage("labelRequirementRemoved");
	                break;   
				case this.COLUMNS.COMMUNITYRISK.name: 
	                val = this._getRiskLevel(rowData.risk, "communityRisk");
	                break;
				case this.COLUMNS.CALCULATEDRISK.name:
					val = this._getRiskLevel(rowData.risk, "calculatedRisk");
                	break;
                case this.COLUMNS.SUMMARY.name:
                case this.COLUMNS.REQUIREMENTLINK.name:
					if(!rowData.summary){
            			rowData.summary = "";
            		}                
                    val = Utility.decodeHTMLEntities(rowData.summary);
                    break;
                case this.COLUMNS.COLLECTION.name:
					val = "";
					if(dojo.isArray(rowData.collections)){
						dojo.forEach(rowData.collections, function(col){
							if(col.summary){
								val += col.summary; 
							}
						});
					}
					val = Utility.decodeHTMLEntities(val);
                	break;
                case this.COLUMNS.LINKEDTESTCASES.name:
					val = "";
					if(dojo.isArray(rowData.linkedTCs)){
						dojo.forEach(rowData.linkedTCs, function(col){
							if(col.testcase){
								val += col.testcase.testCaseName; 
							}
						});
					}
                	break;
            }
            return val;
        },
        getCellDisplayExtendedInfo: function(rowData, atColumnIndex){
        	var column = this.columnProfile[atColumnIndex];
        	
            var val = null;
            switch (column.name) {
				case this.COLUMNS.STATUS.name: 
					val = {};
					if(!rowData) {
						val.image = "";
					} else if(rowData.status == "updated"){
						val.image = ImageCache.REQ_UPDATED;
					}else if(rowData.status == "removed"){
						val.image = ImageCache.REQ_REMOVED;
					}else if(rowData.status == "new"){
						val.image = ImageCache.REQ_NORMAL;
					}else {
						val.image = ImageCache.REQ_NORMAL;
					}
	                break;   
				case this.COLUMNS.COMMUNITYRISK.name: 
	                val = {};
					var image = ImageCache.RISK_LEVELS[this._getRiskLevel(rowData.risk, "communityRisk")];
		            if (image) {
		                val.image = image;
		                val.tooltipInfo = {
		                    createContents: dojo.hitch(this, this._createTooltip, rowData),
		                    onOpen: dojo.hitch(this, this._openTooltip, rowData),
		                    onClose: dojo.hitch(this, this._closeTooltip, rowData)
		                };
		            }
	                break;
				case this.COLUMNS.CALCULATEDRISK.name:
					val = {};
		            var level = this._getRiskLevel(rowData.risk, "calculatedRisk");
		            var image = ImageCache.RISK_LEVELS[level];
	            	if (image) {
	                	val.image = image;
	                	val.tooltip = RiskUtil.getRiskLabel(level);
	           		}
                	break;
                case this.COLUMNS.SUMMARY.name:
                case this.COLUMNS.REQUIREMENTLINK.name:
					val = {};
	                val.uri = RichHoverUtil.getWorkItemUri(rowData.calmLink || rowData.uri);
	                val.presentationUri = RichHoverUtil.getWorkItemPresentationUri(rowData.calmLink || rowData.uri);
	                val.label = Utility.decodeHTMLEntities(rowData.summary);
	                val.noUpdateLabel = false;
                    break;
                case this.COLUMNS.COLLECTION.name:
					var nLinks = 0;
		            var collections = rowData.collections;
		            if (collections != null)
		            	nLinks = collections.length;
		            var items = [];
		            for (var i = 0; i < nLinks; i++) {
		                var item = {};
		                
		                item.label = collections[i].summary;
		                item.uri = collections[i].uri;
		                items.push(item);
		            }
		            val = {
		                items: items,
						useNumericLabel: true,
						noUpdateLabel: false
		            }
                	break;
                case this.COLUMNS.LINKEDTESTCASES.name:
					var nLinks = 0;
		            var linkedTcs = rowData.linkedTCs;
		            if (linkedTcs != null)
		            	nLinks = linkedTcs.length;
		            var items = [];
		            for (var i = 0; i < nLinks; i++) {
		                var item = {};
		                
		                item.label = linkedTcs[i].testcase.name || linkedTcs[i].testcase.testCaseName;
		                item.noUpdateLabel = true;
		                item.uri = Utility.getQmResourceLinkUri(Utility.TYPE_CASE, linkedTcs[i].testcase.versionableItemId || linkedTcs[i].testcase.itemID)
		                item.openInTab = true;
		                item.decorateImage = ImageCache.TEST_CASE;
		                item.presentationUri = PlanningUtil.getTestCaseURI(linkedTcs[i].testcase.id);
		                items.push(item);
		            }
		            val = {
		                items: items,
						useNumericLabel: true
		            }
                	break;
            }
            
            // val.noUpdateLabel = false; //  set it as false if you want to update label, else ignor it or set it as true
            return val;
        },
        
        toColumn: function(name, width, groupable, alignment, type, rowName, isVisible, dbName) {
	        return {
	            name: name,
	            width: width,
	            groupable: groupable,
	            alignment: alignment,
	            type: type,
	            rowName: rowName,
	            isVisible: isVisible,
	            dbName: dbName || rowName // initialize a db name for the column, if no explicit dbName is provided, use the rowName
	        }
	    },
		
		//return value is int (0 ~ 5)
		_getRiskLevel: function(dtoRisk, riskType) {
			if (dtoRisk && dojo.isArray(dtoRisk))
				dtoRisk=dtoRisk[0];
			if (dtoRisk) {
				var levelString = null;
				switch (riskType) {
					case "communityRisk":
						levelString = dtoRisk.slice(dtoRisk.indexOf("communityRisk")+14, dtoRisk.indexOf("communityRisk")+15);
						break;
					case "calculatedRisk":
						levelString = dtoRisk.slice(dtoRisk.indexOf("calculatedRisk")+15, dtoRisk.indexOf("calculatedRisk")+16);
						break;
				}
				var level = Number(levelString);
	            if (level != NaN && level >= 0) {
					return level;
	            } 
			}
			return 0;
		},
		
		_createTooltip: function(rowData, hoverPopup) {
			this.riskTooltipWidget = new com.ibm.rqm.risk.web.ui.internal.view.assessment.AssessmentOverview({
				artifact: rowData,
				artifactType: Constants.MODEL_TYPE_REQUIREMENT,
				editable: false,//this.tableViewer.editable && rowData.riskItemId,
				saveCallback: dojo.hitch(RequirementWorkItemClient, "postCalmRequirementRisk")
			});
			hoverPopup.content = this.riskTooltipWidget.domNode;
		},
		
		_openTooltip: function(data) {
		},
		
		_closeTooltip: function(rowData, hoverPopup) {
			hoverPopup._lastOpen = -1;
			var myRanking = [];
			var myComment = [];
			if (this.riskTooltipWidget._myRiskStar)
				myRanking = this.riskTooltipWidget._myRiskStar.getValue();
	
			if(this.riskTooltipWidget && this.tableViewer.editable &&rowData.riskItemId ) {
				this.riskTooltipWidget.onSave(this.tableViewer);
				this.riskTooltipWidget = null;
			}
			rowData.risk = 'communityRisk:' + myRanking + " " + "calculatedRisk:";
				
			this.tableViewer.refresh();
		}
    });
    
    dojo.declare("RequirementLinksTableView.TableFilterProvider", 
	    com.ibm.rqm.planning.web.ui.internal.view.table.ExplorableTableFilterProvider,
	{
		collections: [],
		
	    constructor: function(args) {
	        dojo.mixin(this, args);  
	
	        // define the static filters
	        this.filters = [];
	        
	        this.filters.push({
	            name: "collection",
	            title: Constants.getMessage("labelRequirementCollection"),
	            promptTitle: Constants.getMessage("labelRequirementCollection"),
	            type: TableContentFilterProvider.FIELD_TEXT_POPUP,
	            defaultValue: null,
	            params: {
	                usePopup: true,
	                updateDisplayOnValueChanged: true,
	                fieldClass: "RequirementLinksTableView.SelectorPanelFormField",
	                fieldWidth: 240,
	                fieldArgs: {
	                    panelWidth: 240,
	                    useUnassigned: false,
	                    'artifactType': Constants.MODEL_TYPE_REQUIREMENT,
	                    collections: this.collections
	                }
	            }
	        });
	        this.filters.push({
	            name: "linkedTCs",
	            title: DefectsUIUtil.getMessage("labelLinkedTCs"),
	            promptTitle: DefectsUIUtil.getMessage("labelLinkedTCs"),
	            type: TableContentFilterProvider.FIELD_ENUM, 
	            defaultValue: "All@@", 
	            params: [
	                {
	                    name: Constants.getMessage("labelShowAll"),
	                    value: 'All@@'
	                },
	                {
	                    name: Constants.getMessage("labelInTestPlan"),
	                    value: 'In@@' 
	                }, 
	                {
	                    name: Constants.getMessage("labelNotInTestPlan"),
	                    value: 'NotIn@@' 
	                }
	            ]
	        });
	    },
	    
	    filterRunActionInvoked: function(actionName, filters, updateOnly){
	        if (this.tableView) {
	        	this.tableView.filters = filters;
	        	this.tableView.coverageViewRefreshAction.actionHandler(filters);
	        }
	    }
	});
	
	dojo.declare("RequirementLinksTableView.SelectorPanelFormField", 
		com.ibm.rqm.planning.web.ui.internal.view.common.ArtifactSelectorPanelFormField,
	{
		collections: [],
		hasInitFilterTable: false,
		postCreate: function(){
			this.inherited("postCreate", arguments);
		},
		
		// @override ArtifactSelectorPanelFormField
		onPopupOpen: function() {
	        this.selector.startup();
	        
	        if(!this.hasInitFilterTable){
	        	this.selector.artifactSelector._initialGeneralView();
	        	this.selector.artifactSelector.refresh(this.collections);
	        	if(dojo.isArray(this.defaultValue)){
	        		var tableViewer = this.selector.artifactSelector.tableViewer;
      				tableViewer.selectRows(this.defaultValue, true);
      				tableViewer.refresh();  			
	        	}
	        	this.hasInitFilterTable = true;
	        }
		},
		
		// @override ArtifactSelectorPanelFormField
	    getValue: function() {
	        var selectedArtifacts = this.selector.get('selection');
	        var isLegacy = this.legacyKey != null;
	        var useItemId = this.useItemId;
	        
	        // the user has not selected any thing, and we have a old legacy value
	        // just return it.
	        if(isLegacy && !selectedArtifacts.length && this.oldLegacyValue) {
	            var legacyValue = {};
	            legacyValue[this.valueName] = this.oldLegacyValue;
	            return legacyValue;
	        }
	        
	        // stripe down the artifact object to only include id & versionableItemId
	        var stripedSelection = [];
	        var vItemIds = [];
	        var retVal = stripedSelection;
	        
	        for (var i = 0; i < selectedArtifacts.length; i++) {
	            var artifact = selectedArtifacts[i];
	            var stripedValue = {
	                'uri': artifact.uri,
	                'summary': artifact.summary
	            };
	            stripedSelection.push(stripedValue);
	        }
	        // package the legacy value to return;
	        if(isLegacy) {
	            retVal = {};
	            retVal[this.legacyKey] = vItemIds;
	            retVal['advancedObj'] = stripedSelection;    
	        }
	        return retVal;
	    },
	    
	    // @override ArtifactSelectorPanelFormField
	    getValueInString: function(){
	        var strVal = "";
	        
	        var selectedItem = this.selector.get('selection');
	        var nItems = selectedItem.length;
	        if (selectedItem) {
	            for (var i = 0; i < nItems; i++) {
	                var name = selectedItem[i].summary;
	                strVal += (name + (((i + 1) < nItems) ? ", " : ""));
	            }
	        }
	        // display the old legacy value
	        if(this.oldLegacyValue && !nItems) {
	            strVal = this.oldLegacyValue;
	        }
	        return strVal;
	    },
	    
		// @override ArtifactSelectorPanelFormField
		_getArtifactSelectorClass: function(){
			return "com.ibm.rqm.defects.web.ui.internal.RequirementLinksTableView";
		}
	});
    
    dojo.declare("com.ibm.rqm.defects.web.ui.internal.RequirementLinksTableView", [dijit._Widget, dijit._Templated, AbstractFilteredPagingTableView], {
        templateString: '<div dojoAttachPoint="_tableViewerNode" class="com-ibm-rqm-test-artifact-table-view" tabindex="-1">' +
        '</div>',
        
        widgetsInTemplate: true,
        editable: true,
		hideResetButton: false,
		inDialogMode: false,
     
        constructor: function(){
			this.reqLinks = [];
			this.section = [];
			this.showCoverageView = false;
			this.coverageViewInitialized = false;
			this.actionsInGeneralView = [];
			this.actionsInCoverageView = [];
			this.collections = [];
			this.dataForTableWithoutGroupBy = [];
			this.dataForTableGroupByCollection = [];
        },
        
        postCreate: function(){
            this.inherited("postCreate", arguments);
			
			//load class in Risk component
			jazz.core.loader.load_async("com.ibm.rqm.risk.web.ui.internal.view.assessment.AssessmentOverview", function(){});
			jazz.core.loader.load_async("com.ibm.rqm.risk.web.ui.internal.view.assessment.RiskProfileTemplateDialog", function(){});
			jazz.core.loader.load_async("com.ibm.rqm.risk.web.client.internal.risk.RiskClient", function(){});
			
			var tableArgs = {
                isCompactMode: !this.printable,
                allowAdjustSettings: !this.printable,
                autoSaveSettings: true,
                editable: this.editable,
                tableId: "RQM-WORKITEMLINKS-TABLEVIEWER" + (this.showCoverageView ? "-WITH-COVERAGE-VIEW" : "-WITHOUT-COVERAGE-VIEW"),
                showViewModeControl: this.showCoverageView,
				displayInPopup: this.inDialogMode
           	};
			if(this.tableArgs) {
	            dojo.mixin(tableArgs, this.tableArgs);
	        }
            var tableViewer = new com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer(tableArgs);
            
            tableViewer.registerCellRenderer("RENDER_TYPE_RICHHOVERLINK", new RichHoverCellRenderer());
            this._tableViewerNode.appendChild(tableViewer.domNode);
            
           
			var content = this.reqLinks ? this.reqLinks : [];
            tableViewer.headerRenderer = new com.ibm.rqm.defects.web.ui.internal.RequirementLinkTableHeaderRenderer(tableViewer);
            tableViewer.setContentPageSize(5);
            tableViewer.setTableSummary(Constants.getMessage("labelTableSummary", 
            		this.artifactType == Constants.TYPE_REQUIREMENT_COLLECTION  ? Constants.getMessage("RQM-KEY-RM-COL-SECTION-TITLE") : Constants.getMessage("RQM-KEY-RM-SECTION-TITLE")));
            tableViewer.setContent(content);
            var tableProvider = new com.ibm.rqm.defects.web.ui.internal.RequirementLinksTableProvider(tableViewer, this.disableRisk, this.disableStatus);
            this.tableProvider = tableProvider;
            tableViewer.setContentProvider(tableProvider);
            tableViewer.setTableListener(new RequirementLinksTableView.TableListener({
                parentView: this
            }));
            
            tableViewer.setTableRowsCheckable(true, /* isSingleSelect */ false);

            for (var i = 0; i < (this.actions ? this.actions.length : 0); i++) {
                var action = this.actions[i];
                if (action.label == DefectsUIUtil.getMessage("labelRemoveRmLinks")) {
                    this.deleteActionNode = tableViewer.addAction(action.label, action.label, null, action.iconClass, action.actionHandler);
                    this.deleteActionNode.setDisabled(true);
                    var actionButton = this.deleteActionNode;
                }
                else if(action.label == DefectsUIUtil.getMessage("lableResetRequirementLinkStatus")){
					this.clearStatusActionNode = tableViewer.addAction(action.label, action.label, null, action.iconClass, action.actionHandler);
                    this.clearStatusActionNode.setDisabled(true);
                    var actionButton = this.clearStatusActionNode;
				}else if (action.label == DefectsUIUtil.getMessage("titleSyncReqLinks")) {                    
                    this.syncLinkActionNode = tableViewer.addAction(action.label, action.label, null, action.iconClass, action.actionHandler);
                    this.syncLinkActionNode.setDisabled(true);
                    var actionButton = this.syncLinkActionNode;
                }else if(action.label == DefectsUIUtil.getMessage("tooltipSyncReqColl")){//TODO should use action id instead of action.label
                	if (action.onlyForCoverageView) {
						this.syncLinkActionNodeForCoverageView = tableViewer.addAction(action.label, action.label, null, action.iconClass, action.actionHandler);
						var actionButton = this.syncLinkActionNodeForCoverageView;
					}
					else {
						this.syncLinkActionNode = tableViewer.addAction(action.label, action.label, null, action.iconClass, action.actionHandler);
						var actionButton = this.syncLinkActionNode;
					}         	
                }else if( action.label == Constants.getMessage("toolTipCreateNewQC")){
                	this.createQCActionNode = tableViewer.addAction(action.label, action.label, null, action.iconClass, action.actionHandler);
                	var actionButton = this.createQCActionNode;     
                }
                else 
				{
                    var actionButton = tableViewer.addAction("", action.label, null, action.iconClass, action.actionHandler);
                    actionButton.setDisabled(!this.editable);
                }
                if(action.onlyForCoverageView){
                	if(action.label == DefectsUIUtil.getMessage("labelRefreshLinks")){
                		this.coverageViewRefreshAction = action;
                	}
                	this.actionsInCoverageView.push(actionButton);
                } else {
                	if(action.label == DefectsUIUtil.getMessage("labelRefreshLinks")){
                		this.generalViewRefreshAction = action;
                	}
                	this.actionsInGeneralView.push(actionButton);
                }
            }
			
            this.tableViewer = tableViewer;
            
            if (this.showCoverageView){
            	//add view modes
		        var viewModes = [];
		        var tableId = "RQM-REQUIREMENTORCOLLLINKS-TABLEVIEWER";
		        viewModes.push({
		            id: 'general',
		            label: Constants.getMessage("labelViewGeneral"),
		            tableId: tableId,
					columnsProfile: null
		        });
		        
	            viewModes.push({
	                id: 'coverage',
	                label: Constants.getMessage("labelViewCoverage"),
	                tableId: tableId + '-COVERAGE',
	                columnsProfile: null
	            });
	            // NOTE: This table doesn't use the common table view mechanism to switch views
	            // It does it on its own. If/when this is changed to use common mechanism, the table
	            // provider will need to implement 'getViewColumnsProfile' to return the view's columns
	            // profile.
		        this._configureViewModes(viewModes, tableViewer);
		        
            }
		    // HACK: since we are not using the std way, we need to call into the table's
		    // setting initialization to get the persisted view mode and settings before we load
	        this.tableViewer._initializeTableSettings();
            
            var currentViewModeId = this.tableViewer.getCurrentViewModeId();
            //In case the "view as" table settings has been changed before
            if(!currentViewModeId || currentViewModeId == "general"){
            	tableViewer.tableViewModeId = "general";
            	this._initialGeneralView();          	
            }else{         	
            	tableViewer.tableViewModeId = "coverage";
            	this._initialCoverageView();
            }
         
        },
        
        refresh: function(links){
        	//this.collecitons is used in Coverage view for Reconciliation and Collection filter 
        	this.collections = links;
            this.tableViewer.setContent(links);
            if(this.deleteActionNode){
				this.deleteActionNode.setDisabled(true);
			}
			
			if(this.clearStatusActionNode){
				this.clearStatusActionNode.setDisabled(true);
			}

			//reset sync requirement action
			if(this.syncLinkActionNode){
				if(this.syncLinkActionNode.actionId == DefectsUIUtil.getMessage("tooltipSyncReqColl")){
					//Reconcile button for Test Plan is enabled with 2 conditions:
					//1. Test Plan is editable;
					//2. There are collections had been added to the table;
					if(links.length > 0 && this.tableViewer.isEditable())
            			this.syncLinkActionNode.setDisabled(false); 
            		else
						this.syncLinkActionNode.setDisabled(true);
            	} else {
					//Reconcile button for Test Case is not enabled until there are row selections made
					//for selecting which requirement(s) need to be reconciled. 
            		this.syncLinkActionNode.setDisabled(true);
            	}
			}
			
			if(this.syncLinkActionNodeForCoverageView){
				if(links.length > 0 && this.tableViewer.isEditable()){
					this.syncLinkActionNodeForCoverageView.setDisabled(false);
				}
				else{
					this.syncLinkActionNodeForCoverageView.setDisabled(true);
				}
			}			
			
            this.tableViewer.refresh();
        },
        
        refresh2: function(links){
        	//reconstruct data for grouping by collection  
        	var links2 = [];
	    	dojo.forEach(links, function(link){
	    		//create separate item for the same requirement contained in different collections
	    		dojo.forEach(link.collections, function(coll){
	    			links2.push({
	    				summary: link.summary,
	    				linkedTCs: link.linkedTCs,
	    				collections: [coll],
	    				uri: link.uri
	    			});
	    		});
	    	});
	    	this.dataForTableGroupByCollection = links2;
	    	this.dataForTableWithoutGroupBy = links;
        	
        	this.tableViewer.endLoadingProgress();
        	this.coverageViewInitialized = true;
        	this._resetContentOnTableContentGroupByChanged(this.tableViewer.getGroupByColumn());
			this.tableViewer.refresh();
	    	
        },
        
        getContent: function(){
            return this.tableViewer.getContent();
        },

        getCheckedRows: function(){
            return this.tableViewer.getCheckedRows();
        },
		
		requirementHeaderColumnActionInvoked: function(tableViewer, columnIndex, actionId){
	        var idType = "itemId";  //Risk type
	        this.invokeAction(idType, this, "doBatchUpdate", columnIndex, actionId);
		},
		
		_onChangeStatusActionClick: function(selectedIds) {
			if (selectedIds.length > 0) {
				this.refreshData(selectedIds);
			}
		},
		//change status with latest data
	    refreshData: function(selectedIds){
			if (selectedIds.length > 0) {
				this._needUpdatedReq = selectedIds;
	            var args = {
	                'primaryTitle': Constants.getMessage("labelConfirmation"),
	                'message': Constants.getMessage("msgConfirmUpdateRequirementLink"),
	                'yesCallback': dojo.hitch(this, "_refreshDataAction")
	            };
	            var confirmDialog = new com.ibm.asq.common.web.ui.internal.widgets.YesNoDialog(args);
	            confirmDialog.open();
	        } else {
				var alertDialog = new com.ibm.asq.common.web.ui.internal.widgets.AlertDialog({'message': Constants.getMessage("msgNoRequirementLinkInSuspect")});
	    	    alertDialog.setPrimaryTitle(Constants.getMessage("labelAlert"));
	        	alertDialog.open();
			}
	    },
		
		_refreshDataAction: function() {
	        var method = (this.contentIsVirtual) ? "_invalidateQuery" : "_refreshNewestData";
			var responseHandler = new ServiceResponseHandler(this, method, "_error");
	        RequirementWorkItemClient.getLastestWorkItemDTOs(responseHandler, {
	                    	ids: this._needUpdatedReq
	                	});
		},
	    
	    // @override.
	    //    Abstract method to actually performs the batch change operations. Specific
	    //    subclassess need to override this method to do the work on the artifact type.
	    doBatchUpdate: function(itemIds, columnIndex, actionId) {
	        var itemIdArgName = "artifactItemIds";
	        var action = new Requirement.BulkChangeAction({
	            actionId: actionId,
	            itemIdsArgName: itemIdArgName,
	            itemIds: itemIds,
	            completeCallback: dojo.hitch(this.section, "_handleRefreshRmLinksClicked"),
            	errorCallback: dojo.hitch(this.section, "_handleRefreshRmLinksClicked")
	        });
	        action.execute();
	    },
	    
        preLoadContent: function(){
        	this.tableViewer.setVirtualContent([]);
			this.tableViewer.showLoadingProgress();
        },
        
        getSelectedItems: function(){
        	return this.tableViewer.getCheckedRows();
        },
	    
	    _initialGeneralView: function(){
        	var tableViewer = this.tableViewer;
        	tableViewer.tableViewModeId = "general";
        	this.tableProvider.setProfile('GENERAL');
        	
        	tableViewer.setContentFilterAttributeProvider(null);
            tableViewer.setActionProvider(null);
        	
        	if(this.tableProvider.disableRisk || this.tableProvider.disableRisk == undefined){
            	var columnsProfile = [{index: 0, name: "summary", width: 80}];
            	tableViewer.columnsProfile = columnsProfile;
        	}else{
        		var columnsProfile = [{index: 0, name: "communityRisk", width: 20},
        							  {index: 1, name: "systemRisk", width: 20}, 
        							  {index: 2, name: "summary", width: 50}];
        		tableViewer.columnsProfile = columnsProfile;
        	}
            
            tableViewer.show();
            
            dojo.forEach(this.actionsInGeneralView, function(actionButton){
            	dojo.style(actionButton.domNode, 'display', '');
            });
            dojo.forEach(this.actionsInCoverageView, function(actionButton){
            	dojo.style(actionButton.domNode, 'display', 'none');
            });
            this.tableViewer.setContent([]);
            tableViewer.setTableRowsCheckable(true, /* isSingleSelect */ false);
            this.tableViewer.refresh();
        },
        
        _initialCoverageView: function(){
        	var tableViewer = this.tableViewer;
        	tableViewer.tableViewModeId = "coverage";
        	this.tableProvider.setProfile('COVERAGE');
        	
        	var filterProvider = new RequirementLinksTableView.TableFilterProvider({
				artifactTypeQueryKey: FiltersQueriesClient.REQUIREMENT_QUERY_KEY,   //artifactTypeQueryKey is required for filter table
                tableView: this,
                collections: this.collections
            });
        	tableViewer.setContentFilterAttributeProvider(filterProvider);
        	
            var columnsProfile = [{index: 0, name: "requirement", width: 40},{index: 1, name: "collection", width: 20},{index: 2, name: "linkedTCs", width: 40}];
            tableViewer.columnsProfile = columnsProfile;
            
			
			if (this.columnActions) {
				var actionProvider = this.actionProvider = new ArtifactActionProvider({
					parentView: this,
					tableViewer: tableViewer,
					contentProvider: tableViewer.getContentProvider(),
					artifactName: DefectsUIUtil.getMessagePart("labelLinkedRequirement"),
					artifactNamePlural: DefectsUIUtil.getMessagePart("labelLinkedRequirements")
				});
				tableViewer.setActionProvider(actionProvider);
				
				for (var i = 0; i < (this.columnActions ? this.columnActions.length : 0); i++) {
					var colAction = this.columnActions[i];
					actionProvider.addAction(
                    	colAction.labelSingle,
                    	colAction.labelMultiple,
                    	colAction.iconClass, 
                    	colAction.isVisibleCallback, // visible only on "normal" artifacts
                    	colAction.isEnabledCallback, // visible only on "normal" artifacts
                    	colAction.actionId, 
                    	this, 
                    	colAction.actionHandler);
				}	
			}
			
			tableViewer.show();
            
            dojo.forEach(this.actionsInGeneralView, function(actionButton){
            	dojo.style(actionButton.domNode, 'display', 'none');
            });
            dojo.forEach(this.actionsInCoverageView, function(actionButton){
            	dojo.style(actionButton.domNode, 'display', '');
            });
            
            this.tableViewer.setContent([]);
            tableViewer.setTableRowsCheckable(true, /* isSingleSelect */ false);
        	this.tableViewer.refresh();
        },
   		 
   		// @override - Handle view mode changed
	    _handleViewModeChanged: function(viewMode){
	        this.tableViewModeId = viewMode.id;
	        //clear sortByColumn values set in the other view mode
	        this.tableViewer.clearAllSortValues(true);
	        
	        //clear groupByColumn values
	        this.tableViewer.setGroupByColumn(null, true);
	        
			if(viewMode.id == 'coverage'){
					this._initialCoverageView();
					this.coverageViewRefreshAction.actionHandler(this.filters);
			} else {
				this._initialGeneralView();
				this.generalViewRefreshAction.actionHandler();
			}			
	   },
	   
	   //reset the content of the table when the value of the group by control changes 
	   _resetContentOnTableContentGroupByChanged: function(groupByColIndex){
	   		if(groupByColIndex > -1 && this.tableProvider.columnProfile[groupByColIndex].dbName == "collection")
    		{
    			this.tableViewer.setContent(this.dataForTableGroupByCollection);
			} else {
				this.tableViewer.setContent(this.dataForTableWithoutGroupBy);
			}
	   }
	  });
	  
	  	dojo.declare("Requirement.BulkChangeAction", 
             com.ibm.rqm.planning.web.ui.internal.model.action.BulkChangeAction, 
		{
	    artifactType: Constants.MODEL_TYPE_REQUIREMENT,
	    
	    invokePost: function(responseHandler, params)
	    {
	    	var _self = this;
	        this.inherited("invokePost", arguments);
	        if (this.actionId == "risk") {
	            var svcArgs = {
	                itemIds: params.uid,
					riskProfileItemId: params.riskProfileItemId,
	                riskProfileReplace: params.riskProfileReplace
	  
	            };		
				RequirementWorkItemClient.postBulkUpdate(responseHandler, svcArgs)
	        } else {
            // needs to remap the args for the requirement service.
            var args = {
                'ids': params.artifactItemIds,
                'ownerUUID': params.ownerId
            }
            if(this.remote)
    			args.processArea = this.projectAreaId;
            RequirementWorkItemClient.postReassignRequirementOwner(responseHandler, args)
        }
   		 }
	});
    
})();
