//RunSuiteDialog
/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2015. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
/*
 * Selection Popup for Script Adapter selection for a Suite
 * Author: vasrivas
 */
dojo.provide("com.ibm.rqm.execution.web.ui.internal.view.suite.RunSuiteDialog");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("jazz.app.context");
dojo.require("jazz.ui.MessageBox");

dojo.require("com.ibm.rqm.execution.web.ui.internal.view.table.TestSuiteStepsTableView");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.rqm.execution.web.ui.internal.util.Utility");
dojo.require("com.ibm.rqm.execution.web.client.internal.execution.TestExecutionSuiteClient");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.table.MachineAdapterTableView");
dojo.require( "com.ibm.asq.common.web.ui.internal.util.SelectUtility" );
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer");
dojo.require("com.ibm.asq.common.web.ui.internal.util.Utility");
dojo.require("com.ibm.rqm.execution.web.client.internal.execution.ExecutionResultStateClient");
dojo.require("com.ibm.rqm.planning.web.client.internal.planning.PlanningPageClient");
dojo.require("com.ibm.rqm.process.web.client.internal.timebox.TimeboxClient");
dojo.require("com.ibm.asq.common.web.ui.internal.util.CSHelp");
dojo.require("com.ibm.asq.common.web.client.internal.PermissionsClient");
dojo.require("com.ibm.rqm.buildintegration.web.ui.internal.view.build.BuildList");
dojo.require("com.ibm.rational.test.lm.web.client.internal.collections");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.layout.FormDateField");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.ExecutionConstraintsUtil");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.administration.workflow.WorkflowManager");
dojo.require("com.ibm.rqm.execution.web.client.internal.execution.ExecutionResultStates");
dojo.require("com.ibm.rqm.execution.web.client.internal.execution.ToolAdapterRegistrationClient");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.rational.test.lm.web.client.internal.config");
dojo.require("com.ibm.rational.test.lm.web.client.internal.channel");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.ExecutionAdminSettingsUtil");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.progressStatus.ProgressStatusMonitor");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.construction.ExecutionVarsWidget");
dojo.require("com.ibm.rqm.planning.web.client.internal.construction.TestSuiteClient");
dojo.require("com.ibm.asq.common.web.ui.internal.util.BidiUtil");

(function(){ 
	var ExecutionAdminSettingsUtil 		= com.ibm.rqm.planning.web.ui.internal.util.ExecutionAdminSettingsUtil;
	var ServiceResponseHandler			= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
	var ImageCache     					= com.ibm.rqm.execution.web.ui.internal.view.common.ImageCache;
	var CommonImageCache				= com.ibm.asq.common.web.ui.internal.view.common.ImageCache;
	var TestExecutionSuiteClient		= com.ibm.rqm.execution.web.client.internal.execution.TestExecutionSuiteClient;
	var Utility							= com.ibm.rqm.execution.web.ui.internal.util.Utility;
	var MachineAdapterTV				= com.ibm.rqm.execution.web.ui.internal.view.table.MachineAdapterTableView;
	var PlanningClient					= com.ibm.rqm.planning.web.client.internal.planning.PlanningPageClient;
	var TimeboxClient					= com.ibm.rqm.process.web.client.internal.timebox.TimeboxClient;
	var TC_ID							= "_tc_";
	var SCRIPT_ID 						= "_scirpt_";
	var ADAPTER_ID 						= "_adp_";
	var ADAPTER_IMG_ID 					= "_adpImg_";
	var CHG_ID							= "_chg_";
	var Constants 						= com.ibm.rqm.planning.web.client.internal.Constants;
	var SelectUtility 					= dojo.getObject( "com.ibm.asq.common.web.ui.internal.util.SelectUtility" );
	var TableConstants 					= com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants;
	var ASQCommonUtility 				= com.ibm.asq.common.web.ui.internal.util.Utility;
	var PermissionsClient           	= com.ibm.asq.common.web.client.internal.PermissionsClient;
	var BuildList 						= com.ibm.rqm.buildintegration.web.ui.internal.view.build.BuildList;
	var SelectionDialog 				= com.ibm.asq.common.web.ui.internal.widgets.SelectionDialog;
	var ExecutionConstraintUtil 		= com.ibm.rqm.planning.web.ui.internal.util.ExecutionConstraintsUtil;
	var WorkflowManager         		= com.ibm.rqm.planning.web.ui.internal.view.administration.workflow.WorkflowManager;
	var _textContent					= dojo.isIE?"innerText":"textContent";
	var ExecutionResultStates 			= com.ibm.rqm.execution.web.client.internal.execution.ExecutionResultStates;
	var ToolAdapterClient				= com.ibm.rqm.execution.web.client.internal.execution.ToolAdapterRegistrationClient;
	var AlertDialog                     = com.ibm.asq.common.web.ui.internal.widgets.AlertDialog;
	var ProgressUtility             	= com.ibm.asq.common.web.ui.internal.widgets.progressStatus.ProgressUtility;
	var ExecutionVarsWidget 			= com.ibm.rqm.planning.web.ui.internal.view.construction.ExecutionVarsWidget;
	var TestSuiteClient					= com.ibm.rqm.planning.web.client.internal.construction.TestSuiteClient;
	var BidiUtil 						= com.ibm.asq.common.web.ui.internal.util.BidiUtil;
	
	dojo.declare("RunSuiteDialog.TableListener", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableListener,
	{        
		constructor: function(parentView) {
	       this.parentView = parentView;
	    },
	
	    rowCheckStateChanged: function(tableViewer, rowObject, state){
			var selectedRows = tableViewer.getCheckedRows();

			if(selectedRows == TableConstants.VIRTUAL_CONTENT_SELECT_ALL){
				// get current page rows to enable/disable skip execution action button
				selectedRows = tableViewer.getContent();
			}
			var selectionCount = selectedRows.length;
			var parentView = this.parentView;
			
			if(selectionCount >= 1)	{
				parentView.skipExecutionAction.setDisabled(false);
			}else{
				parentView.skipExecutionAction.setDisabled(true);
			}
	    },
	 
	    tableContentActionInvoked: function(tableViewer, actionId, callbackData, callback){                
	        if (callback === null && callbackData !== null && dojo.isFunction(callbackData)) {
	            callbackData();
	        }
			if (callback !== null && dojo.isFunction(callback)) {
	            if (callbackData !== null) {
	                callback(callbackData);
	            } else {
	                callback();
	            }
	        } 
	    },
	    
	    tableHeaderColumnActionInvoked: function(tableViewer, columnIndex, /* optional */actionId){
	    	if(columnIndex == 2) {	 // Machine
	    		this.parentView._onBulkChangeAdapter();
	    	}
	    }
	});
	dojo.declare("RunSuiteDialog.CellModifier", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellModifier,
	{
		setChangeListener: function(listener){
			this.changeListener = listener;
		},
		cellValueChanged: function(oldValue, newValue, rowObject, columnIndex){
			if(columnIndex == 1) {
				if(this.changeListener && this.changeListener._scriptChanged){
					this.changeListener._scriptChanged.apply(this.changeListener.context, [rowObject,newValue]);
				}
	        }    
		}
	});
	dojo.declare("com.ibm.rqm.execution.web.ui.internal.view.suite.RunSuiteDialog", [dijit._Widget, dijit._Templated, ExecutionAdminSettingsUtil], {
        templateString: '<div class= "com-ibm-rqm-execution-web-selection-popup">' +
						'<div dojoAttachPoint=\"_helpButton\" style=\"float:right;\"></div>' +
						'	<div dojoAttachPoint="_stepInfo" style=\"position: relative;\">' +
						'		<span dojoAttachPoint="_stepIcon"></span>' +
						'		<label class=\"step-label\" dojoAttachPoint="_stepLabel"></label>' +
						'	</div>' +
						'   	<div dojoAttachPoint="_messageNode" dojoType=\"jazz.ui.MessageBox\" dojoAttachEvent="onClose:_onMessageClose" tabIndex="0"></div>'+	
						'    <div dojoAttachPoint="_surroundingNode">'+
						'	<div dojoAttachPoint=\"_progressDiv\" class=\"asq-progress-image\"><span dojoAttachPoint=\"loadingText\" class=\"asq-progress-label\">${labelLoading}</span></div>' +
						'        <table width="100%" dojoAttachPoint="_serNode">' +
						'            <tr dojoAttachPoint=\"_TSERNode\">'+
						'                <td width=\"20%\"><label class=\"field-label\" for=\"${id}-serSelect\"><span>${labelSuiteExecutionRecord}</span></label></td>' +
						'                <td colspan="2">' +		
						'                    <select id=\"${id}-serSelect\" dojoAttachPoint=\"_serDropDown\" class=\"newitem-popup-select\" dojoAttachEvent=\"onchange: _handleSERChange\"></select>' +
						'                </td>'+
						'            </tr>'+
						'			 <tr dojoAttachPoint=\"_TPNode\">'+
						'                <td width=\"20%\"><label class=\"field-label\" for=\"${id}-testPlanSelect\"><span>${labelTestPlan}</span></label></td>' +
						'                <td colspan="2">' +		
						'                    <select id=\"${id}-testPlanSelect\" dojoAttachPoint=\"_TPValue\" class=\"newitem-popup-select\" dojoAttachEvent=\"onchange: _handlePlanChange\"></select>' +
						'                </td>'+
						'            </tr>'+
						'			 <tr dojoAttachPoint=\"_IterationNode\">'+
						'                <td width=\"20%\"><label class=\"field-label\" for=\"${id}-iterSelect\"><span>${labelIteration}</span></label></td>' +
						'                <td colspan="2">' +		
						'                    <select id=\"${id}-iterSelect\" dojoAttachPoint=\"_IterationValue\" class=\"newitem-popup-select\"></select>' +
						'                </td>'+
						'            </tr>'+
						'			 <tr dojoAttachPoint=\"_ConfigNode\">'+
						'                <td width=\"20%\"><label class=\"field-label\" for=\"${id}-configSelect\"><span>${labelConfig}</span></label></td>' +
						'                <td colspan="2">' +		
						'                    <select id=\"${id}-configSelect\" dojoAttachPoint=\"_ConfigValue\" class=\"newitem-popup-select\" dojoAttachEvent=\"onchange:_handleConfigChange\"></select>' +
						'                </td>'+
						'            </tr>'+
						'        </table>' +
						'        <table width="100%" dojoAttachPoint=\"_channelNode\"><tbody>' +
						'			 <tr>'+
						'                <td width=\"20%\"><label class=\"field-label\" for=\"${id}-channelSelect\"><span>${labelChannel}</span></label></td>' +
						'                <td colspan="2">' +		
						'                    <select id=\"${id}-channelSelect\" dojoAttachPoint=\"_channelValue\" class=\"newitem-popup-select\"></select>' +
						'                </td>'+
						'            </tr>'+
						'        </tbody></table>' +

						'        <table width="100%" dojoAttachPoint="_cellContainerNode">' +
						'			 <tr dojoAttachPoint=\"_cellNode\">'+
						'                <td width=\"20%\"><label class=\"field-label\" for=\"${id}-cellSelect\"><span>${labelTestCell}</span></label></td>' +
						'                <td colspan="2">' +		
						'                    <select id=\"${id}-cellSelect\" dojoAttachPoint=\"_cellValue\" class=\"newitem-popup-select\" dojoAttachEvent=\"onchange:_handleCellChange\"></select>' +
						'                </td>'+
						'            </tr>'+
						'        </table>' +
						'        <div dojoAttachPoint="_tableViewerNode" class="com-ibm-rqm-test-artifact-table-view" tabindex="-1"></div>'+
						'        <table width="100%" dojoAttachPoint="_planIterationNode">' +
						'			 <tr dojoAttachPoint=\"_BuildRecord\">'+
						'				 <th width=\"10%\"><label class=\"field-label\" for=\"${id}-build\"><span>${labelBuild}</span></label></th>'+
						'				 <td dojoAttachPoint=\"_BuildColumn\" class=\"bordercell\"><span id=\"${id}-build\" tabindex="0" dojoAttachPoint=\"_buildValue\"></span></td>' +
						'				 <td><span dojoAttachPoint=\"_changeBuildNode\"></span></td>'+
						'			 </tr>'+
						'        </table>' +												
						'        <table width="100%" dojoAttachPoint="_planIterationNode">' +
						'			 <tr><td colspan="3"><br></td></tr>'+
						'			 <tr dojoAttachPoint=\"_executeLaterRow\">' +
						'				<td width=\"42%\">'+
						'					<input id=\"${id}-execute-later\" type=\"checkbox\" dojoAttachPoint=\"_executeLater\" dojoAttachEvent=\"onclick: _onExecuteLaterChanged\"></input>' +
						'					<label class=\"field-label\" for=\"${id}-execute-later\">${labelExecuteLater}</label>' +						
						'			 	</td>' +
						'				<td colspan="2" class="date-cell"><div dojoAttachPoint=\"_scheduleDate\"></div></td>' +
						'			 </tr>' +						'            <tr>'+
						'                <td colspan="3" >' +		
						'                    <input id="${id}-parExec" class="check" dojoAttachPoint="parExecCheck" type="checkbox" dojoAttachEvent="onclick: _parExecCheckClicked"></input><label  for="${id}-parExec"><span  class=\"field-label\">${labelExecuteSuite}</span></label>' +
						'                </td>'+
						'            </tr>'+
						'            <tr>'+
						'                <td colspan="3">' +		
						'                    <input id="${id}-passVariable" class="check" dojoAttachPoint="passVariableCheckbox" type="checkbox"></input><label  for="${id}-passVariable"><span  class=\"field-label\">${labelPassVariablesSeqMode}</span></label>' +
						'                </td>'+
						'            </tr>'+
						'            <tr>'+
						'                <td colspan="3">' +		
						'                    <input id="${id}-haltOnFailure" dojoAttachPoint="haltOnFailureCheckbox" type="checkbox"></input>' +
						'					<label for="${id}-haltOnFailure"><span class=\"field-label\">${labelHaltOnFailure}</span></label>'+			
						'                </td>'+
						'            </tr>'+
						'			<tr dojoAttachPoint=\"_quickResultRow\">'+
						'				<td colspan="3"><input id="${id}-quickResult" type=\"checkbox\" dojoAttachPoint=\"_quickResult\" dojoAttachEvent=\"onclick: _quickResultChange\"></input>'+
						'					<label for="${id}-quickResult"><span  class=\"field-label\">${labelCreateResult}</span></label>'+
						'				</td>'+
						'			</tr>'+
						'			<tr dojoAttachPoint=\"_verdictNode\">' +
	                    '				<td width=\"150px\"><label class=\"field-label\" for=\"${id}-vartictSelect\"><span>${labelSelectVerdict}</span></label></td>' + 
	                    '				<td><select id=\"${id}-vartictSelect\" dojoAttachPoint=\"_verdictValue\" class=\"newitem-popup-select\"></select></td>' +
						'				<td></td>' +
	                    '			</tr>' + 						
						'        </table>' +
						'		<table width="100%"><tr><td>' +
						'		<div dojoAttachPoint=\"_varDivNode\">' +
						'			<input id="${id}-showVariableTable" type=\"checkbox\" dojoAttachPoint=\"_showVariableTableCheckbox\" dojoAttachEvent=\"onclick: _onShowVariableTableClick\">'+
						'			<label class=\"field-label\" for="${id}-showVariableTable"><span>${labelModExecVars}</span></label>'+
						'    	</div></td></tr></table>'+
						'    </div>'+
						'</div>',
        
		width: "1000px",
		widgetsInTemplate: true,
		labelSuiteExecutionRecord: Constants.getMessage("colonMerger", Constants.getMessage("labelSuiteExecutionRecord")),
		labelTestPlan: Constants.getMessage("colonMerger",Constants.getMessage("labelTestPlan")),
		labelIteration: Constants.getMessage("colonMerger",Constants.getMessage("labelIteration")),
		labelConfig: Constants.getMessage("colonMerger", Constants.getMessage("labelConfig")),
		labelTitle: Constants.getMessage("labelExeTestSuiteDialog"),
		labelChannel: Constants.getMessage("labelChannel"),
		labelFinish: Constants.getMessage("labelFinish"),
		labelCancel: Constants.getMessage("labelCancel"),		
		labelExecuteSuite: Constants.getMessage("labelExecuteSuite"),
		labelCreateResult:Constants.getMessage("labelCreateResult"),
		labelSelectVerdict:Constants.getMessage("labelSelectVerdict"),
		labelModExecVars : Constants.getMessage("labelModExecVars"),
		labelPassVariablesSeqMode: Constants.getMessage("labelPassVariablesSeqMode"),
		labelHaltOnFailure: Constants.getMessage("labelHaltOnFailure"),
		labelBuild:Constants.getMessage("colonMerger",Constants.getMessage("labelBuildRecord")),
		labelTestCell: Constants.getMessage("labelTestCell"),
		labelExecuteLater:Constants.getMessage("colonMerger",Constants.getMessage("labelExecuteLater")),
		labelLoading: Constants.getMessage("labelLoading"),
		labelDefineRecDetails: Constants.getMessage("labelDefineRecDetails"),
		searchInCell: false,
		serExecution: false,
		insideSection: false,
		selectedTSER: null,
		resultStates:[],
		loading:false,
		parentTestPlan: null,
		_disableExecution: false,
		
        constructor: function(args){
			if(args && args.serExecution){
				this.serExecution = args.serExecution;
				this.selectedTSER = args.selectedTSER;
			}
			if(args && args.resultStates){
				this.resultStates = args.resultStates;				
			}
			this.buildRecordItemId = null;
			this.buildId = null;
			this.currentResultGroup = null;
			this.currentPassedResultSteps = [];
			if(dojo.isArray(this.resultStates) && this.resultStates.length == 0){
				var registryResponseHandler = new ServiceResponseHandler(this, "_setResultStates", "_error");
				com.ibm.rqm.execution.web.client.internal.execution.ExecutionResultStateClient.getExecutionResultStates(registryResponseHandler, {
					includeHidden: false
				});
			}	
			this.showInitLoadProgress = false;
			WorkflowManager.loadWorkflows();
		},
        
        postCreate: function(){
        	this.setCallBackFunction(dojo.hitch(this, "_setExecPref"));
        	if(this.mySection && this.mySection.compositeDTO){
        		this._setExecutionPreference(this.mySection.compositeDTO.executionSystemConstraintsProjectOption)
        	} else  {
        		this.initPreferences();
        	}
			this.TC_ID = this.id+TC_ID;
			this.SC_ID = this.id+SCRIPT_ID;
			this.ADP_ID = this.id+ADAPTER_ID;
			this.ADP_IMG_ID = this.id+ADAPTER_IMG_ID;
			this.CHG_ID = this.id+CHG_ID;
			if (this.serExecution || this.inSequenceEditor) {
				this.sersAvailable = true;
				ASQCommonUtility.destroyWidgetsFromNode(this._serNode);
				dojox.xml.parser.removeChildren(this._serNode);
			}
			
			if (this.inSequenceEditor) {
				this._cellContainerNode.style.display = "none";
				this._channelNode.style.display = "none";
				this._planIterationNode.style.display = "none";
				this._varDivNode.style.display = "none";
				this._messageNode.style.display = "none";
				this.loading = true;
			}
			if(dojo.isArray(this.resultStates) && this.resultStates.length > 0){
				this._setResultStates(this.resultStates);
			}
		},
		showHideProgressInfo: function(){			
			if(this.loading){
				dojo.style(this._progressDiv, "visibility", "visible");
				dojo.style(this._surroundingNode, "visibility","hidden");				
				this.loading = false;
			} else{
				dojo.style(this._progressDiv, "visibility", "hidden");
				dojo.style(this._surroundingNode, "visibility","visible");				
				this.loading = true;
			}			
		},
		_setResultStates:function(verdicts){
			var len = verdicts.length;
			var combo = this._verdictValue;
			for(var i=0 ; i<len ; i++){
				/* wi 73124
				 * if(verdicts[i].id == ExecutionResultStates.PAUSED || verdicts[i].id ==  ExecutionResultStates.IN_PROGRESS) {
					continue;
				}*/
				var option = new Option(verdicts[i].name, verdicts[i].id ? verdicts[i].id : verdicts[i].name);
				SelectUtility.add( combo, option );
			}
		},
		_quickResultChange:function(evt){
			if(this._quickResult.checked){
				this._verdictNode.style.display = "";
				this._executeLater.disabled = true;
			}else{
				this._verdictNode.style.display = "none";
				this._executeLater.disabled = false;
			}
		},
		
		hideCellSection: function(bool/*true if hide*/){
			if(bool)
				this._cellContainerNode.style.display = "none";
			else	
				this._cellContainerNode.style.display = "";
		},
		
		initialize: function(suite){
			this.suite = suite;
			var teamArea = suite.teamArea;
			if(this.selectedTSER){
				teamArea = this.selectedTSER.teamArea;
				this._initUpdateChannelsDropDown();
			}			
			this.showHideProgressInfo();			
			if(this.mySection && this.mySection.compositeDTO){
				ExecutionConstraintUtil.setConstraints(teamArea, this.mySection.compositeDTO.advisorsEnabledForExecute, Constants.MODEL_TYPE_SUITE);
				this._initialize();
			} else {
				ExecutionConstraintUtil.loadConstraints(
						Constants.MODEL_TYPE_SUITE, teamArea, dojo.hitch(this, "_initialize"));
			}
			},
			
		_initialize: function(){
			var suite = this.suite;
			var teamArea = suite.teamArea;
			if(this.selectedTSER){
				teamArea = this.selectedTSER.teamArea;
			}
			if (!this.inSequenceEditor && ExecutionConstraintUtil.isConstraintEnabled(
						ExecutionConstraintUtil.TestSuiteConstraint, Constants.MODEL_TYPE_SUITE, teamArea)) {
				//check for approved test suite.
				var state = suite.state;
				if(!WorkflowManager.stateBelongsToApproved(state, Constants.MODEL_TYPE_SUITE)){
					var errorStr = Constants.getMessage("msgCannotExecuteTestSuiteNotApproved", suite.name);
					alert(errorStr);
					return;
				}
			}
			this._verdictNode.style.display = "none";
			if(this.insideSection) {
				this._quickResultRow.style.display = "none";
				this._BuildRecord.style.display = "none";
			}

			dojo.style(this._surroundingNode, "display", "");
			this._messageNode.hideMessage();
			this.showAsDialog = false;
			
			if (!this.serExecution && !this.inSequenceEditor) {
				var registryResponseHandler = new ServiceResponseHandler(this, "_showSER", "_error");
				TestExecutionSuiteClient.getTestExecutionSuiteSummaryDTOs(registryResponseHandler, {
					suiteVersionableItemId: suite.versionableItemId
				});
			}
			
			if(!this.inSequenceEditor && suite.testcellItemId){
				this.searchInCell = true;
			}else{
				this.searchInCell = false;
			}	
			if(!this.inSequenceEditor){
				var collectionsService = new com.ibm.rational.test.lm.web.client.internal.collections();
				var responseHandler = new ServiceResponseHandler(this, "_loadCellSuccess", "_loadCellFailure");
				collectionsService.getAllTestCells(responseHandler);
			}else{
				if(suite.testcellItemId){
					var proxyCell = {name: suite.testcellName, itemId: suite.testcellItemId};
					this._loadCellSuccess([proxyCell]);
				}else{
					this._loadCellSuccess();
				}	
			}
			this.elements = [];
			var noScriptMsg = "";
			this.elements = this.suite.steps;			
			this._messageNode.hideMessage();
			this._showAsDialog(true);
			this.parExecCheck.checked = this.suite.sequentialExecution ? false : true;//Checkbox is for parallel wi6856
			this.passVariableCheckbox.checked = this.suite.passVariables ? true : false;
			this.haltOnFailureCheckbox.checked = this.suite.haltOnFailure ? true : false;
			this._parExecCheckClicked();
			this.showInitLoadProgress = true;
			if(this.inSequenceEditor){
				this.showHideProgressInfo();
			}
			this._showTable();
			if (this.serExecution) {
				if(this.selectedTSER && this.selectedTSER.currentResultGroupStateId == ExecutionResultStates.IN_PROGRESS){
					this._showExecutionInProgressMessage(this.selectedTSER);
				}
			}else if(this.inSequenceEditor){
				if (suite.stepAdapters) {
					this._updateSuiteStepsWithAdapters(suite.stepAdapters);
				}
				else {
					if (Constants.MODEL_TYPE_EWI != suite.executionRecordType) {
						this._searchAdaptersForSuiteSteps(null,suite.itemId,suite.configId);	
					}
					else {
						if(suite.steps[0].selectedScriptTypeId) {
							var params = {};
							params.type = suite.steps[0].selectedScriptTypeId;
							if(suite.steps[0].selectedScriptId){
								params.favoriteMachineScript = suite.steps[0].selectedScriptId;
							}
							if(suite.steps[0].configID){
								params.confItemId = suite.steps[0].configID;
							}
							//Send -1 for 'heartBeatAgeInSecond' to search adapters of all health
							params.heartBeatAgeInSecond = -1;
					
							var responseHandler = new ServiceResponseHandler(this, "_searchSuccess", "_error");
							ToolAdapterClient.getSearchAdaptersForExecutionDTO(responseHandler, params);
						}
						else {
							this._searchSuccess([]);
						}
					}
				}
			}
			this._appendBuildChangeNode();
			var tableViewer = this.tableViewer;			
			this.showInitLoadProgress = false;
			tableViewer.endLoadingProgress();
		},
		
		_searchSuccess:function(adapters){
			if(adapters && adapters.length > 0){
				var adapter = adapters[0];
				
				var adapterInfo = {};
				adapterInfo.adapterId = adapter.id;
				adapterInfo.adapterName = adapter.name;
				adapterInfo.adapterHostName = adapter.hostName;
				adapterInfo.adapterHealth = adapter.health;
				
				var stepAdapters = [];
				stepAdapters.push(adapterInfo);
				this._updateSuiteStepsWithAdapters(stepAdapters);
			}else{
				this._updateSuiteStepsWithAdapters(null);
			}
		},
		
		searchAdapters: function(){
			var selectedSER = ((this._serDropDown.value == "global") || (this._serDropDown.value == "new"))? null:(this._serDropDown.selectedIndex != -1 ? this._serDropDown.options[this._serDropDown.selectedIndex].serObj : null);
			var serItemId = selectedSER ? selectedSER.itemId : (this.selectedTSER ? this.selectedTSER.itemId : null); 
			var serconfigId = selectedSER ? selectedSER.configId : null;
			this._searchAdaptersForSuiteSteps(this.suite.versionableItemId, serItemId, serconfigId);
		},
		
		_searchAdaptersForSuiteSteps: function(suiteVersionableItemId,tserItemId,configurationItemId){
			if(!this.stepsTableViewer){
				//wait for the table to be created and then call this search
				console.debug("table not loaded yet");
				setTimeout(dojo.hitch(this, "_searchAdaptersForSuiteSteps", arguments));
			}
			var params ={};			
				params.suiteVersionableItemId = suiteVersionableItemId;
				params.tserItemId = tserItemId;
				params.configurationItemId = configurationItemId;
			var self = this;
			var handler = {
        		success: function(suite){					
					self._beforeUpdateStepWithAdapters(suite.stepAdapters);
				},
		        error: function(err){
					self._error(err);
				}
			};
			
			var elements = this.stepsTableViewer.getUnloadedCurrentElements();
			var stepItemIds = [];
			var elementslength = elements ? elements.length : 0;
			for (var i=0;i<elementslength;i++){
				stepItemIds[i] = elements[i].internalId;
			}
			params.stepItemIds = stepItemIds;
			var responseHandler = new ServiceResponseHandler(handler, "success", "error");
			TestExecutionSuiteClient.getSearchAdaptersForSuiteStepsDTO(responseHandler, params);
		},
		
		_beforeUpdateStepWithAdapters: function(stepAdapters) {
			if(!this.searchInCell && this.isRunSuiteInSingleAdapterEnabled()) {
				this.verifyAllStepsScriptType(dojo.hitch(this, function(status){
					this._updateSuiteStepsWithAdapters(stepAdapters);
					if(status.isOK && status.isSameScriptType && status.scriptType && 
							(status.scriptType != "com.ibm.rqm.planning.common.scripttype.manual")) {
						var curElements = this.stepsTableViewer.getCurrentElements();
						var curElement = curElements[0];
						var stepScriptTypeDtos = status.stepScriptTypeDtos;
						if(stepScriptTypeDtos && (stepScriptTypeDtos.length > 0)) {
							var self = this;
							dojo.forEach(stepScriptTypeDtos, function(stepScriptTypeDto) {
								var cachedElement = self.stepsTableViewer.getCachedElementForId(stepScriptTypeDto.internalId);
								if(!cachedElement) {
									var newElement = stepScriptTypeDto;
									newElement.machine = curElement.machine;
									newElement.adapterId = curElement.adapterId;
									newElement.adapterImg = curElement.adapterImg;
									newElement.adapterStatus = curElement.adapterStatus;
									// add forward reference of the element in the cache
									self.stepsTableViewer.addForwardRefToCache(newElement);
								}
								else if(cachedElement.adapterId != curElement.adapterId){
									// Update machine details for cached elements
									cachedElement.machine = curElement.machine;
									cachedElement.adapterId = curElement.adapterId;
									cachedElement.adapterImg = curElement.adapterImg;
									cachedElement.adapterStatus = curElement.adapterStatus;
								}
							});
						}
					}
				}));
			}
			else {
				this._updateSuiteStepsWithAdapters(stepAdapters);
			}
		},
		
		_updateSuiteStepsWithAdapters: function(stepAdapters){
			var listofStepAdapters = dojo.isArray(stepAdapters) ? stepAdapters : [];
			var elements = this.stepsTableViewer.getUnloadedCurrentElements();
			var eleLen = elements ? elements.length : 0;
			var runtimeSelection = false;
			if((this.insideSection && this.getAdapterSelectionType() == this.runtimeSelection.toUpperCase()) || this.searchInCell){
				runtimeSelection = true;
			}
			for(var i=0;i<eleLen;i++){
				if(!elements[i].selectedScriptTypeId){
					elements[i].machine = {
						name: Constants.getMessage("labelNotApplicable"),
						adapterInfo: {
							id: null,
							name: Constants.getMessage("labelNotApplicable"),
							hostName: Constants.getMessage("labelNotApplicable")
						},
						machineName: Constants.getMessage("labelNotApplicable")
					};
					elements[i].adapterImg = ImageCache.NOIMAGE;
					elements[i].adapterStatus = null;
					elements[i].selectionCriteria = null;
				}else if(elements[i].selectedScriptTypeId != "com.ibm.rqm.planning.common.scripttype.manual"){
					if(runtimeSelection){
						elements[i].machine = {
							name: Constants.getMessage("labelSearchRuntime"),
							adapterInfo: {
								id: "runtime",
								name: Constants.getMessage("labelSearchRuntime"),
								hostName: Constants.getMessage("labelSearchRuntime")
							},
							machineName: Constants.getMessage("labelSearchRuntime")
						};
						elements[i].adapterImg = ImageCache.NOIMAGE;
						elements[i].adapterStatus = "";
						elements[i].adapterId = null;
						elements[i].selectionCriteria = "runtime";
					}else{
						var adpterLength = listofStepAdapters ? listofStepAdapters.length : 0;
						var adapterInfo = null;
						var stepInternalId = elements[i].internalId;
						for(var j = 0; j < adpterLength; j++){
							if(stepInternalId == listofStepAdapters[j].stepItemId){
								adapterInfo = listofStepAdapters[j];
								break;
							}
						}
						elements[i].selectionCriteria = null;
						elements[i].machine = {
							name: adapterInfo.adapterName ? adapterInfo.adapterName : "",
							adapterInfo: {
								id: adapterInfo.adapterId ? adapterInfo.adapterId : "",
								name: adapterInfo.adapterName ? adapterInfo.adapterName : "",
								hostName: adapterInfo.adapterHostName ? adapterInfo.adapterHostName : ""
							},
							machineName: adapterInfo.adapterHostName ? adapterInfo.adapterHostName :
								this.isRunOnReservedMachineEnabled() ? Constants.getMessage("labelNoMachineReserved") : Constants.getMessage("labelNotFound"),
							health: adapterInfo.adapterHealth ? adapterInfo.adapterHealth: null,
							lastHeartBeat: adapterInfo.lastHeartBeat, 
							hostName: adapterInfo.adapterHostName ? adapterInfo.adapterHostName : "",
							requestsInQueue: adapterInfo.adapterRequestsInQueue ? adapterInfo.adapterRequestsInQueue : 0
						};
						elements[i].adapterId = adapterInfo.adapterId ? adapterInfo.adapterId : "";
						this._getAdapterStatus(elements[i]);						
					}
				}else{
					elements[i].machine = {
						name: Constants.getMessage("labelLocalComputer"),
						adapterInfo: {
							id: "global",
							name: Constants.getMessage("labelLocalComputer"),
							hostName: Constants.getMessage("labelLocalComputer")
						},
						machineName: Constants.getMessage("labelLocalComputer")
					};
				}
			}
			if (this.tableViewer) {
//				this.tableViewer.setContent(elements);
				this.tableViewer.refresh();
			}
			
			if(this._dialog && !this._disableExecution){
				this._dialog.getOkButton().disabled = false;
			}		
		},
		
		_appendBuildChangeNode: function(){
			this._buildValue.innerHTML = Constants.getMessage("labelUnassigned"); 
			this._buildValue.title = Constants.getMessage("labelUnassigned"); 
			if(this.editBuildEvent){
					this.disconnect(this.editBuildEvent);
					this.editBuildEvent = null;
			}				
			if(this.clearBuildEvent){
				this.disconnect(this.clearBuildEvent);
				this.clearBuildEvent = null;
			}
			var editImg = document.createElement("img");
			editImg.src = CommonImageCache.EDIT;
			editImg.alt = Constants.getMessage("labelChangeAssociatedBuild");
			editImg.title = Constants.getMessage("labelChangeAssociatedBuild");
			editImg.tabIndex = "0";
			this.editBuildEvent = this.connect(editImg, "onclick", "onBuildChangeClick");
			var clearImg = document.createElement("img");
			clearImg.src = CommonImageCache.CLEAR_FILTER_ENABLED;
			clearImg.alt = Constants.getMessage("labelClearAssociatedBuild");
			clearImg.title = Constants.getMessage("labelClearAssociatedBuild");
			clearImg.tabIndex = "0";				
			this.clearBuildEvent = this.connect(clearImg, "onclick", "onBuildClearClick");
			dojox.xml.parser.removeChildren(this._changeBuildNode);
			this._changeBuildNode.appendChild(editImg);
			this._changeBuildNode.appendChild(clearImg);
		},
		setCSHelpId: function(helpId){	        
	        if (this._helpButton) {
	            dojox.xml.parser.removeChildren(this._helpButton);
	            if (helpId) {
	                this._helpButton.style.display = "inline";
	                var args = {
	                    'contextID': helpId
	                };
					if(this.cshelp)
						this.cshelp.destroy();
	                this.cshelp = new com.ibm.asq.common.web.ui.internal.util.CSHelp(args);
	                this._helpButton.appendChild(this.cshelp.domNode);
	            } else {
	                this._helpButton.style.display = "none";
	            }
	        }
	    },

		_showSER: function(sers){
			this.sersList = sers;
			var combo = this._serDropDown;
			var len = sers && sers.length ? sers.length : 0;
			var tserPerm = PermissionsClient.getStoredPermission(PermissionsClient.OP_EXECUTION_TSER);
			var tcerPerm = PermissionsClient.getStoredPermission(PermissionsClient.OP_EXECUTION_EWI);
			if ((!tserPerm || tserPerm.create) && (!tcerPerm || tcerPerm.create)) { 
				var option = new Option(Constants.getMessage("labelNewTSER"), "new");
				SelectUtility.add(combo, option );
				var selectId = "new";
				SelectUtility.select(combo,selectId);
			} else if (len == 0){
				this._dialog.getOkButton().disabled = true;
				this.showMsg(Constants.getMessage("msgNoTSERCreatePermission"),jazz.ui.MessageBox.STATUS_TYPES.ERROR);
				dojo.style(this._surroundingNode, "display", "none");
				this._showAsDialog(true);
				return;
			} else if (!tcerPerm.create)
			{
				this._dialog.getOkButton().disabled = true;
				this.showMsg(Constants.getMessage("msgNoTCERCreatePermissionFromRunSuiteDialog"),jazz.ui.MessageBox.STATUS_TYPES.ERROR);
				dojo.style(this._surroundingNode, "display", "none");
				this._showAsDialog(true);
				return;
			}
			 
			if(len > 0){
				var requiredSER = null;
				var serWithNoResult = false;
				for(var i=0;i<len;i++){
					var ser = sers[i];
					if(this.parentTestPlan != null && (!ser.testPlanId || (this.parentTestPlan.id != ser.testPlanId)) )
					{						
						continue;
					}
					
					var option = new Option(BidiUtil.enforceTextDirWithUcc(ser.name), ser.id ? ser.id : ser.name);
					option.serObj = ser;
					SelectUtility.add( combo, option );
					
					if(serWithNoResult){
						continue;
					}
					if(ser.currentResultGroupEndTime > 0){
						if(requiredSER){
							if(ser.currentResultGroupEndTime > requiredSER.currentResultGroupEndTime){
								requiredSER = ser;
							}
						}else
							requiredSER = ser;
					}else{
						requiredSER = ser;
						serWithNoResult = true;						
					}
				}
				if(requiredSER){
					selectId = requiredSER.id;
					SelectUtility.select(combo, selectId);
					if(requiredSER.currentResultGroupStateId == ExecutionResultStates.IN_PROGRESS){
						this._showExecutionInProgressMessage(requiredSER);
					}
				}
			}
			this._getTestPlanInfo(this.suite);
		},
				
		_getTestPlanInfo: function(suite){
			if (suite) {
				if(this.parentTestPlan)
				{
					var plan = [this.parentTestPlan];
					 this._setAllPlans(plan);
				}
				else{
					var responseHandler = new ServiceResponseHandler(this, "_setAllPlans", "_error");
					PlanningClient.getRelatedTestPlanBySuiteMinimalSummaryDTO(responseHandler, {uuid: suite.versionableItemId, includeRetiredPlan: false});
				}
            }
			
		},
		
		_setAllPlans: function(plans){
			this.allPlans = plans?plans:[];			
			var allPlans = this.allPlans;
			var allPlansLength = allPlans.length;
			for (var i = 0; i < allPlansLength; i++) {				
				var callbackObj = {
					index:i,
					self:this,
					success: function(results){
						this.self._getTestPhaseSummary(results, this.index);
					},
					failure: function(e){
						this.self._error(e);
					}
				};
				var responseHandler2 = new ServiceResponseHandler(callbackObj, "success", "failure");
				PlanningClient.getConfigurations(responseHandler2, allPlans[i].versionableItemId);
			}
			if(allPlansLength == 0)
				this._getConfigInfo();
		},
		
		_getTestPhaseSummary:function(results, i){
			var allPlans = this.allPlans;
			allPlans[i].configurations = results;
			var shouldContinueCall =  (allPlans.length-1 == i);
			var self =  this;
			var callBackObject ={
					appendIterations: function(iterations){
						if(iterations && iterations.length > 0){
							var allPlans = self.allPlans;
							var iterationsTargetTestPlanUUID = iterations[0].targetTestPlanUUID;
							var allPlansLength = allPlans.length;
							for(var i=0;i<allPlansLength;i++){
								if(allPlans[i].versionableItemId === iterationsTargetTestPlanUUID){
									allPlans[i].iterations = iterations;
									break;
								}	
							}
						}
						if(shouldContinueCall)
							self._getConfigInfo();
					},
					error:function(e){
						self._error(e);
					}
			};
			var responseHandler = new ServiceResponseHandler(callBackObject, "appendIterations", "error");
			TimeboxClient.getTestPhasesSummaryDTO(responseHandler, {
				testPlanId: allPlans[i].versionableItemId
			});
		},
		
		_getConfigInfo:function(){
			try{
				var responseHandler= new ServiceResponseHandler(this, "_setAllConfigs", "_error");
				var cfg = new com.ibm.rational.test.lm.web.client.internal.config();
				cfg.getAll(responseHandler);
			}catch(e){
				console.error("Could not load files lm.config");	
			}
		},
		
		_setAllConfigs: function(response){
			this.allConfigs = (response) ? response : [];
			this._handleSERChange();
		},
		
		_handleSERChange: function(event){
			if(this._messageNode && !this.searchInCell  && !this._disableExecution){
				this._messageNode.hideMessage();
			}
			this.skipPassedClicked = false;
			this.skipPassedStepsAction._setSelectedAttr(false);
			//filter Configuration, changePlan
			var selectedSER = ((this._serDropDown.value == "global") || (this._serDropDown.value == "new"))? null:(this._serDropDown.selectedIndex != -1 ? this._serDropDown.options[this._serDropDown.selectedIndex].serObj : null);
			if(selectedSER == null){
				if(this.isCreateTCERWithTSEREnabled()  && !this._disableExecution)
					this.showMsg(Constants.getMessage("msgCreatingTSERandTCERAutomaticallyInRunDialog"),jazz.ui.MessageBox.STATUS_TYPES.INFO);
				this.sersAvailable = false;
				this._enableSERSettingSection();
				var selectedConfig = null;   //reset config selection
				this._setConfigs(this.allConfigs,selectedConfig);
				this._setPlans(this.allPlans,this.parentTestPlan?this.parentTestPlan.id:null);
				this._setIterations();
				if(this.parentTestPlan != null)
					this._enablePlanCheckvalue(false);
				else
					this._enablePlanCheckvalue(true);
				this._searchAdaptersForSuiteSteps(this.suite.versionableItemId,null,null);
			}else{				
				if(selectedSER.currentResultGroupStateId == ExecutionResultStates.PAUSED){
					this._showExecutionInProgressMessage(selectedSER);
				}				
				else if(this.isCreateTCERWithTSEREnabled()  && !this._disableExecution)
					this.showMsg(Constants.getMessage("msgCreatingTCERAutomaticallyInRunDialog"),jazz.ui.MessageBox.STATUS_TYPES.INFO);
				this.sersAvailable = true;
				this._disableSERSettingSection();
				var planId = selectedSER.testPlanId ? selectedSER.testPlanId : null;
				var configId =  selectedSER.configId;
				if(this._ConfigValue.options.length == 0)
					this._setConfigs(this.allConfigs,configId);
				else if(configId)
					SelectUtility.select(this._ConfigValue, configId);
				else
					SelectUtility.select(this._ConfigValue, "global");
				this._setPlans(this.allPlans,planId);
				if (planId == null) 
					this._setIterations();
				else {
					var allPlans = this.allPlans;
					var allPlansLength = allPlans.length;
					for (var i = 0; i < allPlansLength; i++) {
						if (allPlans[i].id == planId) {
							this._setIterations(allPlans[i], selectedSER.phaseItemId);
							break;
						}
					}
				}
				this._enablePlanCheckvalue(false);
				this._searchAdaptersForSuiteSteps(this.suite.versionableItemId,selectedSER.itemId,selectedSER.configId);
			}
			this._initUpdateChannelsDropDown();
			if(event){
                 dojo.stopEvent(event);
            }
		},
		
		_getSelectedPlan:function(){
			var selectedPlanId = this._TPValue.value;
			var selectedPlan = null;
			if (selectedPlanId != "global" && this.allPlans) {
				var allPlans = this.allPlans;
				var allPlansLength = allPlans.length;
				for(var j=0;j<allPlansLength;j++){
					if(allPlans[j].id == selectedPlanId){
						selectedPlan = this.allPlans[j];
						break;
					}
				}
			}
			return selectedPlan;
		},
		
		_handlePlanChange:function(event){
			var selectedPlan = this._getSelectedPlan();
			var selectedConfig = this._ConfigValue.value;
			if(selectedConfig == "global")
				selectedConfig = null;
			if (selectedPlan) {
				this._setIterations(selectedPlan);
				if (selectedPlan.configurations && selectedPlan.configurations.length > 0) {
					var configs = [];
					var selectedPlanConfigurationsLength = selectedPlan.configurations.length;
					var allConfigs = this.allConfigs;
					var allConfigsLength = allConfigs.length;
					for (var k = 0; k < selectedPlanConfigurationsLength; k++) {
						for (var j = 0; j < allConfigsLength; j++) {
							if (allConfigs[j].id == selectedPlan.configurations[k]) {
								configs.push(allConfigs[j]);
							}
						}
					}
					this._setConfigs(configs, selectedConfig);
				}else {
					this._setConfigs([]);
				}
				this._searchMatchingSER();
			}else {
				this._setIterations();
				this._setConfigs(this.allConfigs,selectedConfig);
			}
			this._setAdapters();
			if(event){
                 dojo.stopEvent(event);
            }
		},
		
		_handleConfigChange:function(event){
			this._searchMatchingSER();
			var selectedSER = ((this._serDropDown.value == "global") || (this._serDropDown.value == "new"))? null:(this._serDropDown.selectedIndex != -1 ? this._serDropDown.options[this._serDropDown.selectedIndex].serObj : null);
			if(selectedSER == null){
				var configId =null;
				if(this._ConfigValue){
					configId = this._ConfigValue.value;
				}
				this._searchAdaptersForSuiteSteps(this.suite.versionableItemId, null, configId);
			}else{
				this._searchAdaptersForSuiteSteps(this.suite.versionableItemId,selectedSER.itemId,selectedSER.configId);
			}
			if(event){
                 dojo.stopEvent(event);
            }
			this._initUpdateChannelsDropDown();	
		},
		
		_getSelectedSER: function(){
			var ser = null;
			if(this.serExecution){
				ser = this.selectedTSER;
			}else{
				ser = this._getSERFromList(this._serDropDown.value);
			}
			return ser;
		},
		
		_initUpdateChannelsDropDown: function(){
			var selectedSER = this._getSelectedSER();
			var channels = [];
			if(selectedSER){
				//if SER is present, get channels from it
				channels = selectedSER.channels;
				this._fillChannelsDropDown(channels);
			}else{
//				get config ID find the channels for that and render
				var configId = this._ConfigValue.value;
				if(configId != "global"){
					var responseHandler= new ServiceResponseHandler(this, "_fillChannelsForEnv", "_error");
					var cfg = new com.ibm.rational.test.lm.web.client.internal.config();
					cfg.retrieveConfigurationWithDetails(responseHandler, configId);
				}else{
					//GET list of empty channels
					var responseHandler= new ServiceResponseHandler(this, "_fillChannelsDropDown", "_error");
					var channelServ = new com.ibm.rational.test.lm.web.client.internal.channel();
					channelServ.getEmptyChannels(responseHandler);
				}
			}
		},
		
		_fillChannelsForEnv: function(config){
			this._fillChannelsDropDown(config.channels);
		},
		
		_fillChannelsDropDown: function(channels){
			channels = dojo.isArray(channels) ? channels : [];
			var len = channels.length;
			var combo = this._channelValue;
			dojox.xml.parser.removeChildren(this._channelValue);
			var option = new Option(Constants.UNASSIGNED_CHANNEL_NAME, "-1");
			SelectUtility.add( combo, option );
			for(var i=0 ; i<len ; i++){
				var option = new Option(BidiUtil.enforceTextDirWithUcc(channels[i].name), channels[i].id ? channels[i].id : channels[i].name);
				SelectUtility.add( combo, option );
			}
		},
		
		getSelectedChannel: function(){
			var selectedChannel = this._channelValue.value;
			if(selectedChannel && selectedChannel != "-1"){
				return selectedChannel;
			}
			return null;
		},
		
		
		_loadCellSuccess: function(cells){
			dojox.xml.parser.removeChildren(this._cellValue);
			var combo = this._cellValue;
			if(dojo.isArray(cells)){
				var cellsLen = cells.length;
				for (var i=0;i<cellsLen;i++){
					var option = new Option(BidiUtil.enforceTextDirWithUcc(cells[i].name), cells[i].itemId);
					if(this.suite.testcellItemId && cells[i].itemId == this.suite.testcellItemId){
						option.selected = true;
						this.searchInCell = true;
						this.showMsg(Constants.getMessage("msgUsingCellAssociatedNowForRunning"), jazz.ui.MessageBox.STATUS_TYPES.INFO);						
					}
					SelectUtility.add( combo, option );
				}
			}
			//Add Unassigned at the end
			var option = new Option(Constants.getMessage("labelUnassigned"), Constants.getMessage("labelUnassigned"));
			if(!this.suite.testcellItemId){
				option.selected= true;
			}
			SelectUtility.add( combo, option );
			
			if(this.inSequenceEditor){
				//Make this section disabled
				combo.disabled = true;
			}
		},
		
		_loadCellFailure: function(error){
			console.error("Cell fetch failure" + error.message);
		},
		
		_handleCellChange: function(){
			if(this._cellValue.value == Constants.getMessage("labelUnassigned")){
				this.searchInCell = false;
				this.suite.testcellItemId = null;//Clear the cell info so that search is done appropriately
				this._messageNode.hideMessage();				
			}else{
				this.searchInCell = true;
				this.suite.testcellItemId = this._cellValue.value;
				this.showMsg(Constants.getMessage("msgUsingCellAssociatedNowForRunning"), jazz.ui.MessageBox.STATUS_TYPES.INFO);
			}		
			this._setAdapters();
		},
		
		_onDateChange:function() {
			this._messageNode.hideMessage();
		},

		_onExecuteLaterChanged: function() {
			if(this._executeLater.checked){
				if (!this.datePicker) {
					var today = new Date();
					this.datePicker = new com.ibm.asq.common.web.ui.internal.widgets.layout.SimpleDateTimePickerFormField({
						minDate: today,
						currentValue: today,
						time: today,
						isRequired: false,
						showFieldLabel: false,
						onValueChanged: dojo.hitch(this, this._onDateChange)
					});
					this._scheduleDate.appendChild(this.datePicker.domNode);
				}
				this._quickResult.disabled = true;
				this.scheduleExecution = true;
				this._scheduleDate.style.display = "";
			} else {
				if (this.datePicker) {
					this._scheduleDate.style.display = "none";
				}
				this.scheduleExecution = false;
				this._quickResult.disabled = false;
			}			
		},

		
		_searchMatchingSER:function(){
			var selectedPlanId = this._TPValue.value;
			var selectedPhase = this._IterationValue.value;
			var selectedConfig = this._ConfigValue.value;
			var found = false;
			var allSERs = this.sersList;
			if(selectedPlanId != "global" && selectedPhase!="" && this.sersList){
				var allSERsLength = allSERs.length;
				for(var i=0;i<allSERsLength;i++){
					var ser = allSERs[i];
					if(ser.testPlanId && ser.testPlanId == selectedPlanId && 
							ser.phaseItemId && ser.phaseItemId == selectedPhase &&
							ser.configId && ser.configId == selectedConfig){
						
						SelectUtility.select(this._serDropDown, ser.id ? ser.id : ser.name);
						found = true;
						break;
					}
				}
			}
			if(!found){
				SelectUtility.select(this._serDropDown,"new");
			}
		},
		
		_setConfigs: function(configs, selectId){
			dojox.xml.parser.removeChildren(this._ConfigValue);
			if((!selectId) || (selectId == "global")){
				var option = new Option(Constants.getMessage("labelUnassigned"), "global");
				SelectUtility.add( this._ConfigValue, option );	
			}
			var configsLength = configs && configs.length ? configs.length : 0;
			for(var i=0;i<configsLength;i++){
				var config = configs[i];
				var option = new Option(BidiUtil.enforceTextDirWithUcc(config.name), config.id);
				if(selectId && selectId == config.id){
					option.selected = true;
				}
				SelectUtility.add( this._ConfigValue, option );					
			}	
		},
		
		_setPlans: function(plans, selectId){
			dojox.xml.parser.removeChildren(this._TPValue);
			if(!selectId){
				var option = new Option(Constants.getMessage("labelUnassigned"), "global");
				SelectUtility.add( this._TPValue, option );
			}
			var plansLength = plans ? plans.length : 0;
			for(var i=0;i<plans.length;i++){
				var plan = plans[i];
				var option = new Option(BidiUtil.enforceTextDirWithUcc(plan.name), plan.id);
				option.planObj = plan;
				if(selectId && selectId == plan.id){
					option.selected = true;
				}
				SelectUtility.add( this._TPValue, option );
			}	
		},
		
		_setIterations:function(selectedPlan,selectPhaseItemId){
			dojox.xml.parser.removeChildren(this._IterationValue);
			var selectedPlanIterationsLength = selectedPlan && selectedPlan.iterations ? selectedPlan.iterations.length : 0;			
			var option = new Option(Constants.getMessage("labelUnassigned"),"");
			SelectUtility.add(this._IterationValue, option);
			
			for (var i = 0; i < selectedPlanIterationsLength; i++) {
				var iter = selectedPlan.iterations[i];
				var option = new Option(BidiUtil.enforceTextDirWithUcc(iter.name),iter.itemId);
				
				if(!selectPhaseItemId && (selectedPlanIterationsLength == (i + 1))){
				    option.selected = true;   
				}
				SelectUtility.add(this._IterationValue, option);
			}
			if(selectPhaseItemId)
				SelectUtility.select(this._IterationValue,selectPhaseItemId);
		},
		
		_getSelectedPlanItemId: function(){
			var selectedId = this._TPValue.value;
			if(selectedId == "global") {
				return selectedId;
			}
			var itemId = "";
			var allPlans = this.allPlans;
			var allPlansLength = allPlans.length;
			for (var i = 0; i < allPlansLength; i++){
				var plan = allPlans[i];
				if(plan.id == selectedId){
					itemId = plan.versionableItemId;
					break;
				}
			}
			return itemId;
		},
		
		_enableSERSettingSection:function(){
			dojo.removeClass(this._ConfigNode, "message-disabled-simple");
			this._ConfigValue.disabled = false;
		},
		
		_disableSERSettingSection:function(){
			dojo.addClass(this._ConfigNode, "message-disabled-simple");			
			this._ConfigValue.disabled = true;
		},
		
		_enablePlanCheckvalue:function(enable){
			if(enable){
				dojo.removeClass(this._TPNode,"message-disabled-simple");
				dojo.removeClass(this._IterationNode,"message-disabled-simple");
				this._TPValue.disabled = false;
				this._IterationValue.disabled = false;
			}else{
				dojo.addClass(this._TPNode,"message-disabled-simple");
				dojo.addClass(this._IterationNode,"message-disabled-simple");
				this._TPValue.disabled = true;
				this._IterationValue.disabled = true;
			}
		},

		_showAsDialog: function(disableRunButton){
            if (!this._dialog) {
        		/*
        		 * Custom z-index is needed as hover popup wont show up
        		 * For FF3 pass zIndex
        		 */
		        var dialogArgs = {
					primaryTitle: this.labelTitle,
					okLabel: this.labelFinish,
					cancelLabel: this.labelCancel,
                    okCallback: dojo.hitch(this, "_onRunClick"),
                    cancelCallback: dojo.hitch(this, "_onCancelClick"),
                    nextCallback: dojo.hitch(this, "_showVariableTable"),
					style: "z-index: 999;",
					zIndex: 999,
					movable: true
                };
				if(this.selectedTSER){
					dialogArgs.csHelpID = "rqm_execution_test_suite_execution_record";
				}else{
					dialogArgs.csHelpID = "rqm_execution_test_suite.html";
				}
                this._dialog = new com.ibm.asq.common.web.ui.internal.widgets.SelectionWizard(dialogArgs);
                this._dialog.setWidth(this.width);
                this._dialog.contentContainer.appendChild(this.domNode);
                this._dialog.getOkButton().disabled = disableRunButton;                                
                this._dialog.getNextButton().disabled = true;
    			this._dialog.getPrevButton().disabled = true;
    			
    			// show first step number and label
    			this.firstStepIcon = this._getStepNumberIcon("1");
    			this._stepIcon.appendChild(this.firstStepIcon);
    			this._stepLabel.innerHTML = this.labelDefineRecDetails;
    			this._stepLabel.title = this.labelDefineRecDetails;
    			this._stepLabel.tabIndex = 0;
            }
			//this.setCSHelpId("rqm_execution_test_suite.html");
            this._dialog.open(false);
            this._dialog._headerText.focus();
        },
		
        disableExecution: function(message, errorType){
        	this._disableExecution = true;
        	this.showMsg(message, errorType);
			dojo.style(this._surroundingNode, "display", "none");
			if(this._stepIcon){
				dojo.style(this._stepIcon, "display", "none");
			}
			if(this._stepLabel){
				dojo.style(this._stepLabel, "display", "none");
			}
        	this._dialog.getOkButton().disabled = true;
        },
        
		_showTable: function(){
			var tableViewer1 = new com.ibm.rqm.execution.web.ui.internal.view.table.TestSuiteStepsTableView({
						showFilterControl:this.insideSection? false:true,
						testSuiteId: this.testSuiteId, 
						adapterSearchCallBack: dojo.hitch(this, "searchAdapters"),
						skipPasssedElements: dojo.hitch(this,"skipPasssedElements"),
						disableExecution: dojo.hitch(this, "disableExecution"),
						matvOkCallback: dojo.hitch(this, "matvOkCallback"),
						getSuiteConfigId: dojo.hitch(this, "getSelectedConfigId")
					});        
        	this._tableViewerNode.appendChild(tableViewer1.domNode);
        	this.stepsTableViewer = tableViewer1;
//			var content = this.elements;
//			tableViewer.setContent(content);
//			if(this.showInitLoadProgress) {
//            	tableViewer.showLoadingProgress();
//        	}
//			this.tableContentProvider = new RunSuiteDialog.TableProvider({insideSection:this.insideSection});
//        	tableViewer.setContentProvider(this.tableContentProvider);
//			tableViewer.setTableSummary(Constants.getMessage("labelTableSummary", Constants.getMessage("labelTestCaseInTestSuite")));
//			tableViewer.setTableRowsCheckable(true, /* isSingleSelect */false);
        	var tableViewer = tableViewer1.getTableViewer();
			tableViewer.setTableListener(new RunSuiteDialog.TableListener(this));
			var cellModifier = new RunSuiteDialog.CellModifier();
			cellModifier.setChangeListener({
				context: this,
				_scriptChanged:dojo.hitch(this,this._scriptSelectionChanged)
			});
			tableViewer.setCellModifier(cellModifier);
			if(!this.insideSection) {	
				this.skipExecutionAction = tableViewer.addAction("exclude_TC", Constants.getMessage("lableExcludeFromExecution"), -1,'exclude-TC-icon-image', dojo.hitch(this, this._onSkipExecutionClick));
				this.skipExecutionAction.setDisabled(true);
				this.skipPassedStepsAction = tableViewer.addAction("exclude_passedTC", Constants.getMessage("lableExcludePassedFromExecution"), -1,'exclude-passed-TC-icon-image', dojo.hitch(this, this._onSkipPassedStepsClick));				
			}
//	        tableViewer.show();
			this.tableViewer = tableViewer;
			
		},

		_setAdapters:function(){
			var elements = this.tableViewer ? this.tableViewer.getContent() : [];
			
			var runtimeSelection = false;
			if((this.insideSection && this.getAdapterSelectionType() == this.runtimeSelection.toUpperCase()) || this.searchInCell){
				runtimeSelection = true;
			}
			this.changeAdaptersInElement(elements, runtimeSelection);
			if (this.tableViewer) {
				this.tableViewer.setContent(elements);
				this.tableViewer.refresh();
			}
			var cachedElement = this.stepsTableViewer.getCachedElements();
			this.changeAdaptersInElement(cachedElement, runtimeSelection);
		},
		
		changeAdaptersInElement : function(elements, runtimeSelection){
			var eleLen = elements ? elements.length:0;
			for(var i=0;i<eleLen;i++){
				if(!elements[i].selectedScriptTypeId){
					elements[i].machine = {
						name: Constants.getMessage("labelNotApplicable"),
						adapterInfo: {
							id: null,
							name: Constants.getMessage("labelNotApplicable"),
							hostName: Constants.getMessage("labelNotApplicable")
						},
						machineName: Constants.getMessage("labelNotApplicable")
					};
					elements[i].adapterImg = ImageCache.NOIMAGE;
					elements[i].adapterStatus = null;
					elements[i].selectionCriteria = null;
				}else if(elements[i].selectedScriptTypeId != "com.ibm.rqm.planning.common.scripttype.manual"){
					if(runtimeSelection){
						elements[i].machine = {
						name: Constants.getMessage("labelSearchRuntime"),
						adapterInfo: {
							id: "runtime",
							name: Constants.getMessage("labelSearchRuntime"),
							hostName: Constants.getMessage("labelSearchRuntime")
						},
						machineName: Constants.getMessage("labelSearchRuntime")
					};
					elements[i].adapterImg = ImageCache.NOIMAGE;
					elements[i].adapterStatus = "";
					elements[i].adapterId = null;
					elements[i].selectionCriteria = "runtime";
					}else{
						var selectedConfigId = elements[i].configId ? elements[i].configId : null;
						var machineTV = new MachineAdapterTV({
							rowNum: elements[i].internalId,
							rowData: elements[i],
							scriptType: elements[i].selectedScriptTypeId,
							scriptVersionableItemId: elements[i].selectedScriptId,
							loadingCompleteCallback: dojo.hitch(this, this._getMachinesFromTable),
							lastSelectedAdapter:elements[i].adapterId,
							configID: selectedConfigId,
							testcellItemID: this.getSelectedTestCell()
						});
						elements[i].selectionCriteria = null;
						elements[i].matv = machineTV;
					}
				}else{
					elements[i].machine = {
						name: Constants.getMessage("labelLocalComputer"),
						adapterInfo: {
							id: "global",
							name: Constants.getMessage("labelLocalComputer"),
							hostName: Constants.getMessage("labelLocalComputer")
						},
						machineName: Constants.getMessage("labelLocalComputer")
					};
				}
			}
		},
		
		verifyAllStepsScriptType: function(callback) {
			var self = this;
			var handler = {
	        	success: function(stepScriptTypeDtos){
	        		var sameScriptType = false;
	        		var scriptType = null;
	        		if(stepScriptTypeDtos && (stepScriptTypeDtos.length > 0)) {
	        			var curElements = self.stepsTableViewer.getCurrentElements();
	        			// get first element's script type
	        			var curScriptType = curElements[0].selectedScriptTypeId;
	        			var selectedRows = self.tableViewer.getCheckedRows();

						if(selectedRows == TableConstants.VIRTUAL_CONTENT_SELECT_ALL){
							stepScriptTypeDtos = self._removeDeselectedSteps(stepScriptTypeDtos);
						}
	        			sameScriptType = true;
	        			dojo.forEach(stepScriptTypeDtos, function(stepScriptTypeDto) {
	        				var cachedElement = self.stepsTableViewer.getCachedElementForId(stepScriptTypeDto.internalId);
	        				if(cachedElement) {
	        					if(curScriptType != cachedElement.selectedScriptTypeId) {
	        						sameScriptType = false;
		        					return;
	        					}
	        				}
	        				else if(curScriptType != stepScriptTypeDto.scriptType) {
	        					sameScriptType = false;
	        					return;
	        				}
	        			});
	        			
	        			if(sameScriptType) {
	        				scriptType = curScriptType;
	        			}
	        		}
	        		if(callback) {
	        			callback({
	        				isOK: true,
	        				isSameScriptType: sameScriptType,
	        				scriptType: scriptType,
	        				stepScriptTypeDtos: stepScriptTypeDtos
	        			});
	        		}
				},
			    error: function(err){
					self._error(err);
					if(callback) {
	        			callback({
	        				isOK: false,
	        				errorObject: err
	        			});
	        		}
				}
			};
			var responseHandler = new ServiceResponseHandler(handler, "success", "error");
			TestSuiteClient.getTestSuiteStepScriptTypeDTOs(responseHandler, {itemId: this.suite.itemId});
		},
		
		//Handle bulk adapter change request
		_onBulkChangeAdapter: function(rowObject) {
			var checkedRows = this.tableViewer.getCheckedRows();
			
			var selectAllChecked = false;
			if(checkedRows == TableConstants.VIRTUAL_CONTENT_SELECT_ALL){
				// get current page rows to enable/disable the bulk change adapter acton button
				checkedRows = this.tableViewer.getContent();
				selectAllChecked = true;
			}
			// get first element's script type
			var selectedType = checkedRows[0].selectedScriptTypeId;
			
			// verify the selected scripts are automated scripts and not of same type.
			var showMessage = null;
			var selectionCount = checkedRows.length;
			var runtimeSelection = this.searchInCell;
			if(runtimeSelection) {
				showMessage = Constants.getMessage("msgAssignMachineRuntime");
			}
			else {
				if((selectedType == "com.ibm.rqm.planning.common.scripttype.manual") 
						|| (checkedRows[0].selectedScriptId == "-1") ){
					showMessage = Constants.getMessage("msgNotAutomatedScript");
				}
				else if (selectionCount > 1) {
					var notSameType = false;
					for(var i=1; i<selectionCount; i++){
						if(checkedRows[i].selectedScriptTypeId != selectedType){
							notSameType = true;
							break;
						}
					}
					if(notSameType)
						showMessage = Constants.getMessage("msgSelScriptsNotSameType");
				}
			}

			if(showMessage) {
				this._displayAlertDialog(showMessage);
				return;
			}
			
			// Show change adapter dialog
			var showMachineDialogFunc = dojo.hitch(this, function(rowObject, callbackData) {
				var selectedConfigId = (rowObject.configId && (rowObject.configId != "global")) ? rowObject.configId : this.getSelectedConfigId();
				var scriptTypeId = rowObject.selectedScriptTypeId;
				var matvArgs = {
					scriptType: scriptTypeId,
					scriptVersionableItemId: rowObject.selectedScriptId,
					configID: selectedConfigId,
					allowMultiSelect:true,
					loadingCompleteCallback: dojo.hitch(this, function(machines, table) {
						table.setFocus();
					})
				};
				
				this._showMachineSelectionDialog(matvArgs, dojo.hitch(this, "_handleMultiAdapterChange", callbackData), Constants.getMessage("labelChooseMachineForRun"));
			});
			
			if(selectAllChecked){
				this.verifyAllStepsScriptType(dojo.hitch(this, function(status){
					if(status.isOK) {
						if(!status.isSameScriptType) {
							this._displayAlertDialog(Constants.getMessage("msgSelScriptsNotSameType"));
		        			return;
						}
						showMachineDialogFunc(checkedRows[0], status.stepScriptTypeDtos);
					}
				}));
			}
			else {
				showMachineDialogFunc(checkedRows[0], checkedRows);
			}
		},
		
		// Display the MATV to let the user choose a different machine
		_showMachineSelectionDialog: function(matvArgs, okCallback, dialogTitle){
			var matv = new MachineAdapterTV(matvArgs);
			
			var dialogArgs = {
				primaryTitle: dialogTitle ? dialogTitle : null,
				okCallback: okCallback,
				okCallbackData: matv,
				style: "z-index: 9995;",
				zIndex: 9994
			};
			
			var adapterDialog = new com.ibm.asq.common.web.ui.internal.widgets.SelectionDialog(dialogArgs);
			adapterDialog.setWidth("80%");
			adapterDialog.setHeight("80%");
			adapterDialog.contentContainer.appendChild(matv.domNode);
			adapterDialog.getOkButton().disabled = false;
			adapterDialog.open(false);	
		},
		
		_handleMultiAdapterChange:function(selectedRows, matvCallbackData){
			var selectedData = matvCallbackData.getSelectedInfo();
			var j=0;
			if(selectedData.length>0){
				var selectedRowsLength = selectedRows.length;
				for(var i=0;i<selectedRowsLength;i++){
					var selData = selectedData[j];
					var machine = selData.machine;
					var cachedElement = this.stepsTableViewer.getCachedElementForId(selectedRows[i].internalId);
					var element = cachedElement ? cachedElement : selectedRows[i];
					element.machine = machine;
					element.adapterId = machine.id+"";
					element.testCellID = selData.cellID;
					element.testCellName = selData.cellName;
					this._getAdapterStatus(element);
					
					if(!cachedElement) {
						// add forward reference of the element in the cache
						this.stepsTableViewer.addForwardRefToCache(element);
					}
					
					j++;
					if(j==selectedData.length)
						j = 0;
				}
				this.tableViewer.refresh();
				if(this.onChange && dojo.isFunction(this.onChange))
					this.onChange();
			}
		},
		
		matvOkCallback: function(matvCallbackData){
			var selectedData = matvCallbackData.getSelectedInfo();
			if (selectedData && selectedData.machine){
				this._getMachinesFromTable([selectedData.machine], matvCallbackData);
				if(this.onChange && dojo.isFunction(this.onChange))
					this.onChange();
			}
		},
		_scriptSelectionChanged: function(rowObject,changedValue){
			var scripts = rowObject.testCase.scripts;
			var scriptItemId = changedValue;
			var scriptsLength = scripts.length;
			if(changedValue == -1){
				rowObject.selectedScriptName = null;
				rowObject.selectedScriptId = -1;
				rowObject.selectedScriptTypeId = null;
			}else{
				for(var j=0;j<scriptsLength;j++){
					if(scripts[j].versionableItemId == scriptItemId){
						var scriptObj = scripts[j];
						rowObject.selectedScriptName = scriptObj.name;
						rowObject.selectedScriptId = scriptObj.versionableItemId;
						rowObject.selectedScriptTypeId = scriptObj.scriptTypeId?scriptObj.scriptTypeId:scriptObj.scriptType.id;
						break;
					}
				}
			}
			if(!this.searchInCell){
				this._messageNode.hideMessage();
			}
			if(this._dialog)
				this._dialog.getOkButton().disabled = this._disableExecution;
			var matv = rowObject.matv;
			
			var selectedConfigId = rowObject.configId ? rowObject.configId : null;
			
			if(!rowObject.selectedScriptTypeId){
				if(matv){
					matv.scriptType = null;
					this._getMachinesFromTable([], matv);
				}else{
					this._updateMachineForScriptlessExecution(rowObject);
				}
			}else if(rowObject.selectedScriptTypeId == "com.ibm.rqm.planning.common.scripttype.manual"){
				if(matv){
					matv.scriptType = rowObject.selectedScriptTypeId;
					this._getMachinesFromTable([], matv);
				}else{
					this._updateMachineForManualScript(rowObject);
				}
			}else if(matv){//Here we need MATV to be called to get the list of adapters which are available currently.
				var selectedTestCellId = this.getSelectedTestCell();
				matv.setTestCellId(selectedTestCellId);
				if(selectedTestCellId == null){
					matv.reInitialize(rowObject.selectedScriptTypeId, rowObject.selectedScriptId, selectedConfigId, dojo.hitch(this, this._getMachinesFromTable));
				}else{
					this._updateMachineForRuntimeAdapterSelection(rowObject.internalId);
				}
				
			}else{
				var selectedTestCellId = this.getSelectedTestCell();
				if(selectedTestCellId != null){
					this._updateMachineForRuntimeAdapterSelection(rowObject.internalId);			
				}else{
					var machineTV = new MachineAdapterTV({
					rowNum: rowObject.internalId,
					rowData: rowObject,
					scriptType: rowObject.selectedScriptTypeId,
					scriptVersionableItemId: rowObject.selectedScriptId,  
					loadingCompleteCallback: dojo.hitch(this, this._getMachinesFromTable),
					lastSelectedAdapter:rowObject.adapterId,
					configID: selectedConfigId,
					testcellItemID: this.getSelectedTestCell()
					});
					rowObject.matv = machineTV;
				}
			}
			if(this.onChange && dojo.isFunction(this.onChange))
				this.onChange();
		},
		
		_updateMachineForManualScript: function(rowObject){
			var element = rowObject;
			element.machine = {
				name: Constants.getMessage("labelLocalComputer"),
				adapterInfo: {
					id: "global",
					name: Constants.getMessage("labelLocalComputer"),
					hostName: Constants.getMessage("labelLocalComputer")
				},
				machineName: Constants.getMessage("labelLocalComputer")
			};
			element.adapterImg = ImageCache.NOIMAGE;
			element.adapterStatus = "";
			element.adapterId = "";
			element.testCellID = null;
			element.testCellName = "";
//			var content = elements?elements:[];
//			this.elements = elements;
//			this.tableViewer.setContent(content);
			this.tableViewer.refresh();
		},
		
		_updateMachineForScriptlessExecution: function(rowObject){
			var element = rowObject;
			element.machine = {
				name: Constants.getMessage("labelNotApplicable"),
				adapterInfo: {
					id: null,
					name: Constants.getMessage("labelNotApplicable"),
					hostName: Constants.getMessage("labelNotApplicable")
				},
				machineName: Constants.getMessage("labelNotApplicable")
			};
			element.adapterImg = ImageCache.NOIMAGE;
			element.adapterStatus = "";
			element.adapterId = null;
			element.testCellID = null;
			element.testCellName = "";
//			this.tableViewer.setContent(content);
			this.tableViewer.refresh();
		},
		
		_updateMachineForRuntimeAdapterSelection: function(rowNum){
			this.elements = this.tableViewer ? this.tableViewer.getContent() : [];
			var elements = this.elements;
			elements[rowNum].machine = {
									name: Constants.getMessage("labelSearchRuntime"),
									adapterInfo: {
										id: "runtime",
										name: Constants.getMessage("labelSearchRuntime"),
										hostName: Constants.getMessage("labelSearchRuntime")
									},
									machineName: Constants.getMessage("labelSearchRuntime")
									};
			elements[rowNum].adapterImg = ImageCache.NOIMAGE;
			elements[rowNum].adapterStatus = "";
			elements[rowNum].adapterId = null;
			elements[rowNum].selectionCriteria = "runtime";	
			var content = elements?elements:[];
			this.elements = elements;
			this.tableViewer.setContent(content);
			this.tableViewer.refresh();
		},
		
	
		_getMachinesFromTable: function(machines, matvContext){
			var scriptType = null;
			if(matvContext){
				scriptType = matvContext.scriptType;
				var context = matvContext.rowData;
				if(!scriptType){
					this._updateMachineForScriptlessExecution(context);
					return;
				}else if (scriptType && scriptType == "com.ibm.rqm.planning.common.scripttype.manual"){
					this._updateMachineForManualScript(context);
					return;
				}
				var availableAdapter = 0;//First adapterin the list if the best fit, let MATV handle that ordering
				context.machine = machines.length > 0 ? machines[availableAdapter] : 
							{machineName: this.isRunOnReservedMachineEnabled() ? Constants.getMessage("labelNoMachineReserved") : Constants.getMessage("labelNotFound")};
				context.adapterId = machines.length > 0 ? machines[availableAdapter].id+"":"";
				context.testCellID = machines && machines[availableAdapter] && machines[availableAdapter].testCellID ? machines[availableAdapter].testCellID : null;
				context.testCellName = machines &&machines[availableAdapter]&& machines[availableAdapter].cellName ? machines[availableAdapter].cellName : "";
				this._getAdapterStatus(context);
				context.lastSelectedAdapter = machines.length > 0 && machines[availableAdapter]? machines[availableAdapter].id:null;
				
//				var content = elements?elements:[];
//				this.elements = elements;
//				this.tableViewer.setContent(content);
				this.tableViewer.refresh();
			}
		},
		
		_getAdapterStatus: function(element){
			var adapterStatusIcon = CommonImageCache.NOIMAGE;
			var adapterObj = element.machine;
			
			if(adapterObj){
				var availablity = Constants.getMessage("labelNotFound");
				
				if(adapterObj.health == "GREEN"){
					adapterStatusIcon = CommonImageCache.ENGINE_AVAILABLE;
					availablity = Constants.getMessage("msgEngAvailable");
				}
				else if(adapterObj.health == "RED"){
					adapterStatusIcon = CommonImageCache.ENGINE_NOTAVAILABLE;
					availablity = Constants.getMessage("msgEngUnresponsive");
				}
				else if(adapterObj.health == "YELLOW"){
					adapterStatusIcon = CommonImageCache.ENGINE_NOTRESPONDED;
					availablity = Constants.getMessage("msgEngRespondLate");
				}
				element.adapterImg = adapterStatusIcon;
				element.adapterStatus = this.getAdapterToolTip(element.machine, availablity);
			}else{
				element.adapterImg = ImageCache.NOIMAGE;
				element.adapterStatus = "";
			}
		},		
		
		getAdapterToolTip: function(machine, availability){
			var tooltip = [];
			
			var reqInQueue = machine.requestsInQueue ? machine.requestsInQueue : 0;
			tooltip.push(Constants.getMessage("availableAndJobsInQueueTip", availability, reqInQueue));
			
			var heartBeatTime = new Date();
			if (parseInt(heartBeatTime.getTime(), 10) > parseInt(machine.lastHeartBeat, 10)) {
                heartBeatTime.setTime(machine.lastHeartBeat);
            }
			if(heartBeatTime instanceof Date) {
				heartBeatTime = ASQCommonUtility.formatDate(heartBeatTime);
			}
			tooltip.push(", "+Constants.getMessage("labelLastHeartBeat")+": "+heartBeatTime);				
			
			return tooltip.join("");	
		},
		
		validate: function(){
			if(this._quickResult && this._quickResult.checked){
				return true;
			}
			var elements = this.stepsTableViewer.getCachedElements();
			var items = elements ? elements :[];
			var itemsLength = items.length;
			
			for(var i=0;i<itemsLength;i++){
				var item = items[i];
				var scriptTypeId = item.selectedScriptTypeId;
				if(scriptTypeId){
					var adapterId = item.adapterId;
					if(scriptTypeId != "com.ibm.rqm.planning.common.scripttype.manual" && (adapterId === "" || adapterId == "global")&& !item.excludeStep){
						var errorMsg = Constants.getMessage("msgNoAdapterFoundForTestScript", item.selectedScriptName);
						this.showMsg(errorMsg,jazz.ui.MessageBox.STATUS_TYPES.ERROR);						
						if(this._dialog)
							this._dialog.getOkButton().disabled = true;
						return false;
					}
				}
			}
			if (this.scheduleExecution && this.scheduleExecution == true && this.datePicker) {
				var datePicker = this.datePicker;
				if(!datePicker.getValue() || (datePicker.getValue() == "") || datePicker.hasError) {
					// TODO: Provide more specific and meaningful message to user
					var msg = Constants.getMessage("msgInvalidDateErrorBox");
					this.showMsg(msg, jazz.ui.MessageBox.STATUS_TYPES.ERROR);
					return false;
				}
			}
			if(!this.searchInCell){
				this._messageNode.hideMessage();
			}
			if(this._dialog)
				this._dialog.getOkButton().disabled = false;
			return true;
		},
		
		_showVariableTable: function(){
			// Validate current page before moving to next page
			if(!this.validate()){
				this._dialog.getNextButton().disabled = false;
				return false;
			}
			// show second step number and label
			this.secondStepIcon = this._getStepNumberIcon("2");
			this._stepIcon.appendChild(this.secondStepIcon);
			this._stepLabel.innerHTML = Constants.getMessage("labelModExecVars");
			this._stepLabel.title = Constants.getMessage("labelModExecVars");
			this._stepLabel.tabIndex = 0;
			
			this._dialog.getNextButton().disabled = true;
			this._dialog.getPrevButton().disabled = false;
			this._dialog.getOkButton().disabled = this._disableExecution;
			this._dialog.getCancelButton().disabled = false;
			this._dialog.prevCallback = dojo.hitch(this, "_onPrevAction");
			
			if(!this._variablesNode) {
				var div = dojo.create('div');
				var variableWidget = new ExecutionVarsWidget({
					artifact: this.suite,
					artifactType: Constants.TYPE_SUITE,
					inRunDialog: true
				});
				variableWidget.initialize();
				div.appendChild(variableWidget.domNode);
				this.variableWidget = variableWidget;
				this._variablesNode = div;
			}
			else {
				dojo.style(this._variablesNode, "display", "");
			}
			
			dojo.style(this._surroundingNode, "display", "none");
			this._dialog.contentContainer.appendChild(this._variablesNode);
		},
		
		_onPrevAction: function() {
			dojo.style(this._surroundingNode, "display", "");
			dojo.style(this._variablesNode, "display", "none");
			this._dialog.getNextButton().disabled = false;
			this._dialog.getPrevButton().disabled = true;
			this._dialog.getOkButton().disabled = true;
			
			// show first step number and label
			this._stepIcon.removeChild(this.secondStepIcon);
			this._stepLabel.innerHTML = this.labelDefineRecDetails;
			this._stepLabel.title = this.labelDefineRecDetails;
			this._stepLabel.tabIndex = 0;
		},
		
		_onRunClick: function(){
			
			this.itemList = [];
			this.isSequentialExecution = !this.parExecCheck.checked;
			this.passVariables = this.passVariableCheckbox.checked;
			this.haltOnFailure = this.haltOnFailureCheckbox.checked;
			if(!this.validate()){
				return false;
			}
			if(this._dialog){
				this._dialog.getOkButton().disabled = true;
				this._dialog.getCancelButton().disabled = true;
			}
//			var elements = this.tableViewer.getContent();
//			var containsArchived =  false;
//			var elementsLength = elements.length;
//			for(var i=0;i<elementsLength;i++){
//				if(elements[i].testCase.archived === true){
//					containsArchived = true;
//					break;
//				}		
//			}
			if(this.isCreateTCERWithTSEREnabled())
				 this.monitorId = ProgressUtility.beginTaskMonitor(Constants.getMessage("msgCreatingTCER"),0 , null);
			
			if(this.sersAvailable){
				var ser = null;
				if(this.serExecution){
					ser = this.selectedTSER;
				}else{
					ser = this._getSERFromList(this._serDropDown.value);
				}
				this._run(ser);
			}else{
				var configId = this._ConfigValue.value;
				var testPlanItemId = this._getSelectedPlanItemId();
				var testPhaseId = this._IterationValue.value;
				var params = {};
				params.passVariables = this.passVariables;
				params.haltOnFailure = this.haltOnFailure;
				params.newTestExecutionSuite = true;
				params.buildUniqueName = true;
				params.name = this.suite.name;
				params.suiteVersionableItemId = this.suite.versionableItemId;
				
				if (configId != "global") {
					params.configurationItemId = configId;
					var selectedIndex = this._ConfigValue.selectedIndex;
					var testEnvName = this._ConfigValue.options[selectedIndex].text;
					params.name = params.name + "_" +testEnvName;
				}
				if(this.suite.teamArea){
					params.teamArea = this.suite.teamArea;
				}
				if(testPlanItemId != "global")
					params.versionedTestPlanItemId = testPlanItemId;
				if(testPhaseId && testPhaseId !="")
					params.testPhaseItemId = testPhaseId;
				
				var responseHandler = new ServiceResponseHandler(this, "_run", "_error");
				TestExecutionSuiteClient.postTestExecutionSuiteDTO(responseHandler, params);
			}
			
			//need to disable the ok button after the return 
			setTimeout(dojo.hitch(this,function(){
				if(this._dialog){
					this._dialog.getOkButton().disabled = true;
				}
			}),10);
			return false;
		},
		
		_getSERFromList:function(serId){
			var len = this.sersList && this.sersList.length  ? this.sersList.length : 0;
			var sers = this.sersList;
			for(var i=0;i<len;i++){
				if(sers[i].id == serId){
					return sers[i];
				}
			}
		},
		
		_showQuickResult:function(result){
			this.closeDialog();
			if(this.isCreateTCERWithTSEREnabled())
            	ProgressUtility.endTaskMonitor(this.monitorId);
			parent.location =  Utility.showSuiteResult({ id: result.id });
		},
		
		_run: function(tser){			
			var self = this;
			this.currentTSER = tser;
			var items = this.stepsTableViewer.getCachedElements();
			//get all information per page and load the elements
			var itemsLength = items.length;			
			for(var i=0; i < itemsLength; i++){
				var internalId = items[i].internalId;
				var scriptId = items[i].selectedScriptId ? items[i].selectedScriptId: null;
				var adapterId = (items[i].adapterId != "" && items[i].adapterId != "global") ? items[i].adapterId : null;
				var excludeStep = items[i].excludeStep;
				this.itemList.push({
					internalId: internalId,
					adapterId: adapterId,
					testScriptId: (scriptId && (scriptId != "-1")) ? scriptId : null,
					excludeStep: excludeStep,
					noScriptExecution: (scriptId && (scriptId == "-1")) ? true : false
				});
			}
			this._postExecute();
		},
		
		_postExecute:function(){
			var startTime = Utility._convertDateToLong(new Date());
			var params = {
				id: this.sersAvailable ? (this.serExecution  ? this.currentTSER.id : this._serDropDown.value) : this.currentTSER.id,
				startTime: startTime,
				suiteElementsJsonString: dojo.toJson(this.itemList),
				isSerialExecution: this.isSequentialExecution,
				passVariables: this.passVariableCheckbox.checked,
				haltOnFailure: this.haltOnFailureCheckbox.checked
			};
			if(this.getSelectedTestCell()){
				params.testcellItemId = this.getSelectedTestCell();
			}
			
			if (this.scheduleExecution && this.scheduleExecution == true && this.datePicker) {
				var scheduledDate = this.datePicker.getValue();
				this.scheduledDate = scheduledDate;
				params.scheduleOn = scheduledDate;
			}
			var responseHandler = null;
			if (this._quickResult.checked) {
				params.state = this._verdictValue.value;
				responseHandler = new ServiceResponseHandler(this, "_showQuickResult", "_executionError");
			}
			else {
				responseHandler = new ServiceResponseHandler(this, "_executionStarted", "_executionError");
			}
			
			if(this._showVariableTableCheckbox.checked && this.variableWidget){
				var variables = this.variableWidget.getContent();
				params.suiteVariableJson = dojo.toJson(variables.modifiededVariableMap);
				if(variables.projectVariableMap)
					params.suiteProjectVariableJson = dojo.toJson(variables.projectVariableMap.modifiededVariableMap);
			}
			params.buildRecordItemId = this.buildRecordItemId ? this.buildRecordItemId : null;
			var selectedChannel = this.getSelectedChannel();
			if(selectedChannel){
				params.channelId = selectedChannel;
			}
			params.skipPasssedElements = this.skipPassedClicked;
			TestExecutionSuiteClient.postExecute(responseHandler, params);
			var updatedSer = [];
			updatedSer.push(this.currentTSER);
			dojo.publish(GlobalEvents.ArtifactsUpdated, [Constants.TYPE_SER, updatedSer]);
		},
		_executionStarted: function(erg){
			this.closeDialog();			
			if(erg !=null){				
				var args = {groupId: erg.id};
				args.itemId = args.itemId ? args.itemId : null;				
				//Automatically navigate to the suiteExecution page.
				parent.location = Utility.runSuite(args);
			}else if(erg ==null && this.scheduleExecution == true){				
				this._displayAlertDialog(Constants.getMessage("msgScheduleExecutionOn",Utility._convertLongToDate(this.scheduledDate)),Constants.getMessage("labelExecuteLater"));
			}
			if(this.isCreateTCERWithTSEREnabled())
            	ProgressUtility.endTaskMonitor(this.monitorId);
		},
		_executionError: function(errorObj){
			this.closeDialog();			
			this._displayAlertDialog(errorObj.message);
			if(this.isCreateTCERWithTSEREnabled())
            	ProgressUtility.endTaskMonitor(this.monitorId,errorObj.message);
		},
				
		closeDialog: function() {
			if(this._dialog)
				this._dialog.close();
		},

		_onCancelClick: function(){
			if(this._dialog){
				this._dialog.getOkButton().disabled = true;
				this._dialog.getCancelButton().disabled = true;
			}
		},
		
		_onRuntimeSelectionClick: function(){
			//Extender must over-ride !!
		},
		
		// handle bulk skip execution request.
		_onSkipExecutionClick: function() {
			var checkedRows = this.tableViewer.getCheckedRows();
			if(checkedRows == TableConstants.VIRTUAL_CONTENT_SELECT_ALL){
				var self = this;
				var handler = {
		        	success: function(stepScriptTypeDtos){
		        		if(stepScriptTypeDtos && (stepScriptTypeDtos.length > 0)) {
		        			stepScriptTypeDtos = self._removeDeselectedSteps(stepScriptTypeDtos);
		        			self._skipExecutionForSteps(stepScriptTypeDtos);
		        		}
					},
				    error: function(err){
						self._error(err);
					}
				};
				var responseHandler = new ServiceResponseHandler(handler, "success", "error");
				TestSuiteClient.getTestSuiteStepScriptTypeDTOs(responseHandler, {itemId: this.suite.itemId});
			}
			else {
				this._skipExecutionForSteps(checkedRows);
			}
		},
		
		_removeDeselectedSteps:function(stepScriptTypeDtos){
			var deselectedRows = this.tableViewer.getVirtualDeselectedRows();
			var deselectedLength = deselectedRows ? deselectedRows.length : 0;
			if(deselectedLength > 0){
				var selectedStepScriptTypeDtos = [];
				var length = stepScriptTypeDtos.length;
				for(var i = 0; i < length; i++){
					var internalId = stepScriptTypeDtos[i].internalId;
					var deselected = false;
					for(var j = 0; j < deselectedLength; j++){
						if(internalId == deselectedRows[j].internalId){
							deselected = true;
							break;
						}
					}
					if(!deselected){
						selectedStepScriptTypeDtos.push(stepScriptTypeDtos[i]);
					}
				}
				stepScriptTypeDtos = selectedStepScriptTypeDtos;
			}
			return stepScriptTypeDtos;
		},
		
		_skipExecutionForSteps: function(steps) {
			var stepsLength = steps.length;
			for(var i=0;i<stepsLength;i++){
				var cachedStep = this.stepsTableViewer.getCachedElementForId(steps[i].internalId);
				var step = cachedStep ? cachedStep : steps[i];
				step.excludeStep = !step.excludeStep;
				if(!cachedStep) {
					// add forward reference of the element in the cache
					this.stepsTableViewer.addForwardRefToCache(step);
				}
			}
			this.tableViewer.refresh();
			
			var allStepsSkipped = this.stepsTableViewer.isAllStepsSkipped();
			this._disableExecution = allStepsSkipped;
			this._dialog.getOkButton().disabled = allStepsSkipped;
			
			if(allStepsSkipped) {
				this.showMsg(Constants.getMessage("msgAllStepsSkipped"), jazz.ui.MessageBox.STATUS_TYPES.WARNING);
			}
			else {
				this._messageNode.hideMessage();
			}
		},
		
		_onSkipPassedStepsClick: function(){
			this.skipPassedClicked = !this.skipPassedClicked;
			this.skipPassedStepsAction._setSelectedAttr(this.skipPassedClicked);
			var ewi = null;
			this.currentPassedResultSteps = [];
			var self = this;			
			if(!this.sersAvailable) {
					self.showMsg(Constants.getMessage("msgSkipPassedStepsWithNewTSER"),jazz.ui.MessageBox.STATUS_TYPES.WARNING);					
					return;
			}			
			if(this.serExecution){
				ewi = this.selectedTSER;
			}else{
				ewi = this._getSERFromList(this._serDropDown.value);
			}
			
			var handler = {
        		success: function(currentResult){
					self._setCurrentResult(currentResult);
					var resultGroup = self._getCurrentResult();
					
					if(resultGroup != null) {
						self._populateCurrentResultGroup();								
					}else{						
						self.showMsg(Constants.getMessage("msgSkipPassedStepsWithExistingTSERNoResult"), jazz.ui.MessageBox.STATUS_TYPES.WARNING);
						self.tableViewer.endLoadingProgress();
						return;
					}
					var currentPassedResultSteps = self.currentPassedResultSteps ? self.currentPassedResultSteps : []; 	
					var currentPassedResultStepsLen = currentPassedResultSteps.length;
					if(currentPassedResultStepsLen == 0){						
						self.showMsg(Constants.getMessage("msgSkipPassedStepsWithExistingTSERNoPassedResultSteps"), jazz.ui.MessageBox.STATUS_TYPES.WARNING);						
						self.tableViewer.endLoadingProgress();
						return;	
					}
					self.skipPasssedElements(self.stepsTableViewer.getCachedElements());
				},
		        error: function(err){
					self._error(err);
				}
			};
			var tableViewer = this.tableViewer;
			tableViewer.showLoadingProgress();				
			var responseHandler = new ServiceResponseHandler(handler, "success", "error");
			TestExecutionSuiteClient.getTestSuiteExecutionRecordCurrentResultDTO(responseHandler, {itemId: ewi.itemId});			
		},
		
		skipPasssedElements: function(elements){
			var currentPassedResultSteps = this.currentPassedResultSteps ? this.currentPassedResultSteps : [];
			var currentPassedResultStepsLen = currentPassedResultSteps.length;
			var elementsLen = elements.length;					
			for (var j = 0; j < elementsLen; j++) {
		    	var element = elements[j];
				for(var i=0;i<currentPassedResultStepsLen;i++){
					var step = currentPassedResultSteps[i];
					if(step){
						if (element.selectedScriptId == step.testScriptItemId && element.testCase.versionableItemId == step.testCaseVersionableItemId) { 
							element.excludeStep = this.skipPassedClicked;
			        	}
					}	
				}
			}
			if (this.tableViewer) {
				this.tableViewer.refresh();
				this.tableViewer.endLoadingProgress();
			}
		},
		
		_displayAlertDialog: function(message,title){
        	message = message ? message.replace(/\n/g, "<br />") : "";
	    	new AlertDialog({
	    		message: message,
	    		primaryTitle:title ? title : Constants.getMessage("labelError")
	    	}).open(true);
        },
				
		showMsg:function(message,typeName){			
				var messageArgs = {
					summary: message,
	            	type: typeName,
	            	details: null,
	            	closable: true
				};				
     			this._messageNode.showMessage(messageArgs);
		},
		
		_showExecutionInProgressMessage: function(){
			var stType = jazz.ui.MessageBox.STATUS_TYPES.INFO;     
			var msg = Constants.getMessage("msgexecutionInProgress");
			var frontLabel = document.createElement('label');
			frontLabel.innerHTML = msg+"  ";
			var span = document.createElement('span');
			span.tabIndex = "-1";
			var clickHere = document.createElement('a');					
			clickHere.alt = clickHere.title = Constants.getMessage("labelClickHereToolTip");
			clickHere[_textContent]= Constants.getMessage("labelClickHere");
			dojo.style(clickHere ,"cursor","pointer");
			clickHere.tabIndex = "0";
			span.appendChild(clickHere);
			this.connect(clickHere, "onclick", "_resumeSuiteExecution");
			this.connect(clickHere, "onkeypress", "_onEnterResumeSuiteExecution");
			var msgSpan = document.createElement('span');
			msgSpan.appendChild(frontLabel);
			msgSpan.appendChild(clickHere);				
			this.showMsg(msgSpan, stType);
		},
		
		_onEnterResumeSuiteExecution: function(e){
			var charCode = (e.which) ? e.which : e.keyCode;
			if (charCode == 13) {
				this._resumeSuiteExecution();
			}
		},
				
		_onMessageClose: function(){
        	this._messageNode.hideMessage();
        	this.statusClosed = true;
    	},
    	
    	_resumeSuiteExecution: function(){
    		var ser = null;
			if(this.serExecution){
				ser = this.selectedTSER;
			}else{
				ser = this._getSERFromList(this._serDropDown.value);
			}
			this.closeDialog();
			parent.location =  Utility.runSuite({
				groupId: ser.currentResultGroupId
			});
			
		},
		
		_setCurrentResult: function(currentResult){
			if(currentResult){
				this.currentResultGroup = null;				
				this.currentResultGroup =  currentResult;
			}					
		},
		
		_getCurrentResult: function(){			
				return this.currentResultGroup ? this.currentResultGroup : null;			
		},
		
		_populateCurrentResultGroup: function(){
			this.currentPassedResultSteps = [];
			var resultGroup = this._getCurrentResult();
			var elements = resultGroup ? resultGroup.stepResults : [];
			var elementsLen = elements.length;
			for(var i = 0; i < elementsLen; i++){
				var element = elements[i];
				if(element.resultStateId == "com.ibm.rqm.execution.common.state.passed"){
					var stepResult = { 	internalId: element.stepInternalId, 
										testCaseVersionableItemId: element.testCaseVersionableItemId, 
										testScriptItemId: element.testScriptVersionableItemId ? element.testScriptVersionableItemId : "-1", 
										result: element.resultStateName ? element.resultStateName : null
												};
					this.currentPassedResultSteps.push(stepResult);
				}
			}	
		},
		
		uninitialize: function(){
			if (this._tableViewerNode) {
				ASQCommonUtility.destroyWidgetsFromNode(this._tableViewerNode);
				console.debug("removed Table from SPUP");
			}
			var elements = this.elements; 
			var elementsLength =  elements? elements.length: 0; 
			for(var i=0;i<elementsLength;i++){
				var element = elements[i];
				if(element.matv){
					element.matv.destroy();
					element.matv = null;
				}
			}
		},
		
		_onShowVariableTableClick: function(){
			if(this._showVariableTableCheckbox.checked){
				this._dialog.getNextButton().disabled = false;
				this._dialog.getPrevButton().disabled = true;
				this._dialog.getOkButton().disabled = true;
			}else{
				this._dialog.getNextButton().disabled = true;
				this._dialog.getPrevButton().disabled = true;
				this._dialog.getOkButton().disabled = this._disableExecution;
			}
		},
		
		_parExecCheckClicked: function(e){
			if(this.parExecCheck.checked){
				this.passVariableCheckbox.disabled = true;
				this.haltOnFailureCheckbox.disabled = true;
				this.passVariableCheckbox.checked = false; 
				this.haltOnFailureCheckbox.checked = false;
			}else{
				this.passVariableCheckbox.disabled = false;
				this.haltOnFailureCheckbox.disabled = false;
			}
		},
		
		_getStepNumberIcon: function(iconLabel) {
        	var stepIconSpan = document.createElement("span");
			dojo.style(stepIconSpan, "position", "relative");
			dojo.style(stepIconSpan, "padding", "12px 0 0 11px");
			var stepIconImg = document.createElement("img");
			stepIconImg.src = CommonImageCache.STEP_SELECTED;
			var stepIconLabel = document.createElement("label");
			stepIconLabel.className = "step-icon-label";
			stepIconLabel.innerHTML = iconLabel;
			stepIconSpan.appendChild(stepIconImg);
			stepIconSpan.appendChild(stepIconLabel);
			
			return stepIconSpan;
        },
		
		getSelectedTestCell: function(){
			return this.suite.testcellItemId;
		},
		
		getSelectedConfigId: function() {
			if(this.selectedTSER) {
				return this.selectedTSER.configId;
			}
			else {
				var configId = this._ConfigValue.value;
				return ((configId && (configId != "global")) ? configId : null);
			}
		},
		
		onBuildChangeClick: function(){
			 var dialogArgs = {
			        primaryTitle: Constants.getMessage("labelAvailableBuilds"),
		            okCallback: dojo.hitch(this, "_buildSelected"),
		            cancelCallback: dojo.hitch(this, "_cancelled"),
					isClosable: true
		        };
			this.buildRecordTableView = new BuildList({consoleNode: false, rowCheckable: true, singleSelectable: true});
			var buildSelectionDialog = new SelectionDialog(dialogArgs);
			buildSelectionDialog.contentContainer.appendChild(this.buildRecordTableView.domNode);
			buildSelectionDialog.setWidth("50%");
	        buildSelectionDialog.setHeight("30%");
			buildSelectionDialog.getOkButton().disabled = false;
			buildSelectionDialog.open();
		},
		
		_buildSelected: function(){
			var items = this.buildRecordTableView.getSelectedBuildRecord();
			var buildName = "";
			if(items && items.length == 1){
				var buildRecord = items[0];
				if(items[0].buildRecord)
					buildRecord = items[0].buildRecord;
				if (this.editable) {
					buildName = buildRecord.parentBuildDefName ? buildRecord.parentBuildDefName + " : " + buildRecord.name : buildRecord.name;
					this.build2[_textContent] = buildName;
					this.build2.title = buildName;
				}else {
					buildName = buildRecord.parentBuildDefName ? buildRecord.parentBuildDefName + " : " + buildRecord.name : buildRecord.name;
					this._buildValue[_textContent] = BidiUtil.enforceTextDirWithUcc(buildName);
					this._buildValue.title = BidiUtil.enforceTextDirWithUcc(buildName);
				}
				this.buildRecordItemId = buildRecord.itemId;
				this.buildId = buildRecord.id;
				this._buildEdited = true;
			}
		},
		
		_cancelled: function(){
		},
		
		onBuildClearClick: function(){
			if(this.editable){
				this.build2[_textContent] = Constants.getMessage("labelUnassigned");
			}else{
				this._buildValue[_textContent] = Constants.getMessage("labelUnassigned");	
			}
			this.buildRecordItemId = null;
			this.buildId = null;
			this._buildEdited = true;
		},     
		
		_setExecPref: function(){
			if(!this.isChannelEnabled()){
				this._channelNode.style.display = "none";	
			}
		},
		
		_error: function(errorObj){
			this.closeDialog();
			console.error("Error in RunSuiteDialog "+ errorObj.message + " ");
		}        
    });
})();
