/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2014. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.planning.web.client.internal.HiddenMenuClient");

dojo.require("jazz.app.context");
dojo.require("com.ibm.team.repository.web.transport.ServiceRequest");
dojo.require("com.ibm.team.repository.web.transport.TeamServerClient");

(function() { //module container

var ServiceRequest 			= com.ibm.team.repository.web.transport.ServiceRequest;
var getCurrentPA            = jazz.app.context.get;
var TeamServerClient 		= com.ibm.team.repository.web.transport.TeamServerClient;

com.ibm.rqm.planning.web.client.internal.HiddenMenuClient = {

	HIDDEN_MENU_SERVICE_URI: "com.ibm.rqm.planning.common.service.rest.IHiddenMenusWebUIInitializerRestService",

	_invokeService: function(responseHandler, method, args) {
		var serviceRequest= new ServiceRequest(this.HIDDEN_MENU_SERVICE_URI, method, args);
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	},
	
    getHiddenMenusEntries: function(serviceResponseHandler, args) {
    	if(!args){
    		args = {};
    	}
    	if (args && !args.projectAreaUUID) {
			args.projectAreaUUID = getCurrentPA().itemId;
		}
		if(!args.projectAreaUUID){
			//If we are calling from the Administration page, jazz.app.context.get wouldn't work, 
			//The project area admin page uses the configuration data directly so no need for us to fetch.
			//We can just invoke the success handler with nothing.
			serviceResponseHandler.doCallback();
		}else{
			this._invokeService(serviceResponseHandler, "getHiddenMenusEntries", args);
		}
    },

};

})();
