/*******************************************************************************
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2013, 2015. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  Use,
 * duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.apt.web.client.PlanModelManager");

dojo.require("com.ibm.jdojo.lang.Runtime");
dojo.require("com.ibm.jdojo.util.Assert");
dojo.require("com.ibm.team.apt.api.client.IPlanItem");
dojo.require("com.ibm.team.apt.api.client.IPlanModel");
dojo.require("com.ibm.team.apt.api.client.IResolvedPlan");
dojo.require("com.ibm.team.apt.api.client.internal.PlanningAttributeIdentifierImpl");
dojo.require("com.ibm.team.apt.api.client.util.Flag");
dojo.require("com.ibm.team.apt.api.common.UIItemHandle");
dojo.require("com.ibm.team.apt.api.common.planning.IProgressMonitor");
dojo.require("com.ibm.team.apt.shared.client.internal.model.PlanModel");
dojo.require("com.ibm.team.apt.shared.client.internal.util.Future");
dojo.require("com.ibm.team.apt.web.client.PlanModelDataRequests");
dojo.require("com.ibm.team.apt.web.client.PlanModelDataWorker");
dojo.require("com.ibm.team.apt.web.client.PlanningUtil1");
dojo.require("com.ibm.team.apt.web.client.WorkItemChangedListener");
dojo.require("com.ibm.team.apt.web.client.internal.model.AttributeHelper");
dojo.require("com.ibm.team.apt.web.client.internal.model.AttributeMapping");
dojo.require("com.ibm.team.apt.web.client.internal.model.attributes.workitems.AttributeBatchLoadingSupport");
dojo.require("com.ibm.team.rtc.foundation.web.ui.util.ListenerList");
dojo.require("com.ibm.team.workitem.web.cache.internal.WorkItemProxy");

(function() {
var jdojo2= com.ibm.jdojo;
var jdojo= jdojo2.lang.Runtime;
var Assert= jdojo2.util.Assert;
var team= com.ibm.team;
var apt= team.apt;
var api= apt.api;
var client= api.client;
var IPlanItem= client.IPlanItem;
var IPlanModel= client.IPlanModel;
var IResolvedPlan= client.IResolvedPlan;
var PlanningAttributeIdentifierImpl= client.internal.PlanningAttributeIdentifierImpl;
var Flag= client.util.Flag;
var common= api.common;
var UIItemHandle= common.UIItemHandle;
var IProgressMonitor= common.planning.IProgressMonitor;
var internal= apt.shared.client.internal;
var PlanModel= internal.model.PlanModel;
var Future= internal.util.Future;
var client2= apt.web.client;
var PlanModelDataRequests= client2.PlanModelDataRequests;
var GetPlanConfigurationRequest= PlanModelDataRequests.GetPlanConfigurationRequest;
var GetPlanEditorConfigurationRequest= PlanModelDataRequests.GetPlanEditorConfigurationRequest;
var GetPlanItemsRequest= PlanModelDataRequests.GetPlanItemsRequest;
var GetPlanModel2Request= PlanModelDataRequests.GetPlanModel2Request;
var PlanModelDataWorker= client2.PlanModelDataWorker;
var PlanningUtil1= client2.PlanningUtil1;
var WorkItemChangedListener= client2.WorkItemChangedListener;
var model= client2.internal.model;
var AttributeHelper= model.AttributeHelper;
var AttributeMapping= model.AttributeMapping;
var AttributeBatchLoadingSupport= model.attributes.workitems.AttributeBatchLoadingSupport;
var ListenerList= team.rtc.foundation.web.ui.util.ListenerList;
var WorkItemProxy= team.workitem.web.cache.internal.WorkItemProxy;

dojo.declare("com.ibm.team.apt.web.client.PlanModelManager", null, {
	"-chains-": { constructor: "manual" },

	//fPlanningClient2: null,

	//fCache: null,

	constructor: function(planningClient2) {
		this.fCache= {};
		this.fPlanningClient2= planningClient2;
	},

	addRefreshListener: function(planHandle, listener) {
		var key= planHandle.getHandleValue();
		this.fCache[key].listenerList.addListener(listener);
	},

	removeRefreshListener: function(planHandle, listener) {
		var key= planHandle.getHandleValue();
		this.fCache[key].listenerList.removeListener(listener);
	},

	refresh: function(planHandle, planViewId, requests, onPlanModel) {
		var key= planHandle.getHandleValue();
		if (!((key in this.fCache))) Assert.fail("(key in this.fCache)", "PlanModelManager:101");
		var onFetchPlanModel= dojo.hitch(this, function(newPlanModel) {
			var onPlanModelInit= new Future();
			onPlanModelInit.setCallback(dojo.hitch(this, function(result) {
				var data= this.fCache[key];
				var oldPlanModel= data.planModel;
				var oldWorkItemListener= data.workItemListener;
				data.planModel= newPlanModel;
				data.workItemListener= new WorkItemChangedListener(newPlanModel);
				var listeners= data.listenerList.getListeners();
				for (var i= 0; i < listeners.length; i++){
					listeners[i](oldPlanModel, newPlanModel);
				}
				oldPlanModel.dispose();
				oldWorkItemListener.dispose();
				var onWorkItemRevert= function(workItems) {
					onPlanModel.callback(newPlanModel);
				};
				this.revertDirtyWorkItems(newPlanModel, Future.newInstance(onWorkItemRevert, onPlanModel.getErrCallback(), onPlanModel.getProgressMonitor()));
			}));
			newPlanModel.initialize([IResolvedPlan.PLAN_CATEGORIES_ROOT], [newPlanModel], onPlanModelInit);
		});
		if (requests == null || requests.length === 0) {
			requests= this.getPlanModelDataRequests(planHandle, planViewId, true);
		}
		this.doFetchPlanModel2(planHandle, requests, Future.newInstance(onFetchPlanModel, onPlanModel.getErrCallback(), onPlanModel.getProgressMonitor()), Flag.Refresh);
	},

	revertDirtyWorkItems: function(planModel, onWorkItemsRevert) {
		var workItems= [];
		var $subject= planModel.getAllPlanElements();
		var $length= $subject.length;
		for (var $count= 0; $count < $length; $count++){
			var planElement= $subject[$count];
			var planItem= planElement.getAdapter(IPlanItem);
			if (planItem != null) {
				var workItem= planItem.getWorkItem();
				var proxy= workItem.getWorkingCopyObject(WorkItemProxy);
				if (proxy != null && proxy.isChanged()) {
					workItems.push(workItem);
				}
			}
		}
		if (workItems.length === 0) {
			onWorkItemsRevert.callback(workItems);
			return ;
		}
		var request= {};
		request.attribute= null;
		request.refresh= true;
		request.workItems= workItems;
		var batchSupport= new AttributeBatchLoadingSupport(this.fPlanningClient2);
		batchSupport.prepareBatch();
		batchSupport.addValueRequest(request, onWorkItemsRevert);
		batchSupport.processBatch();
	},

	dispose: function(planModel) {
		var key= UIItemHandle.itemHandleFor(planModel.getAdapter(IResolvedPlan).getPlanRecord()).getHandleValue();
		var data= this.fCache[key];
		if (!(data != null)) Assert.fail("data != null", "PlanModelManager:176");
		data.useCount-= 1;
		if (data.useCount <= 0) {
			if (!(data.planModel === planModel)) Assert.fail("data.planModel === planModel", "PlanModelManager:179");
			data.planModel.dispose();
			data.workItemListener.dispose();
			delete this.fCache[key];
			return true;
		} else {
			return false;
		}
	},

	load: function(planHandle, planViewId, future) {
		return this.load2(planHandle, this.getPlanModelDataRequests(planHandle, planViewId, false), future);
	},

	load2: function(planHandle, requests, future) {
		var key= planHandle.getHandleValue();
		var data= this.fCache[key];
		var load= data == null;
		if (load) {
			data= {};
			data.listenerList= new ListenerList();
			data.useCount= 0;
			this.fCache[key]= data;
			data.future= future;
			var callback= dojo.hitch(this, function(result) {
				var key= UIItemHandle.itemHandleFor(result.getAdapter(IResolvedPlan).getPlanRecord()).getHandleValue();
				var data= this.fCache[key];
				data.useCount= 1;
				data.planModel= result;
				data.workItemListener= new WorkItemChangedListener(result);
				data.future.callback(result);
				data.future= null;
			});
			this.doFetchPlanModel2(planHandle, requests, Future.newInstance(callback, future.getErrCallback(), future.getProgressMonitor()));
		} else {
			if (data.future != null) {
				data.useCount+= 1;
				data.future= data.future.chain(future);
			} else {
				data.useCount+= 1;
				future.callback(data.planModel);
			}
		}
		return load;
	},

	createUncachedPlanModel: function(planHandle, requests, future) {
		var callback= function(newPlanModel) {
			future.callback(newPlanModel);
		};
		this.doFetchPlanModel2(planHandle, requests, Future.newInstance(callback, future.getErrCallback(), future.getProgressMonitor()));
	},

	doFetchPlanModel2: function(planHandle, requests, future /*, flags... */ ) {
		var flags= Array.prototype.slice.call(arguments, 3);
		var worker= new PlanModelDataWorker(requests, this.fPlanningClient2);
		var onPlanModelData= dojo.hitch(this, function(planModelData) {
			this.buildPlanModel.apply(this, [planModelData, future].concat(flags));
		});
		var loadPlanModelDataFuture= Future.newInstance(onPlanModelData, future.getErrCallback(), future.getProgressMonitor());
		worker.execute(loadPlanModelDataFuture);
	},

	buildPlanModel: function(planModelData, future /*, flags... */ ) {
		var flags= Array.prototype.slice.call(arguments, 2);
		var attributeQueues= this.buildAttributeQueues(planModelData);
		var attributes= attributeQueues.attributes;
		var lazyAttributes= attributeQueues.lazyAttributes;
		var toLoad= lazyAttributes.length;
		if (toLoad > 0) {
			for (var i= 0; i < lazyAttributes.length; i++){
				var lazyAttribute= lazyAttributes[i];
				jdojo.newInstanceByName(lazyAttribute.getImplementationName(), dojo.hitch(this, function(instance) {
					attributes.push(instance);
					toLoad-= 1;
					if (toLoad === 0) {
						this.createPlanModel.apply(this, [planModelData, attributes, future].concat(flags));
					}
				}), lazyAttribute, this.fPlanningClient2, planModelData.context);
			}
		} else {
			this.createPlanModel.apply(this, [planModelData, attributes, future].concat(flags));
		}
	},

	buildAttributeQueues: function(planModelData) {
		var attributeDescriptors= planModelData.attributeDescriptors;
		var context= planModelData.context;
		var attributeQueues= {};
		attributeQueues.attributes= [];
		attributeQueues.lazyAttributes= [];
		var $subject2= attributeDescriptors;
		var $length2= $subject2.length;
		for (var $count2= 0; $count2 < $length2; $count2++){
			var description= $subject2[$count2];
			var implementationName= description.getImplementationName();
			var helperDescription= AttributeHelper.INSTANCE.getPlanningWorkItemHelperAttributeDescription(description);
			if (helperDescription != null) {
				attributeQueues.lazyAttributes.push(helperDescription);
			}
			if (AttributeHelper.INSTANCE.isRanking(implementationName)) {
				var syncDescription= AttributeHelper.INSTANCE.getRankingHelperAttributeDescription(description);
				var synCtor= AttributeMapping.INSTANCE.getWebAttributeCtor(syncDescription);
				var attribute= jdojo.newInstance(synCtor, syncDescription, this.fPlanningClient2, context);
				attributeQueues.attributes.push(attribute);
				helperDescription= AttributeHelper.INSTANCE.getPlanningWorkItemHelperAttributeDescription(syncDescription);
				if (helperDescription != null) {
					attributeQueues.lazyAttributes.push(helperDescription);
				}
			}
			if (AttributeHelper.INSTANCE.REFERENCE_IMPLEMENTATION_NAME === implementationName) {
				var syncDescription= AttributeHelper.INSTANCE.getReferenceHelperAttributeDescription(description);
				if (syncDescription != null) {
					var synCtor= AttributeMapping.INSTANCE.getWebAttributeCtor(syncDescription);
					var attribute= jdojo.newInstance(synCtor, syncDescription, this.fPlanningClient2, context);
					attributeQueues.attributes.push(attribute);
				}
			}
			var webAttr= AttributeMapping.INSTANCE.getWebAttributeCtor(description);
			if (webAttr != null) {
				var attribute= jdojo.newInstance(webAttr, description, this.fPlanningClient2, context);
				attributeQueues.attributes.push(attribute);
				continue;
			}
			var sharedAttr= AttributeMapping.INSTANCE.getSharedAttributeCtor(description);
			if (sharedAttr != null && description.getAttributeType() != null) {
				var attribute= jdojo.newInstance(sharedAttr, description, this.fPlanningClient2, context);
				attributeQueues.attributes.push(attribute);
				continue;
			}
			if (implementationName != null && implementationName !== "com.ibm.team.apt.client.BuiltInAttribute") {
				attributeQueues.lazyAttributes.push(description);
			}
		}
		return attributeQueues;
	},

	getPlanAttributeInitializationLoopTimeProperty: function() {
		var initializationData= dojo.getObject("com.ibm.team.repository.web.client.init.InitializationData");
		var initializationTime= 500;
		if (initializationData != null) {
			var planningInitialization= initializationData.get("com.ibm.team.apt.service.planningWebUIInitializer");
			if (planningInitialization != null) {
				initializationTime= planningInitialization["planAttributeInitializationLoopTime"];
			}
		}
		return initializationTime;
	},

	createPlanModel: function(planModelData, attributes, future /*, flags... */ ) {
		var flags= Array.prototype.slice.call(arguments, 3);
		var planModel= new PlanModel(planModelData.planRecord, attributes, this.getPlanAttributeInitializationLoopTimeProperty(), this.fPlanningClient2.getExecutionEnvironment());
		planModel.addCreationListener(dojo.hitch(this, function(itemType) {
			return this.fetchAdditionalAttributesToLoad(planModelData.planType);
		}));
		var initPlanModelCallback= function(result) {
			var createElementCallback= function(result) {
				future.callback(planModel);
			};
			if (planModelData.workItems != null) {
				planModel.createPlanElements(planModelData.workItems, [], Future.newInstance(createElementCallback, future.getErrCallback(), future.getProgressMonitor().child(1, IProgressMonitor.LABEL_NONE)));
			} else {
				future.callback(planModel);
			}
		};
		var planModelProfile= [IPlanItem.PROJECT_AREA, IPlanItem.DIRTY];
		var planElements= [planModel];
		planModel.initialize.apply(planModel, [planModelProfile, planElements, Future.newInstance(initPlanModelCallback, future.getErrCallback(), future.getProgressMonitor().child(1, IProgressMonitor.LABEL_APPEND))].concat(flags));
		planModel.define(IPlanModel.PARENTS_INCLUSION_ATTRIBUTE, !PlanningUtil1.onDemand || planModelData.parentsIncluded);
	},

	fetchAdditionalAttributesToLoad: function(planType) {
		var attributeIdsArr= [];
		attributeIdsArr.push(IPlanItem.DIRTY, IPlanItem.STATUS_REPORT, IPlanItem.PROJECT_AREA);
		if (planType.getCustomIterationAttribute() != null) {
			attributeIdsArr.push(new PlanningAttributeIdentifierImpl(planType.getCustomIterationAttribute()));
		}
		return attributeIdsArr;
	},

	getPlanModelDataRequests: function(planHandle, planViewId, isRefresh) {
		var requests= [];
		if (PlanningUtil1.onDemand) {
			var getPlanRequest= new GetPlanConfigurationRequest(planHandle, isRefresh ? GetPlanConfigurationRequest.REFRESH_FLAGS : GetPlanEditorConfigurationRequest.OPEN_FLAGS);
			var getPlanItemsRequest= new GetPlanItemsRequest(planHandle, planViewId, isRefresh ? GetPlanItemsRequest.REFRESH_FLAGS : GetPlanItemsRequest.OPEN_FLAGS);
			requests.push(getPlanRequest, getPlanItemsRequest);
		} else {
			var getPlanModel2Request= new GetPlanModel2Request(planHandle);
			requests.push(getPlanModel2Request);
		}
		return requests;
	}
});

})();
