/*******************************************************************************
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2007, 2015. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  Use,
 * duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.apt.web.ui.internal.StatusUtil");

dojo.require("com.ibm.jdojo.lang.Exception");
dojo.require("com.ibm.team.apt.api.common.Severity");
dojo.require("dojo.i18n");
dojo.require("dojo.string");

dojo.requireLocalization("com.ibm.team.apt.web.ui.internal", "Messages");

(function() {
var Messages= dojo.i18n.getLocalization("com.ibm.team.apt.web.ui.internal", "Messages");

var Exception= com.ibm.jdojo.lang.Exception;
var Severity= com.ibm.team.apt.api.common.Severity;
var string= dojo.string;

var StatusUtil= dojo.declare("com.ibm.team.apt.web.ui.internal.StatusUtil", null, {
	"-chains-": { constructor: "manual" }
});

StatusUtil.report= function(report) {
	var message= StatusUtil.getMessage(report.infos, report.message);
	return { severity: Severity.ERROR, message: message, exception: new Error(report) };
};
StatusUtil.messageWithoutException= function(severity, report) {
	var message= StatusUtil.getMessage(report.infos, report.message);
	return { severity: severity, message: message, exception: null };
};
StatusUtil.ok= function() {
	return { severity: Severity.NONE, message: null, exception: null };
};
StatusUtil.okWithMessage= function(message) {
	return { severity: Severity.NONE, message: message, exception: null };
};
StatusUtil.messageWithWarning= function(message) {
	return { severity: Severity.WARNING, message: message, exception: null };
};
StatusUtil.error= function(error) {
	if (error instanceof Exception) {
		return { severity: Severity.ERROR, message: string.substitute(Messages.StatusUtil_ERROR, [error.getMessage() ]), exception: error };
	}
	return { severity: Severity.ERROR, message: string.substitute(Messages.StatusUtil_ERROR, [error ]), exception: error };
};
StatusUtil.getMessage= function(reportInfos, operationMessage) {
	var message= "";
	if (reportInfos != null) {
		var $subject= reportInfos;
		var $length= $subject.length;
		for (var $count= 0; $count < $length; $count++){
			var info= $subject[$count];
			message+= string.substitute(Messages.StatusUtil_SUMMARY_DESCRIPTION, [info.summary , info.description]);
		}
	}
	if (message.length === 0) {
		message= operationMessage;
	}
	return message;
};

})();
