/*******************************************************************************
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2013, 2015. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  Use,
 * duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.workitem.web.mvvm.view.queryable.combo.QueryableSection"); //$NON-NLS-1$

dojo.require("com.ibm.team.rtc.foundation.web.ui.util.Sprites"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.util.sprite.ImageSource"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.views.autocomplete.AutoCompleteAction"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.mvvm.view.queryable.combo.NullIndentProvider"); //$NON-NLS-1$
dojo.require("dijit._Templated"); //$NON-NLS-1$
dojo.require("dijit._Widget"); //$NON-NLS-1$

(function() {
var team= com.ibm.team;
var ui= team.rtc.foundation.web.ui;
var util= ui.util;
var Sprites= util.Sprites;
var ImageSource= util.sprite.ImageSource;
var AutoCompleteAction= ui.views.autocomplete.AutoCompleteAction;
var NullIndentProvider= team.workitem.web.mvvm.view.queryable.combo.NullIndentProvider;
var _Templated= dijit._Templated;
var _Widget= dijit._Widget;

dojo.declare("com.ibm.team.workitem.web.mvvm.view.queryable.combo.QueryableSection", [ _Widget, _Templated], { //$NON-NLS-1$

	templatePath: dojo.moduleUrl("com.ibm.team.workitem.web", "mvvm/view/queryable/combo/template/QueryableSection.html"), //$NON-NLS-1$ //$NON-NLS-2$

	//_sectionTitle: null,

	//_statusMessage: null,

	//_container: null,

	//_elements: null,

	//_title: null,

	//_indentProvider: null,

	constructor: function(params, node) {
		this._elements= [];
		this._title= params.sectionHeader;
		this._indentProvider= params.indentProvider;
		this._addIsShownListener(params.isShown);
	},

	postCreate: function() {
		this.inherited("postCreate", arguments, []); //$NON-NLS-1$
		if (this._title != null) {
			this._sectionTitle.appendChild(dojo.doc.createTextNode(this._title));
		}
	},

	element: function(index) {
		return this._elements[index];
	},

	elements: function() {
		return this._elements;
	},

	renderValues: function(message, values) {
		this._destroyListElements();
		var showSection= values.length > 0 || message != null;
		var showMessage= message != null && values.length === 0;
		dojo.toggleClass(this.domNode, "Empty", !showSection); //$NON-NLS-1$
		dojo.place(dojo.doc.createTextNode(showMessage ? message : ""), this._statusMessage, 'only'); //$NON-NLS-1$ //$NON-NLS-2$
		if (showSection) {
			var fragment= dojo.doc.createDocumentFragment();
			var $subject= values;
			var $length= $subject.length;
			for (var $count= 0; $count < $length; $count++){
				var action= $subject[$count];
				var elem= new QueryableElement({action: action, indentProvider: this._indentProvider}, null);
				fragment.appendChild(elem.domNode);
				this._elements.push(elem);
			}
			dojo.place(fragment, this._container, 'only'); //$NON-NLS-1$
		}
	},

	_destroyListElements: function() {
		var $subject2= this._elements;
		var $length2= $subject2.length;
		for (var $count2= 0; $count2 < $length2; $count2++){
			var listElement= $subject2[$count2];
			listElement.destroy(false);
		}
		this._elements.splice(0, this._elements.length);
		if (this._container != null) {
			dojo.empty(this._container);
		}
	},

	_addIsShownListener: function(isShown) {
		if (isShown == null) {
			return ;
		}
		isShown.addListener(dojo.hitch(this, function(shown) {
			if (shown) {
				var $subject3= this._elements;
				var $length3= $subject3.length;
				for (var $count3= 0; $count3 < $length3; $count3++){
					var element= $subject3[$count3];
					element._onElementShowing();
				}
			}
		}));
	},

	destroy: function(preserveDom) {
		this._destroyListElements();
		this.inherited("destroy", arguments, [preserveDom]); //$NON-NLS-1$
	}
});
var QueryableElement= dojo.declare("com.ibm.team.workitem.web.mvvm.view.queryable.combo.QueryableSection.QueryableElement", [ _Widget, _Templated], { //$NON-NLS-1$

	templatePath: dojo.moduleUrl("com.ibm.team.workitem.web", "mvvm/view/queryable/combo/template/QueryableElement.html"), //$NON-NLS-1$ //$NON-NLS-2$

	//_prefixValue: null,

	//_icon: null,

	//_entry: null,

	//action: null,

	constructor: function(params, node) {
		this.action= params.action;
		this._prefixValue= this._computeIndent(params.indentProvider != null ? params.indentProvider : new NullIndentProvider(), this.action);
	},

	postCreate: function() {
		this.inherited("postCreate", arguments, []); //$NON-NLS-1$
		dojo.place(dojo.doc.createTextNode(this.action.getLabel()), this._entry, 'only'); //$NON-NLS-1$
		AutoCompleteAction.highlight(this._entry, this.action);
		if (this.action.iconUrl != null) {
			dojo.addClass(this._icon, Sprites.cssClassName(ImageSource.fromIconUri(this.action.iconUrl)));
		}
	},

	select: function(hover) {
		dojo.toggleClass(this.domNode, "Hover", hover); //$NON-NLS-1$
		if (hover) {
			dijit.scrollIntoView(this.domNode);
		}
	},

	_computeIndent: function(indentProvider, action) {
		var indent= new Array(indentProvider.getIndent(action) + 1).join(QueryableElement.INDENT_SPACE);
		indent+= action.isParent() ? QueryableElement.PARENT_ELEMENT_PREFIX : QueryableElement.INDENT_SPACE;
		return indent;
	},

	_onElementShowing: function() {
		this._addTitleIfNecessary();
	},

	_addTitleIfNecessary: function() {
		if (this.domNode.offsetWidth < this.domNode.scrollWidth) {
			this._entry.title= this.action.getLabel();
		}
	}
});

QueryableElement.PARENT_ELEMENT_PREFIX= "&#9660;"; //$NON-NLS-1$
QueryableElement.INDENT_SPACE= "&nbsp;&nbsp;&nbsp;&nbsp;"; //$NON-NLS-1$

})();
